<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');
$translator->addTranslation('articles');

// define some vars
initVar($_POST['usergroup'],array());
initVar($_SESSION['SID_articles_select_nr'],NULL);
initVar($System_release,NULL);

// use rubric_id from session
if (isset($_SESSION['SID_rubric_id'])) {
    $cpoRubric['id'] = $_SESSION['SID_rubric_id'];
}

if (empty($_SESSION['SID_pagers']['articlesPerPage'])) {
    $_SESSION['SID_pagers']['articlesPerPage'] = $cpoSystem['noOfArticles'];
}

if (!isset($_SESSION['filter_articles'])) {
    $_SESSION['filter_articles'] = array(
        'enabled' => false,
        'phrase' => '',
    );
}

if (empty($_SESSION['SID_articles_select_nr'])) {
    $_SESSION['SID_articles_select_nr'] = false;
}
require(CPO_BASEDIR.'_include/var_category.php');
require(CPO_BASEDIR.'_include/check.php');

$views = array('list');

// Mod_editor *******************************************************************************************
if (array_key_exists('Editor',$activeModules)) include(CPO_BASEDIR.'mod_editor/CPO/'.basename(__FILE__));
// Mod_editor *******************************************************************************************

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);
while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'articles_pastebefore':
        $sortBefore = $_GET['nr'];
        if (empty($sortBefore)) break;
        
        $toSortNr = $_SESSION['SID_articles_select_nr'];
        if (!empty($_GET['which'])) $toSortNr = $_GET['which'];
        unset($_SESSION['SID_articles_select_nr']);

        $db = new DB;
        $db->query('SELECT nr, rubric_id, sort_id FROM ' . CPO_NEWS . ' ' .
            'WHERE nr=' . addslashes($sortBefore) . ' ' .
            'OR nr=' . addslashes($toSortNr)
        );
        if ($db->num_rows()!=2) break;
        $sortBeforeId = null;
        $toSortId     = null;
        $rubricId     = null;
        while ($db->next_record()) {
            if ($db->v('nr')==$sortBefore) $sortBeforeId = $db->v('sort_id');
            if ($db->v('nr')==$toSortNr)   $toSortId     = $db->v('sort_id');
            $rubricId = $db->v('rubric_id');
        }
        if ($sortBeforeId>$toSortId) {
            $query = 'UPDATE ' . CPO_NEWS . ' SET sort_id=sort_id-1 ' .
                     'WHERE rubric_id=' . $rubricId . ' ' .
                     'AND artikel_archiv=0 ' .
                     'AND sort_id>'  . addslashes($toSortId) . ' ' .
                     'AND sort_id<=' . addslashes($sortBeforeId);
            $db->query($query);
            $query = 'UPDATE ' . CPO_NEWS .' SET sort_id= ' . addslashes($sortBeforeId) . ' ' .
                     'WHERE nr=' . addslashes($toSortNr);
            $db->query($query);
        }
        if ($sortBeforeId<$toSortId) {
            $query = 'UPDATE ' . CPO_NEWS . ' SET sort_id=sort_id+1 ' .
                     'WHERE rubric_id=' . $rubricId . ' ' .
                     'AND artikel_archiv=0 ' .
                     'AND sort_id>' . addslashes($sortBeforeId) . ' ' .
                     'AND sort_id<' . addslashes($toSortId);
            $db->query($query);
            $query = 'UPDATE ' . CPO_NEWS .' SET sort_id= ' . addslashes($sortBeforeId+1) . ' ' .
                     'WHERE nr=' . addslashes($toSortNr);
            $db->query($query);
        }
        break;
    case 'articles_pasteafter':
        $db = new DB;
        $sortAfter = $_GET['nr'];
        if (empty($sortAfter)) break;

        $toSortNr = $_SESSION['SID_articles_select_nr'];
        if (!empty($_GET['which'])) $toSortNr = $_GET['which'];
        unset($_SESSION['SID_articles_select_nr']);
        
        $db->query('SELECT nr, rubric_id, sort_id FROM ' . CPO_NEWS . ' ' .
            'WHERE nr=' . addslashes($sortAfter) . ' ' .
            'OR nr=' . addslashes($toSortNr)
        );
        if ($db->num_rows()!=2) break;
        $sortBeforeId = null;
        $toSortId     = null;
        $rubricId     = null;
        while ($db->next_record()) {
            if ($db->v('nr')==$sortAfter) $sortAfterId = $db->v('sort_id');
            if ($db->v('nr')==$toSortNr)  $toSortId    = $db->v('sort_id');
            $rubricId = $db->v('rubric_id');
        }
        if ($sortAfterId>$toSortId) {
            $query = 'UPDATE ' . CPO_NEWS . ' SET sort_id=sort_id-1 ' .
                     'WHERE rubric_id=' . $rubricId . ' ' .
                     'AND sort_id>' . addslashes($toSortId) . ' ' .
                     'AND sort_id<' . addslashes($sortAfterId);
            $db->query($query);
            $query = 'UPDATE ' . CPO_NEWS .' SET sort_id= ' . addslashes($sortAfterId-1) . ' ' .
                     'WHERE nr=' . addslashes($toSortId);
            $db->query($query);
        }
        if ($sortAfterId<$toSortId) {
            $query = 'UPDATE ' . CPO_NEWS . ' SET sort_id=sort_id+1 ' .
                     'WHERE rubric_id=' . $rubricId . ' ' .
                     'AND sort_id>=' . addslashes($sortAfterId) . ' ' .
                     'AND sort_id<'  . addslashes($toSortId);
            $db->query($query);
            $query = 'UPDATE ' . CPO_NEWS .' SET sort_id= ' . addslashes($sortAfterId) . ' ' .
                     'WHERE nr=' . addslashes($toSortNr);
            $db->query($query);
        }

        break;
    case 'articles_status': // {{{ articles_status_versions, articles_status_release
    case 'articles_status_versions':
        if ($_SESSION['SID_stufe4']!=1) {
            $message[] = ___('Sorry, you are not allowed to edit the status of an article.');
            break;
        }
    case 'articles_status_release': // for the "articles release" view
        switch ($nextaction) {
        case 'articles_status':          $views = array('reject'); break;
        case 'articles_status_versions': $views = array('reject_versions'); break;
        case 'articles_status_release':  $views = array('reject_release'); break;
        }
        
        $db = new DB;
        $query = 'SELECT article_nr, titel, autor, email, name '
                .'FROM '.CPO_NEWS.', '.CPO_RUBRIC.' '
                .'WHERE rubric_id = '.CPO_RUBRIC.'.id '
                ."AND nr='".addslashes($_REQUEST['nr'])."'";
        $db->query($query);
        $db->next_record();
        $article_nr = $db->v('article_nr');
        $titel      = $db->v('titel');
        $autor      = $db->v('autor');
        $email      = $db->v('email');
        $rubric     = $db->v('name');

        if ($_REQUEST['status']==STATE_REJECTED && isset($_REQUEST['sendmessage']) && !$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('reject article', 'CSRF check failed.');
            break;
        }

        if ($_REQUEST['status']==STATE_REJECTED && !isset($_REQUEST['sendmessage'])) {
            break;
        }

        $query = 'UPDATE '.CPO_NEWS.' SET '
                ."freigabe='".addslashes($_REQUEST['status'])."', "
                ."released_user_id='".addslashes($_SESSION['SID_user']['id'])."', "
                ."release_date='".addslashes(date('Y-m-d H:i:s', time()))."' "
                ."WHERE nr='".addslashes($_REQUEST['nr'])."'";
        $db->query($query);

        if ($_REQUEST['status']==STATE_RELEASED) {
           $query = 'UPDATE '.CPO_NEWS.' SET '
                   ."artikel_archiv=5 "
                   ."WHERE article_nr=".$article_nr." "
                   ."AND artikel_archiv>0";
           $db->query($query);
        }

        $m = '';
        switch ($_REQUEST['status']) {
        case STATE_RELEASED:
            $message[] = sprintf(___('The article %s got released.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            logaction('release article', $_REQUEST['nr'].': '.$titel);
            break;
        case STATE_BLOCKED:
            $message[] = sprintf(___('The article %s got blocked.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            logaction('block article', $_REQUEST['nr'].': '.$titel);
            break;
        case STATE_REJECTED:
            $message[] = sprintf(___('The article %s got rejected.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            if (isset($_REQUEST['sendmessageyes'])) {
                ini_set('sendmail_from', $cpoSystem['system_email']);
                mail($email, $_REQUEST['subject'], wordwrap($_REQUEST['body']), 'FROM: '.$cpoSystem['system_email']);
                ini_restore('sendmail_from');
                $message[] = sprintf(___('A message was sent to the author %s <%s>.'), $autor, $email);
            } else {
                $message[] = sprintf(___('No message was sent to the author %s <%s>.'), $autor, $email);
            }

            logaction('reject article', $_REQUEST['nr'].': '.$titel);
            break;
        }
        switch ($nextaction) {
        case 'articles_status_versions':
            $views = array('list_versions');
            $_POST['nr'] = $article_nr;
            break;
        case 'articles_status_release':
            $views = array('list_release');
            break;
        default:
            $views = array('list');
            break;
        }
        break;
        // }}}
    case 'articles_create': // {{{
        //$_POST['nr']          = '';
        //$_POST['article_nr']  = '';
        //$_POST['auth']        = '';
        //$_POST['sort_id']     = '';
        //$_POST['freigabe']    = '';
        $_POST['datum']       = date('Y-m-d H:i:s');
        $_POST['content']     = array();
        $_POST['rubric_id']     = $_SESSION['SID_rubric_id'];
        $views = array('edit_form');
        break;
        // }}}
    case 'articles_modify': // {{{
        $db = new DB;
        $query = "SELECT user_id, name, user, admin "
                ."FROM ".CPO_BLOCK.", ".CPO_LOG_LOGIN.", ".CPO_USER." "
                ."WHERE log_login_id = ".CPO_LOG_LOGIN.".id "
                ."AND user_id=".CPO_USER.".id "
                ."AND news_nr=".(int)$_REQUEST['nr']." "; 
        $db->query($query);
               
        // blocked
        if ($db->next_record()) {
            if ($db->v('user_id')==$_SESSION['SID_user']['id'] || $_SESSION['SID_user']['admin']>$db->v('admin')) {
                array_unshift($actions, 'articles_unlock');
                break;
            }
            $message[] = htmlspecialchars('The article is already in use.', ENT_COMPAT, 'ISO-8859-15');
            $views = array('list');
            break;
        } 


        // lock article for other editors
        $query = "INSERT INTO ".CPO_BLOCK." VALUES ("
                ."'', "
                ."'".addslashes($_REQUEST['nr'])."', "
                ."'".(date('Y-m-d H:i:s', time()))."', "
                ."'".$_SESSION['SID_log_login_id']."') ";
        $db->query($query); 

        $query = "SELECT rubric_id, nr, idx, auth, keywords, commentary, titel, templates_id, datum, verfallsdatum, pub_datum, autor, email, initial, freigabe, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_GET['nr'])."' ";
        $db = new DB;
        $db->query($query);
        $db->next_record();
            
        $_POST['idx']           = $db->v('idx')=='zzzzzzzz' ? '' : $db->v('idx');
        $_POST['nr']            = $db->v('nr');
        $_POST['auth']          = $db->v('auth');               
        $_POST['keywords']      = $db->v('keywords');         
        $_POST['commentary']    = $db->v('commentary');         
        $_POST['titel']         = $db->v('titel'); 
        $_POST['templates_id']  = $db->v('templates_id');           
        $_POST['verfallsdatum'] = $db->v('verfallsdatum');      
        $_POST['datum']         = $db->v('datum');          
        $_POST['pub_datum']     = $db->v('pub_datum');          
        $_POST['autor']         = $db->v('autor'); 
        $_POST['email']         = $db->v('email');              
        $_POST['initial']       = $db->v('initial');           
        $_POST['freigabe']      = $db->v('freigabe');           
        $_POST['sort_id']       = $db->v('sort_id');
        $_POST['rubric_id']     = $db->v('rubric_id');

        $_POST['content'] = array();

        // Images 
        $query = "SELECT ".CPO_CONTENT_IMAGES.".id, fieldname, image_id, rubric_id "
                ."FROM ".CPO_CONTENT_IMAGES.", " . CPO_DATA . " "
                ."WHERE image_id=" . CPO_DATA . '.id '
                ."AND article_id='".$_POST['nr']."'";
        $db_form = new DB;
        $db_form->query($query);
        while ($db_form->next_record()) {
            if ($db_form->v('rubric_id')!=-1 && $db_form->v('rubric_id') != $_POST['rubric_id']) {
                $message['notAllowedImagesUsed'] = ___('At least one used image is not allowed in this rubric. You might want to choose a different image.');
            }
            $_POST['content'][$db_form->v('fieldname').' (image)'] = array(
                'type'    => 'image',
                'name'    => $db_form->v('fieldname'),
                'id'      => $db_form->v('id'),
                'image_id'=> $db_form->v('image_id')
            );
        }

        // Files 
        $query = "SELECT ".CPO_CONTENT_FILES.".id, fieldname, file_id, rubric_id "
                ."FROM ".CPO_CONTENT_FILES.", " . CPO_DATA . " "
                ."WHERE file_id=" . CPO_DATA . ".id "
                ."AND article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            if ($db_form->v('rubric_id')!=-1 && $db_form->v('rubric_id') != $_POST['rubric_id']) {
                $message['notAllowedFilesUsed'] = ___('At least one used file is not allowed in this rubric. You might want to choose a different file.');
            }
            $_POST['content'][$db_form->v('fieldname').' (file)'] = array(
                'type'   => 'file',
                'name'   => $db_form->v('fieldname'),
                'id'     => $db_form->v('id'),
                'file_id'=> $db_form->v('file_id')
            );
        }

        // Texts 
        $query = "SELECT id, fieldname, text "
                ."FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (text)'] = array(
                'type' => 'text',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'text' => $db_form->v('text')
            );
        }

        // HTMLs 
        $query = "SELECT id, fieldname, html "
                ."FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (html)'] = array(
                'type' => 'html',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'html' => $db_form->v('html')
            );
        }

        // URLs 
        $query = "SELECT id, fieldname, url, urltext, urltarget "
                ."FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (url)'] = array(
                'type'      => 'url',
                'name'      => $db_form->v('fieldname'),
                'id'        => $db_form->v('id'),
                'url'       => $db_form->v('url'),
                'urltext'   => $db_form->v('urltext'),
                'urltarget' => $db_form->v('urltarget')
            );
        } 

        $views = array('edit_form');
        
        break;
        // }}}
    case 'articles_copy': // {{{
        $_POST['copy'] = true;

        $query = "SELECT rubric_id, nr, idx, auth, keywords, commentary, titel, templates_id, datum, verfallsdatum, pub_datum, autor, email, initial, freigabe, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_GET['nr'])."' ";
        $db = new DB;
        $db->query($query);
        $db->next_record();
            
        $_POST['idx']           = $db->v('idx')=='zzzzzzzz' ? '' : $db->v('idx');
        $_POST['nr']            = $db->v('nr');
        $_POST['auth']          = $db->v('auth');               
        $_POST['keywords']      = $db->v('keywords');         
        $_POST['commentary']    = $db->v('commentary');         
        $titel = $db->v('titel');
        $_POST['titel']         = sprintf(__('Copy of %s'), $db->v('titel'));
        $_POST['templates_id']  = $db->v('templates_id');           
        $_POST['verfallsdatum'] = $db->v('verfallsdatum');      
        $_POST['datum']         = $db->v('datum');          
        $_POST['pub_datum']     = $db->v('pub_datum');          
        $_POST['autor']         = $db->v('autor'); 
        $_POST['email']         = $db->v('email');              
        $_POST['initial']       = $db->v('initial');           
        $_POST['freigabe']      = $db->v('freigabe');           
        $_POST['sort_id']       = $db->v('sort_id');
        $_POST['rubric_id']     = $db->v('rubric_id');

        $_POST['content'] = array();

        // Images 
        $query = "SELECT id, fieldname, image_id "
                ."FROM ".CPO_CONTENT_IMAGES." "
                ."WHERE article_id='".$_POST['nr']."'";
        $db_form = new DB;
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (image)'] = array(
                'type'    => 'image',
                'name'    => $db_form->v('fieldname'),
                'id'      => $db_form->v('id'),
                'image_id'=> $db_form->v('image_id')
            );
        }

        // Files 
        $query = "SELECT id, fieldname, file_id "
                ."FROM ".CPO_CONTENT_FILES." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (file)'] = array(
                'type'   => 'file',
                'name'   => $db_form->v('fieldname'),
                'id'     => $db_form->v('id'),
                'file_id'=> $db_form->v('file_id')
            );
        }

        // Texts 
        $query = "SELECT id, fieldname, text "
                ."FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (text)'] = array(
                'type' => 'text',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'text' => $db_form->v('text')
            );
        }

        // HTMLs 
        $query = "SELECT id, fieldname, html "
                ."FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (html)'] = array(
                'type' => 'html',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'html' => $db_form->v('html')
            );
        }

        // URLs 
        $query = "SELECT id, fieldname, url, urltext, urltarget "
                ."FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id=".$_POST['nr'];
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (url)'] = array(
                'type'      => 'url',
                'name'      => $db_form->v('fieldname'),
                'id'        => $db_form->v('id'),
                'url'       => $db_form->v('url'),
                'urltext'   => $db_form->v('urltext'),
                'urltarget' => $db_form->v('urltarget')
            );
        } 

        // create "new" article
        $_POST['nr'] = 0; // $db->v('nr');

        $views = array('edit_form');
        
        break;
        // }}}
    case 'articles_delete': // {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $views = array('reallydelete');
        break;
    // }}}

    // https://community.conpresso4.de/viewtopic.php?p=17955#p17955
    case 'articles_archive': // instant expire {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET verfallsdatum = '".date('Y-m-d H:i:s')."' "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        logaction('expire article', $_GET['nr'].': '.$titel);
        $views = array('list');
        break;
    // }}}
    case 'articles_republish': // republish {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET verfallsdatum = '2036-01-01 00:00:00' "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $views = array('list');
        logaction('republish article', $_GET['nr'].': '.$titel);
        break;
    // }}}
    case 'articles_publish': // publish NOW! (minus 1 second for display) {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET pub_datum = '".date('Y-m-d H:i:s', strtotime( '-1 second' ))."' "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        logaction('forced publish article', $_GET['nr'].': '.$titel);
        $views = array('list');
        break;
    // }}}

    case 'articles_delete_really': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete article', 'CSRF check failed.');
            break;
        }
        
        if ($_SESSION['SID_stufe2']!=1) {
            $message[] = ___('Sorry, you are not allowed to delete an article.');
            break;
        }

        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The article %s was not deleted.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            break;
        }

        // article gets marked as deleted (but not really deleted!
        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET artikel_archiv=5 "
                  ."WHERE artikel_archiv=1 "
                  ."AND article_nr='".addslashes($_POST['nr'])."'"); // FIXME article_nr should always be equal to nr - edited, check if true

        $db->query("UPDATE ".CPO_NEWS." "
                  ."SET artikel_archiv=9 "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");

        $message[] = sprintf(___('The article %s was successfully deleted.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');

        if ($_POST['nr']==$_SESSION['SID_articles_select_nr']) {
            unset($_SESSION['SID_articles_select_nr']);
        }

        logaction('delete article', $_POST['nr'].': '.$titel);
        break;
    // }}}
    case 'articles_save': // {{{
        require(CPO_BASEDIR.'_include/check_edit.php');

        if (isset($_POST['displayAgain']) && isset($_POST['clearOldContent']) && $_POST['clearOldContent']=='yes') {
            //print_r($_POST['content']);
            // clear old article content
            // first find the unused form fields, then unset POST-content w/o placeholder
            // fetch placeholders to list them
            $q = "SELECT id, ttype, fieldname, pos, ddata FROM ".CPO_PLACEHOLDERS." "
                ."WHERE templates_id='".addslashes($_POST['templates_id'])."' "
                ."ORDER BY pos";
            $dbq = new DB;
            DEBUG(1, $q, __FILE__, __LINE__);
            $dbq->query($q);

            $placeholder = array();
            while($dbq->next_record()) {
                $phname = $dbq->v('fieldname').' ('.$typeNames[$dbq->v('ttype')].')';
                $placeholder[$phname]  = $dbq->v('fieldname');
            }
            //print_r($placeholder);
            foreach ($_POST['content'] AS $key=>$value) {
                // unset POST-content w/o placeholder
                if(!array_key_exists($key,$placeholder)) {
                    $message[] = sprintf(__('Clearing <em>%s</em> ...'), $key);
                    unset ($_POST['content'][$key]);
                }
            }

            
            $message[] = __('Old article content was cleared!');
            $message[] = __('Please continue editing and saving the article.');
        }

        if (isset($_POST['displayAgain']) || $fehler) {
            $views = array('edit_form');
            break;
        }
        
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('save article', 'CSRF check failed.');
            $views = array('edit_form');
            break;
        }

        $data = array();
        if (empty($_POST['rubric_id'])) $_POST['rubric_id'] = $_SESSION['SID_rubric_id'];
        $data['rubric_id']     = $_POST['rubric_id'];
        $data['titel']         = $_POST['titel'];
        $data['templates_id']  = $_POST['templates_id'];
        $data['autor']         = $_POST['autor'];
        $data['idx']           = $_POST['idx'];
        $data['keywords']      = $_POST['keywords'];
        $data['commentary']    = $_POST['commentary'];
        $data['verfallsdatum'] = $_POST['verfallsdatum'];
        $data['datum']         = $_POST['datum'];
        $data['pub_datum']     = $_POST['pub_datum'];
        $data['email']         = $_POST['email'];
        $data['initial']       = $_POST['initial'];
        $data['changedBy']     = $_SESSION['SID_login'];
        $data['content']       = $_POST['content'];

        $data['nr']            = $_POST['nr'];
        $data['sort_id']       = $_POST['sort_id'];
        $data['releasedby']    = '';
        $logrelease = '';
        if (!empty($_POST['article_free'])) {
            $data['releasedby'] = $_SESSION['SID_user']['id'];
            $logrelease = ' and release';
        }
        if (is_array($_POST['usergroup']))  $data['usergroup']  = $_POST['usergroup']; // auth

		// Instant upload **********************************************************************************************
        if (file_exists(CPO_BASEDIR.'mod_instantupload/i_file_upload.php')) require(CPO_BASEDIR.'mod_instantupload/i_file_upload.php');
		// Instant upload **********************************************************************************************

        $nr = save_article($data);

		// Artikelcache **********************************************************************************************
		if(array_key_exists('Cache', $activeModules))  include(CPO_BASEDIR.$activeModules['Cache']['directory'].'/i_cache.php');
 		// Artikelcache **********************************************************************************************

        $message[] = sprintf(___('The article %s was successfully saved.'), '<em>'.htmlspecialchars($_POST['titel'], ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('save'.$logrelease.' article', $nr.': '.$_POST['titel']); // use $nr since $nr is available when saving

		// mod_form remail **********************************************************************************************
		if (isset($_POST['saveAndMail']) && isset($_POST['remailDir']) && trim($_POST['remailDir']) != '') {
	        require(CPO_BASEDIR.$_POST['remailDir'].'/includes/remail.inc.php');
        }
		// mod_form remail **********************************************************************************************
        break; // }}}
    case 'articles_move': // {{{
        if (empty($_GET['nr'])) break;

        $_POST['nr'] = $_GET['nr'];

        $views = array('move');
        break; // }}}
    case 'articles_moveto': // {{{
        $query = "SELECT titel FROM ".CPO_NEWS." "
                ."WHERE nr='".$_POST['nr']."'";
        $db->query($query);
        $db->next_record();
        $artikel_titel = $db->v('titel');

        if (isset($_POST['cancel'])) {
            $message[] = sprintf(___('The article %s was not moved.'), '<em>'.htmlspecialchars($artikel_titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            break;
        }

        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('move article', 'CSRF check failed.');
            break;
        }
        
        $db = new DB;
        if ($_POST['move_target']=='') break;

        // fetch used template
        $query = "SELECT templates_id FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_POST['nr'])."'";
        $db->query($query);
        $db->next_record();
        $templates_id = $db->v('templates_id');

        // find the rubric id for the new rubrics settings
        $query = "SELECT source_rubric_id FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($_POST['move_target'])."'";
        $db->query($query);
        $db->next_record();
        $templates_rubric = $_POST['move_target'];
        if ($db->v('source_rubric_id')!=0) {
            $templates_rubric = $db->v('source_rubric_id');
        }

        // is the actual templates_id allowed in the new rubric?
        $query = "SELECT COUNT(*) FROM ".CPO_TPL_ASSIGNMENT." "
                ."WHERE templates_id='".addslashes($templates_id)."' "
                ."AND rubric_id='".addslashes($templates_rubric)."'";
        $db->query($query);
        $db->next_record();

        if ($db->v('COUNT(*)')<=0) {  
            $message[] = ___('The actual article-template of the article is not allowed in the new rubric. You might want to choose a different article-template.');
        }

        $query = "UPDATE ".CPO_NEWS." SET "
                ."rubric_id = '".addslashes($_POST['move_target'])."' "
                ."WHERE article_nr='".addslashes($_POST['nr'])."'";
        $db->query($query); 

        $query = "SELECT name FROM ".CPO_RUBRIC." "
                ."WHERE id='".$_POST['move_target']."'";
        $db->query($query);
        $db->next_record();
        $move_target_name = $db->v('name');

        $message[] = sprintf(___('The article %s was successfully moved to rubric %s.'), 
            '<em>'.htmlspecialchars($artikel_titel, ENT_COMPAT, 'ISO-8859-15').'</em> ',
            '<em>'.htmlspecialchars($move_target_name, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('move article', $_POST['nr'].': '.$artikel_titel.' -> '.$_POST['move_target'].' '.$move_target_name);

        break;
        // }}}
    case 'articles_versions': // {{{
        if (empty($_GET['nr'])) break;

        $_POST['nr'] = $_GET['nr'];

        $views = array('list_versions');
        break; // }}}
    case 'articles_versions_delete': // {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $views = array('articles_version_reallydelete');
        break;
    // }}}
    case 'articles_versions_deletereally': //  {{{
        //$_POST['nr'] = $_GET['nr'];
        $views = array('list_versions');
        
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete article version', 'CSRF check failed.');
            break;
        }
        
        $query = 'SELECT titel, article_nr '
                .'FROM '.CPO_NEWS.' '
                .'WHERE nr='.(int)$_POST['nr'];
        $db = new DB;
        $db->query($query);
        $db->next_record();
        $titel = $db->v('titel');
        $article_nr  = $db->v('article_nr');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The article version %s was not deleted.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            $_POST['nr'] = $article_nr;
            break;
        }

        $query_del = "DELETE FROM ".CPO_CONTENT_FILES." "
                    ."WHERE article_id='".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_HTML." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_IMAGES." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_TEXT." WHERE "
                    ."article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_CONTENT_URLS." "
                    ."WHERE article_id = '".addslashes($_POST['nr'])."'";
        $db->query($query_del); 

        $query_del = "DELETE FROM ".CPO_NEWS." "
                    ."WHERE nr='".$_POST['nr']."'";
        $db->query($query_del); 

        $message[] = sprintf(___('The article version %s was deleted successfully.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('delete article version', $_POST['nr'].': '.$titel);

        $_POST['nr'] = $article_nr;
        $views = array('list_versions');
        break; // }}}
    case 'articles_versions_restore': // {{{
        //$_POST['copy'] = true;

        $query = "SELECT rubric_id, article_nr, idx, auth, keywords, commentary, titel, templates_id, datum, verfallsdatum, pub_datum, autor, email, initial, freigabe, sort_id "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_GET['version_nr'])."' ";
        $db = new DB;
        $db->query($query);
        $db->next_record();

        $_POST['idx']           = $db->v('idx')=='zzzzzzzz' ? '' : $db->v('idx');
        $_POST['nr']            = $db->v('article_nr');
        $_POST['auth']          = $db->v('auth');
        $_POST['keywords']      = $db->v('keywords');
        $_POST['commentary']    = $db->v('commentary');
        $titel = $db->v('titel');
        $_POST['titel']         = $db->v('titel');
        $_POST['templates_id']  = $db->v('templates_id');
        $_POST['verfallsdatum'] = $db->v('verfallsdatum');
        $_POST['datum']         = $db->v('datum');
        $_POST['pub_datum']     = $db->v('pub_datum');
        $_POST['autor']         = $db->v('autor');
        $_POST['email']         = $db->v('email');
        $_POST['initial']       = $db->v('initial');
        $_POST['freigabe']      = $db->v('freigabe');
        $_POST['sort_id']       = $db->v('sort_id');
        $_POST['rubric_id']     = $db->v('rubric_id');

        $_POST['content'] = array();

        // Images
        $query = "SELECT id, fieldname, image_id "
                ."FROM ".CPO_CONTENT_IMAGES." "
                ."WHERE article_id='".addslashes($_GET['version_nr'])."'";
        $db_form = new DB;
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (image)'] = array(
                'type'    => 'image',
                'name'    => $db_form->v('fieldname'),
                'id'      => $db_form->v('id'),
                'image_id'=> $db_form->v('image_id')
            );
        }

        // Files
        $query = "SELECT id, fieldname, file_id "
                ."FROM ".CPO_CONTENT_FILES." "
                ."WHERE article_id=".addslashes($_GET['version_nr']);
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (file)'] = array(
                'type'   => 'file',
                'name'   => $db_form->v('fieldname'),
                'id'     => $db_form->v('id'),
                'file_id'=> $db_form->v('file_id')
            );
        }

        // Texts
        $query = "SELECT id, fieldname, text "
                ."FROM ".CPO_CONTENT_TEXT." "
                ."WHERE article_id=".addslashes($_GET['version_nr']);
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (text)'] = array(
                'type' => 'text',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'text' => $db_form->v('text')
            );
        }

        // HTMLs
        $query = "SELECT id, fieldname, html "
                ."FROM ".CPO_CONTENT_HTML." "
                ."WHERE article_id=".addslashes($_GET['version_nr']);
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (html)'] = array(
                'type' => 'html',
                'name' => $db_form->v('fieldname'),
                'id'   => $db_form->v('id'),
                'html' => $db_form->v('html')
            );
        }

        // URLs
        $query = "SELECT id, fieldname, url, urltext, urltarget "
                ."FROM ".CPO_CONTENT_URLS." "
                ."WHERE article_id=".addslashes($_GET['version_nr']);
        $db_form->query($query);
        while ($db_form->next_record()) {
            $_POST['content'][$db_form->v('fieldname').' (url)'] = array(
                'type'      => 'url',
                'name'      => $db_form->v('fieldname'),
                'id'        => $db_form->v('id'),
                'url'       => $db_form->v('url'),
                'urltext'   => $db_form->v('urltext'),
                'urltarget' => $db_form->v('urltarget')
            );
        }

        $views = array('edit_form');

////////////////////////////////
        //logaction('restore article version', $archive_article_nr.': '.$archive_titel);

        break; // }}}
    case 'articles_release': // {{{
        $views = array('list_release');
        break; // }}}
    case 'articles_unlock': // {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');

        $query = "SELECT user_id, name, user, create_date "
                ."FROM ".CPO_BLOCK.", ".CPO_LOG_LOGIN.", ".CPO_USER." "
                ."WHERE log_login_id = ".CPO_LOG_LOGIN.".id "
                ."AND user_id=".CPO_USER.".id "
                ."AND news_nr=".(int)$_GET['nr']; 
        $db->query($query);
        if ($db->next_record()) {
            $name = $db->v('name');
            $user = $db->v('user');
            $user_id = $db->v('user_id');
            $date = $db->v('create_date');
            $views = array('reallyunlock');
            break;
        }

        // article is unlocked already - FIXME directly edit it?

        break;
        // }}}
    case 'articles_unlock_really': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('unlock article', 'CSRF check failed.');
            break;
        }

        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The article %s was not unlocked.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            break;
        }

        $db->query("DELETE FROM ".CPO_BLOCK." "
                  ."WHERE news_nr='".addslashes($_POST['nr'])."' ");
        $message[] = sprintf(___('Unlocked article %s.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
        $views = array('list');
        break;
        // }}}

    case 'articles_restore': // {{{
        $views = array('restorearticles');
        break; // }}}
    case 'articles_do_restore': // {{{
        $views = array('restorearticles');

        $query = "SELECT titel "
                ."FROM ".CPO_NEWS." WHERE nr = '".(int)$_REQUEST['nr']."'";
        $db = new DB;
        $db->query($query);

        $db->next_record();
        $titel = $db->v("titel");          

        if ( $System_release == 1 ) {
            $query = "UPDATE ".CPO_NEWS." SET artikel_archiv = 0, freigabe = 1, changer = '".$_SESSION['SID_login']."' WHERE nr = '".(int)$_REQUEST['nr']."'";
        } else {
            $query = "UPDATE ".CPO_NEWS." SET artikel_archiv = 0, freigabe = 2, changer = '".$_SESSION['SID_login']."' WHERE nr = '".(int)$_REQUEST['nr']."'";
        }
        $db->query($query); 

        $message[] = sprintf(___('The article %s was successfully restored.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('restore article', $titel);

        break; // }}}
    case 'articles_purge': // {{{
        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_GET['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');
        $views = array('reallypurge');
        break;
    // }}}
    case 'articles_purge_really': // {{{
        $views = array('restorearticles');
        
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('purge article', 'CSRF check failed.');
            break;
        }

        if ($_SESSION['SID_stufe2']!=1) {
            $message[] = ___('Sorry, you are not allowed to delete an article.');
            break;
        }

        $db = new DB;
        $db->query("SELECT titel "
                  ."FROM ".CPO_NEWS." "
                  ."WHERE nr='".addslashes($_POST['nr'])."'");
        $db->next_record();
        $titel = $db->v('titel');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The article %s was not purged.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');
            break;
        }

        $query = 'SELECT nr, titel, article_nr '
                .'FROM '.CPO_NEWS.' '
                ."WHERE nr='".$_REQUEST['nr']."'";
        $db = new DB;
        $db->query($query);
        $db->next_record();
        $titel      = $db->v('titel');          
        $article_nr = $db->v('article_nr');          

        $query_del = 'SELECT nr FROM '.CPO_NEWS.' '
                    ."WHERE article_nr='".$db->v('article_nr')."'";

        $db2 = new DB;
        $db->query($query_del); 
        while ($db->next_record()) {
            $q = 'DELETE FROM '.CPO_CONTENT_FILES.' '
                .'WHERE article_id='.(int)$db->v('nr');
            $db2->query($q); 

            $q = 'DELETE FROM '.CPO_CONTENT_HTML.' '
                .'WHERE article_id='.(int)$db->v('nr');
            $db2->query($q); 
            
            $q = 'DELETE FROM '.CPO_CONTENT_IMAGES.' '
                .'WHERE article_id='.(int)$db->v('nr');
            $db2->query($q); 

            $q = 'DELETE FROM '.CPO_CONTENT_TEXT.' '
                .'WHERE article_id='.(int)$db->v('nr');
            $db2->query($q); 

            $q = 'DELETE FROM '.CPO_CONTENT_URLS.' '
                .'WHERE article_id='.(int)$db->v('nr');
            $db2->query($q); 
        }

        $query_del = 'DELETE FROM '.CPO_NEWS.' '
                    ."WHERE article_nr='".(int)$article_nr."'";
        $db = new DB;
        $db->query($query_del); 

        $message[] = sprintf(___('The article %s was successfully purged.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>');

        logaction('purge article', $_POST['nr'].': '.$titel);
        break;
    case 'setPerPage':
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('articles setPerPage', 'CSRF check failed.');
            break;
        }
        
        if ($_SESSION['SID_pagers']['articlesPerPage']!=$_REQUEST['newPerPage'])
            $_SESSION['SID_pagers']['articles'] = 0;
        $_SESSION['SID_pagers']['articlesPerPage'] = $_REQUEST['newPerPage'];
        break;
    case 'articles_select':
        $_SESSION['SID_articles_select_nr'] = $_GET['nr'];
        if ($_GET['nr']=='null') {
            unset($_SESSION['SID_articles_select_nr']);
        }
        break;
    // }}}
    case 'togglefilter':
        $_SESSION['filter_articles']['enabled'] = !$_SESSION['filter_articles']['enabled'];

        if ($_SESSION['filter_articles']['enabled']) break;
        $_SESSION['filter_articles']['phrase'] = '';
        break;
    case 'setfilter':
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('articles set filter', 'CSRF check failed.');
            break;
        }
        // $_SESSION['SID_pagers'][$pager] = 0; // FIXME Unknown $pager
        $_SESSION['filter_articles']['phrase'] = $_POST['phrase'];
        break;
    }
}

// (re)define some vars
initVar($_SESSION['SID_articles_select_nr'],NULL);

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        $art_count = 0;

        if (isset($_GET['pos'])) $_SESSION['SID_pagers']['articles'] = $_GET['pos'];
        if (empty($_GET['unr'])) $_GET['unr'] = -1;
        if (empty($_GET['dnr'])) $_GET['dnr'] = -1;

        $join_phrase = '';
        $q_phrase = '';
        if (!empty($_SESSION['filter_articles']['phrase'])) {
            $join_phrase =
                  "LEFT JOIN " . CPO_CONTENT_TEXT . " t ON " . CPO_NEWS . ".nr = t.article_id "
                . "LEFT JOIN " . CPO_CONTENT_HTML . " h ON " . CPO_NEWS . ".nr = h.article_id "
                . "LEFT JOIN " . CPO_CONTENT_URLS . " u ON " . CPO_NEWS . ".nr = u.article_id ";

            $q_phrase .=
                 "AND (titel LIKE '%"    . addslashes($_SESSION['filter_articles']['phrase'])."%' "
                ."OR commentary LIKE '%" . addslashes($_SESSION['filter_articles']['phrase'])."%' "
                ."OR keywords LIKE '%"   . addslashes($_SESSION['filter_articles']['phrase'])."%' "
                ."OR t.text LIKE '%"     . addslashes($_SESSION['filter_articles']['phrase'])."%' "
                ."OR h.html LIKE '%"     . addslashes($_SESSION['filter_articles']['phrase'])."%' "
                ."OR u.urltext LIKE '%"  . addslashes($_SESSION['filter_articles']['phrase'])."%') "
                ."GROUP BY " . CPO_NEWS . ".nr ";
        }

        $_q = "FROM " . CPO_NEWS . " "
            . $join_phrase
            . "WHERE artikel_archiv=0 "
            . "AND rubric_id='".addslashes($_SESSION['SID_rubric_id'])."' "
            . $q_phrase;

        $db = new DB;
        $db->query('SELECT COUNT(*) '.$_q);
        $db->next_record();
        $max_data = $db->v('COUNT(*)');
        
        if ($_SESSION['SID_stufe2']==1
                && strpos($cpoRubricSettings['sorting'], 'sort_id DESC')!==false
                && !empty($_SESSION['filter_articles']['phrase'])
                && $max_data>0) {
            $message[] =  ___("The manual sorting mechanism is disabled while the article filter is active.");
        }

        $articlesPerPage = $_SESSION['SID_pagers']['articlesPerPage'];

        // if last article at article_pos got deleted, decrease article_pos
        if ($max_data<=$_SESSION['SID_pagers']['articles']) 
            $_SESSION['SID_pagers']['articles'] = $max_data-1;
        if ($_SESSION['SID_pagers']['articles']<0)
            $_SESSION['SID_pagers']['articles'] = 0;

        if (!empty($_SESSION['SID_articles_select_nr'])) {
            $message[] = sprintf(__('Select mode active. You can move or %sundo%s the selection.'),
                '<a href="' . BASE_REL . '_admin/articles.php?action=articles_select&nr=null">',
                '</a>'
            );
        }
            
        printPageHeader(
            ___('Work on articles'),
            ___('In this view you can choose the article you want to manage.'),
            'articles-listarticles.html#articles-listarticles'
        );

        if ($max_data<=0) {
            if ($_SESSION['SID_stufe1']) {
                $message[] =  __('No articles found.').' '
                    .sprintf(___('You can %screate a new article%s.'),
                        '<a href="'.BASE_REL.'_admin/articles.php?action=articles_create">',
                        '</a>');
            } else {
                $message[] =  ___('No articles found.');
            }
        }

        include(CPO_BASEDIR.'_include/message.php');

        if (!$_SESSION['filter_articles']['enabled']) {
            echo '<table style="width: 100%;" class="colored filter"><thead>';
            echo '<tr>';
            printf('<th><span><a href="%1$s">'
                . '<img src="' . SKIN_URL . 'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                . '&nbsp;<a href="%1$s">%2$s</a>' .help('') . '</span></th>',
                $_SERVER['PHP_SELF'] . '?action=togglefilter',
                ___('Enable filter')
            );
            echo '</tr></table>';
        } else {
            echo '<table style="width: 100%;" class="colored"><thead>';
            echo '<tr>';
            printf('<th colspan="3"><span><a href="%1$s">'
                . '<img src="' . SKIN_URL . 'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                . '&nbsp;<a href="%1$s">%2$s</a>' . help('') . '</span></th>',
                $_SERVER['PHP_SELF'] . '?action=togglefilter',
                ___('Disable filter')
            );
            echo '</tr></thead><tbody><tr>';

            echo '<form method="post" action="' . $_SERVER["PHP_SELF"] . ' " name="newsentry">';
            $antiCSRF->printInput('setfilter');
            echo '<td class="leftrow">';
            echo ___('Filter by phrase:').'</td><td>';
            printf('<input type="text" name="%s" value="%s" class="inputwidth">' . help(''),
                'phrase',
                htmlspecialchars($_SESSION['filter_articles']['phrase'], ENT_COMPAT, 'ISO-8859-15')
            );
            echo '</td></tr><td>&nbsp;</td><td>';
            echo '<input type="submit" class="button" value="' . ___('Set filter parameters') . '">';
            echo '</td>';
            echo '</form>';
            echo '</tr></tbody></table>';
        }

        if ($max_data<=0) {
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='top')  {
            next_page($_SESSION['SID_pagers']['articles'], 
                      $max_data, 
                      $articlesPerPage, 
                      true, 
                      '', 
                      BASE_REL . '_admin/articles.php',
                      array(),
                      $cpoSystem['noOfArticles']);
            echo '<br />';
        }
                  
        // table header {{{
        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';

        if ($_SESSION['SID_stufe2']==1
                && strpos($cpoRubricSettings['sorting'], 'sort_id DESC')!==false
                && $_SESSION['filter_articles']['phrase'] == '') {
            echo '<th style="width: 1%;"><span>'.help('', true).'</span></th>'; // helpme

            // find first and last article to allow sorting to top / bottom
            $db->query('SELECT nr FROM ' . CPO_NEWS . ' ' .
                       'WHERE (' .
                           'sort_id=(SELECT MAX(sort_id) ' . $_q . ') ' .
                           'OR    sort_id=(SELECT MIN(sort_id) ' . $_q . ') ' .
                       ') AND ' . str_replace('FROM ' . CPO_NEWS . ' WHERE ', '', $_q) . ' ' .
                       'ORDER BY sort_id DESC'
            );
            if ($db->next_record()) $topNr    = $db->v('nr');
            if ($db->next_record()) $bottomNr = $db->v('nr');
        }

        echo '<th style="width: 74%;"><span>'.___('Title/Author').help('articles-listarticles.html#articles-listarticles-titleauthor').'</span></th>';

        if ($_SESSION['SID_stufe2']==1) {
            echo '<th style="width: 10%;"><span>'.___('Manage').help('articles-listarticles.html#articles-listarticles-edit').'</span></th>';
        }

        echo '<th style="width: 5%;"><span>'.___('Status').help('articles-listarticles.html#articles-listarticles-status').'</span></th>';
        echo '<th style="width: 5%;"><span>'.___('Publication').help('articles-listarticles.html#articles-listarticles-publication').'</span></th>';
        echo '<th style="width: 5%;"><span>'.___('Info').help('articles-listarticles.html#articles-listarticles-info').'</span></th>';
        echo '</tr></thead><tbody>';
        // }}}
        
        $query = "SELECT nr, article_nr, auth, autor, changer, commentary, freigabe, released_user_id, last_modify, datum, pub_datum, sort_id, templates_id, titel, verfallsdatum, idx "
                .$_q
                ."ORDER BY ".$cpoRubricSettings['sorting']." ";
        if ($articlesPerPage!='all') 
            $query .= "LIMIT ".$_SESSION['SID_pagers']['articles'].", ".$articlesPerPage;
        DEBUG(1, $query, __FILE__, __LINE__);
        $db->query($query);

        while($db->next_record()) {
            if (isset($_SESSION['SID_articles_select_nr']) && $_SESSION['SID_articles_select_nr']==$db->v('nr')) {
                echo '<tr class="table_system_active">';
            } else {
                echo '<tr>';
            }

            if ($_SESSION['SID_stufe2']==1
                    && strpos($cpoRubricSettings['sorting'], 'sort_id DESC')!==false
                    && $_SESSION['filter_articles']['phrase'] == '') {
                echo '<td>';
                if (strpos($cpoRubricSettings['sorting'], 'sort_id DESC')!==false) { 
                    // Find article above and below this one {{{
                    $query = '(SELECT nr, sort_id ' . $_q .
                             'AND sort_id>' . $db->v('sort_id') . ' ORDER BY sort_id ASC LIMIT 1) ' .
                             'UNION ' .
                             '(SELECT nr, sort_id ' . $_q .
                             'AND sort_id<' . $db->v('sort_id') . ' ORDER BY sort_id DESC LIMIT 1) ';
                    $db_2 = new DB;
                    $db_2->query($query);
                    $downNr = false;
                    $upNr   = false;
                    while ($db_2->next_record()) {
                        if ($db_2->v('sort_id')>$db->v('sort_id')) $upNr = $db_2->v('nr');
                        else $downNr = $db_2->v('nr');
                    }
                    // }}}
                    
                    // move up
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='mu' . $db->v('nr') ? '2' : '');
                    if ($upNr!==false) {
                        echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pastebefore&nr=' . $upNr. '&which=' . $db->v('nr') . '&mark=mu' . $db->v('nr') . '">';
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_up' . $mark . '.gif" width="13" height="13" alt="' . __('move up') . '" title="' . __('move up') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the first article') . '" title="' . __('this is the first article') . '" />';
                    }
                    
                    // move top
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='mt' . $db->v('nr') ? '2' : '');
                    if ($topNr!==false && $topNr!==$db->v('nr')) {
                        echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pastebefore&nr=' . $topNr . '&which=' . $db->v('nr') . '&mark=mt' . $db->v('nr') . '">';
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_top' . $mark . '.gif" width="13" height="13" alt="' . __('move article to the top') . '" title="' . __('move article to the top') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the first article') . '" title="' . __('this is the first article') . '" />';
                    }
                    
                    // paste before
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='pb' . $db->v('nr') ? '2' : '');
                    if (!empty($_SESSION['SID_articles_select_nr'])) {
                        if ($db->v('nr')!=$_SESSION['SID_articles_select_nr']) {
                            echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pastebefore&nr=' . $db->v('nr') . '&mark=pb' . $db->v('nr') . '">';
                            echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_paste-above' . $mark . '.gif" width="13" height="13" alt="' . __('paste selected article before this one') . '" title="' . __('paste selected article before this one') . '" />';
                            echo '</a>';
                        } else {
                            echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the selected article') . '" title="' . __('this is the selected article') . '" />';
                        }
                    } else {
                        echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('please select an article') . '" title="' . __('please select an article') . '" />';
                    }

                    echo '<br />';
                    // select
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='s' . $db->v('nr') ? '2' : '');
                    if ($db->v('nr')!=$_SESSION['SID_articles_select_nr']) {
                        echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_select&nr='.(int)$db->v('nr') . '&mark=s' . $db->v('nr') . '">';
                        echo '<img style="margin: 0 2px 2px 30px;" src="' . SKIN_URL . 'sort_select' . $mark . '.gif" width="13" height="13" alt="' . __('select this article') . '" title="' . __('select this article') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="margin: 0 0 2px 30px;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the selected article') . '" title="' . __('this is the selected article') . '" />';
                    }

                    echo '<br />';
                    // move down
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='md' . $db->v('nr') ? '2' : '');
                    if ($downNr!==false) {
                        echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pasteafter&nr=' . $downNr. '&which=' . $db->v('nr') . '&mark=md' . $db->v('nr') . '">';
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_down' . $mark . '.gif" width="13" height="13" alt="' . __('move article one step down') . '" title="' . __('move article one step down') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the last article') . '" title="' . __('this is the last article') . '" />';
                    }
                    
                    // move bottom
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='mb' . $db->v('nr') ? '2' : '');
                    if (isset($bottomNr) && $bottomNr!==false && $bottomNr!==$db->v('nr')) {
                        echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pasteafter&nr=' . $bottomNr . '&which=' . $db->v('nr') . '&mark=mb' . $db->v('nr') . '">';
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_bottom' . $mark . '.gif" width="13" height="13" alt="' . __('move article to the bottom') . '" title="' . __('move article to the bottom') . '" />';
                        echo '</a>';
                    } else {
                        echo '<img style="margin: 0 2px 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the last article') . '" title="' . __('this is the last article') . '" />';
                    }
                    
                    // paste after
                    $mark = (isset($_GET['mark']) && $_GET['mark']=='pa' . $db->v('nr') ? '2' : '');
                    if (!empty($_SESSION['SID_articles_select_nr'])) {
                        if ($db->v('nr')!=$_SESSION['SID_articles_select_nr']) {
                            echo '<a href="' . BASE_REL.'_admin/articles.php?action=articles_pasteafter&nr=' . $db->v('nr') . '&mark=pa' . $db->v('nr') . '">';
                            echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_paste-below' . $mark . '.gif" width="13" height="13" alt="' . __('paste selected article after this one') . '" title="' . __('paste selected article after this one') . '" />';
                            echo '</a>';
                        } else {
                            echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('this is the selected article') . '" title="' . __('this is the selected article') . '" />';
                        }
                    } else {
                        echo '<img style="margin: 0 0 2px 0;" src="' . SKIN_URL . 'sort_empty' . $mark . '.gif" width="13" height="13" alt="' . __('please select an article') . '" title="' . __('please select an article') . '" />';
                    }
                }
                echo '</td>';
            } 
            
            
            echo '<td>';
            mini_title($db->v('freigabe'), $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $db->v('nr'), $db->v('last_modify'));
            echo '</td>';

            // Manage {{{
            if ($_SESSION['SID_stufe2']==1) {
                $article_block = false;

                echo '<td>';

                $db_2 = new DB;
                $query = "SELECT user_id, name, user, admin "
                        ."FROM ".CPO_BLOCK.", ".CPO_LOG_LOGIN.", ".CPO_USER." "
                        ."WHERE log_login_id = ".CPO_LOG_LOGIN.".id "
                        ."AND user_id=".CPO_USER.".id "
                        ."AND news_nr='".$db->v('nr')."' "; 
                $db_2->query($query);
                
                // blocked
                if ($db_2->next_record()) {
                    $article_block = true;

                    if ($db_2->v('user_id')==$_SESSION['SID_user']['id'] || $_SESSION['SID_user']['admin']>$db_2->v('admin')) {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_modify&nr='.htmlspecialchars($db->v('nr'), ENT_COMPAT, 'ISO-8859-15'), 
                            SKIN_URL.'pic_locked.gif', 
                            __('unlock article'), 
                            true
                        );
                    } else {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_modify&nr='.$db->v('nr'),
                            SKIN_URL.'pic_edit.gif',
                            sprintf(___('Article is being edited by %s.'), htmlspecialchars($db_2->v('name'), ENT_COMPAT, 'ISO-8859-15')),
                            false
                        );
                    }
                } 

                // edit (not blocked)
                if (!$article_block) {
                    printIcon(
                        BASE_REL.'_admin/articles.php?action=articles_modify&nr='.$db->v('nr'),
                        SKIN_URL.'pic_edit.gif',
                        __('edit article'),
                        true
                    );
                }

                if ($_SESSION['SID_stufe1']==1 OR $_SESSION['SID_user']['admin']>ROLE_EDITOR)  { 
                    // copy
                    printIcon(
                        BASE_REL.'_admin/articles.php?action=articles_copy&nr='.$db->v('nr'),
                        SKIN_URL.'pic_copy.gif',
                        __('copy article'),
                        true
                    );

                    // move 
                    if ($article_block) {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_move&nr='.$db->v('nr'),
                            SKIN_URL.'pic_move.gif',
                            sprintf(__('Article is being edited by %s.'), htmlspecialchars($db_2->v('name'), ENT_COMPAT, 'ISO-8859-15')),
                            false
                        );
                    } else {
                        // Allowed to access different rubric?
                        $query = "SELECT COUNT(*) FROM ".CPO_PERMISSION." "
                                ."WHERE user_id=".$_SESSION['SID_user']['id']." "
                                ."AND stufe1=1 "
                                ."AND rubric_id!='".addslashes($_SESSION['SID_rubric_id'])."'";
                        DEBUG(2, 'Is the user allowed to access a different rubric?<br /><br />'.$query, __FILE__, __LINE__);
                        $db_2->query($query);
                        $db_2->next_record();
                        if ($db_2->v('COUNT(*)')>0) {
                            printIcon(
                                BASE_REL.'_admin/articles.php?action=articles_move&nr='.$db->v('nr'),
                                SKIN_URL.'pic_move.gif',
                                __('move article'),
                                true
                            );
                        } else {
                            printIcon(
                                BASE_REL.'_admin/articles.php?action=articles_move&nr='.$db->v('nr'),
                                SKIN_URL.'pic_move.gif',
                                __('You only have access to this rubric.'),
                                false
                            );
                        }
                    }

                    // delete article
                    if ($article_block) {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_delete&nr='.$db->v('nr'),
                            SKIN_URL.'pic_del.gif',
                            sprintf(__('Article is being edited by %s.'), htmlspecialchars($db_2->v('name'), ENT_COMPAT, 'ISO-8859-15')),
                            false
                        );
                    } else {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_delete&nr='.$db->v('nr'),
                            SKIN_URL.'pic_del.gif',
                            __('delete article'),
                            true
                        );
                    }
                }
                
				// Artikel verfallen lassen https://community.conpresso4.de/viewtopic.php?p=17955#p17955
				if (time()<=strtotime($db->v('pub_datum'))) {  // not published yet
                    // republish
                    printIcon(
                        BASE_REL.'_admin/articles.php?action=articles_publish&nr='.$db->v('nr'),
                        SKIN_URL.'pic_mod_active_on.gif',
                        __('publish article now!'),
                        true
                    );
                } elseif (time()>=strtotime($db->v('verfallsdatum'))) {  // already expired
                    // republish
                    printIcon(
                        BASE_REL.'_admin/articles.php?action=articles_republish&nr='.$db->v('nr'),
                        SKIN_URL.'pic_mod_active_on.gif',
                        __('republish article'),
                        true
                    );
                } else {
                    printIcon(
                        BASE_REL.'_admin/articles.php?action=articles_archive&nr='.$db->v('nr'),
                        SKIN_URL.'pic_mod_active_off.gif',
                        __('expire article'),
                        true
                    );
                }

                // Version archive
                if ($_SESSION['SID_user']['admin']>ROLE_EDITOR) {
                    $db_2 = new DB;
                    $query = "SELECT COUNT(*) "
                            ."FROM ".CPO_NEWS." "
                            ."WHERE article_nr=".$db->v('nr');
                    $db_2->query($query);
                    $db_2->next_record();
                    if ($db_2->v('COUNT(*)')>1) {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_versions&nr='.(int)$db->v('nr'),
                            SKIN_URL.'pic_version.gif',
                            sprintf(__('show all %d article versions'), $db_2->v('COUNT(*)')),
                            true
                        );
                    } else {
                        printIcon(
                            BASE_REL.'_admin/articles.php?action=articles_versions&nr='.(int)$db->v('nr'),
                            SKIN_URL.'pic_version.gif',
                            __('This is the only article version.'),
                            false
                        );
                    }
                }
            }
            echo '</td>';
            // }}}

            echo '<td style="white-space: nowrap;">';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), '_admin/articles.php?action=articles_status'); // FIXME article_nr needed or can nr be used?
            echo '</td>';

            echo '<td style="white-space: nowrap;">';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum')); 
            echo '</td>';

            echo '<td>';
            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'), $db->v('idx'));
            echo '</td>';
            echo '</tr>';
            $art_count++;
        }

        echo '</tbody></table>';

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='bottom')  {
            next_page($_SESSION['SID_pagers']['articles'], 
                      $max_data, 
                      $articlesPerPage, 
                      true, 
                      '', 
                      BASE_REL . '_admin/articles.php',
                      array(),
                      $cpoSystem['noOfArticles']);
        }

        $fields = array(
            'titel ASC'          => 'Title ascending', 
            'titel DESC'         => 'Title descending', 
            'datum ASC'          => 'Date ascending',
            'datum DESC'         => 'Date descending',
            'verfallsdatum ASC'  => 'Expiration date ascending',
            'verfallsdatum DESC' => 'Expiration date descending',
            'pub_datum ASC'      => 'Publication date ascending',
            'pub_datum DESC'     => 'Publication date descending',
            'idx ASC'            => 'Index ascending',
            'idx DESC'           => 'Index descending',
            'sort_id DESC'       => 'Manual',
        );

        $sortings = explode(', ', $cpoRubricSettings['sorting']);
        echo '<p><b>'.___('Sorting method:').'</b> ';
        $comma = '';
        foreach ($sortings AS $v) {
            if (isset($fields[$v])) echo $comma.___($fields[$v]);
            $comma = ", ";
        }
        echo '</p>';

        require(CPO_BASEDIR.'_include/footer.php');
        break;
        // }}}
    case 'list_release': // {{{
        $db = new DB;
        $query = "SELECT COUNT(*) FROM ".CPO_NEWS.", ".CPO_PERMISSION." "
                ."WHERE ".CPO_NEWS.".rubric_id=".CPO_PERMISSION.".rubric_id "
                ."AND artikel_archiv='0' "
                ."AND freigabe>'".STATE_RELEASED."' "
                ."AND stufe4='1' "
                ."AND user_id='".addslashes($_SESSION['SID_user']['id'])."'";
        DEBUG(2, $query, __FILE__, __LINE__);
        $db->query($query);
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        if (isset($_GET['pos'])) $_SESSION['SID_pagers']['articles_release'] = $_GET['pos'];

        if ($max_data<=$_SESSION['SID_pagers']['articles_release'])
            $_SESSION['SID_pagers']['articles_release'] = $max_data-1;
        if (!isset($_SESSION['SID_pagers']['articles_release']) 
            || $_SESSION['SID_pagers']['articles_release']<0)
            $_SESSION['SID_pagers']['articles_release'] = 0;

        require(CPO_BASEDIR.'_include/header.php');
        printPageHeader(
            ___('Release articles'),
            ___('In this view you can release articles.'),
            'articles-releasearticles.html#articles-releasearticles'
        );
        if ($max_data<=0) {
            $message[] = ___('No articles within your release area were found.');
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }
        include(CPO_BASEDIR.'_include/message.php');

        $query = "SELECT nr, name, templates_id, sort_id, ".CPO_NEWS.".rubric_id, commentary, auth, freigabe, article_nr, titel, autor, ".CPO_NEWS.".changer, last_modify, datum, pub_datum, verfallsdatum, stufe4 "
                ."FROM ".CPO_NEWS.", ".CPO_PERMISSION.", ".CPO_RUBRIC." "
                ."WHERE ".CPO_NEWS.".rubric_id=".CPO_PERMISSION.".rubric_id "
                ."AND ".CPO_NEWS.".rubric_id=".CPO_RUBRIC.".id "
                ."AND artikel_archiv=0 "
                ."AND freigabe>'".STATE_RELEASED."' "
                ."AND stufe4='1' "
                ."AND user_id='".$_SESSION['SID_user']['id']."'"
                ."ORDER BY name, datum " // FIXME sort by?
                ."LIMIT ".$_SESSION['SID_pagers']['articles_release'].",".$cpoSystem['noOfArticles'];
        DEBUG(2, $query, __FILE__, __LINE__);
        $db->query($query);
            
        echo '<table class="ruler" style="width: 100%">';
        echo '<thead><tr>';

        echo '<th style="width: 50%;"><span>'.___('Title/Author').help('articles-releasearticles.html#articles-releasearticles-titleauthor').'</span></th>';
        echo '<th style="width: 20%;"><span>'.___('Rubric').help('articles-releasearticles.html#articles-releasearticles-rubric').'</span></th>';
        echo '<th style="width: 10%;"><span>'.___('Status').help('articles-releasearticles.html#articles-releasearticles-status').'</span></th>';
        echo '<th style="width: 15%;"><span>'.___('Publication').help('articles-releasearticles.html#articles-releasearticles-publication').'</span></th>';
        echo '<th style="width: 5%;"><span>'.___('Info').help('articles-releasearticles.html#articles-releasearticles-info').'</span></th>';
        echo '</tr></thead><tbody>';

        while($db->next_record()) {
            echo '<td>';
            mini_title($db->v('freigabe'), $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $db->v('nr'), $db->v('last_modify'));
            echo '</td>';

            echo '<td>';
            echo '<a href="'.BASE_REL.'_admin/index.php?rubric='.htmlspecialchars($db->v('rubric_id'), ENT_COMPAT, 'ISO-8859-15').'" target="_top"><strong><nobr>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</nobr></strong></a><br />';
            echo '</td>';

            echo '<td>';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), '_admin/articles.php?action=articles_status_release', $db->v('stufe4'));
            echo '</td>';

            echo '<td>';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum'));
            echo '</td>';

            echo '<td>';
            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
            echo '</td>';

            echo '</tr>';
        }
            
        echo '</tbody></table>';
        next_page($_SESSION['SID_pagers']['articles_release'], $max_data, $cpoSystem['noOfArticles'], true, 'action=articles_release');
        require(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'list_versions': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        $db = new DB;
        $query = "SELECT article_nr, autor, auth, commentary, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, last_modify, changer, nr "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_POST['nr'])."'";
        $db->query($query);
        $db->next_record();

        printPageHeader(
            ___('Article versions'), 
            sprintf(___('In this view you can manage all versions of the article %s.'), '<em>'.htmlspecialchars($db->v('titel'), ENT_COMPAT, 'ISO-8859-15').'</em>'),
            'articles-listarticles.html#articles-listarticles-articleversions'
        );
        include(CPO_BASEDIR.'_include/message.php');

        echo '<table class="ruler" style="width: 100%"><thead><tr>';
        echo '<th style="width: 20%;"><span>'.___('Version date').help('articles-listarticles.html#articles-listarticles-articleversions-versiondate').'</span></th>';
        echo '<th style="width:  5%;"><span>'.___('Manage')      .help('articles-listarticles.html#articles-listarticles-articleversions-edit').'</span></th>';
        echo '<th style="width: 50%;"><span>'.___('Title/Author').help('').'</span></th>'; // helpme
        echo '<th style="width: 10%;"><span>'.___('Status')      .help('articles-listarticles.html#articles-listarticles-articleversions-status').'</span></th>';
        echo '<th style="width: 10%;"><span>'.___('Publication') .help('articles-listarticles.html#articles-listarticles-articleversions-publication').'</span></th>';
        echo '<th style="width:  5%;"><span>'.___('Info')        .help('articles-listarticles.html#articles-listarticlelistarticles-articleversions-info').'</span></th>';
        echo '</tr></thead><tbody>';
    
        // actual article {{{
        $article_nr = $db->v('article_nr'); // used to display versions below

        // is the newest version the online one?
        $online = false;
        $trclass = '';
        if ($db->v('artikel_archiv')==0 && $db->v('freigabe')==STATE_RELEASED) { 
            $trclass = 'table_system_active';
            $online = true;
        }

        print('<tr class="'.$trclass.'">');
        ?>
        <td style="white-space: nowrap;">
            <?php
            // Version date
            print($db->v('last_modify')>0 ? 
                date($cpoSystem['date_format'], strtotime($db->v('last_modify'))) : 
                date($cpoSystem['date_format'], strtotime($db->v('datum')))
            );
            print('<br />');

            if ($db->v('freigabe')==STATE_RELEASED && $db->v('release_date')!='0000-00-00 00:00:00') {
                print(date($cpoSystem['date_format'], strtotime($db->v('release_date'))));
                // FIXME display released_user_id name if ($freigabe_name!=$changer && $freigabe_name!='') {
            }
            ?>
        </td>

        <td> <!-- manage --></td>

        <?php
        echo '<td>';
        $r = $db->v('freigabe');
        if (!$online) $r = -1; // do not display the published image for versions not online
        mini_title($r, $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $_POST['nr'], $db->v('last_modify'));
        echo '</td>';

        echo '<td>';
        mini_status($_POST['nr'], $db->v('article_nr'), $db->v('freigabe'), '_admin/articles.php?action=articles_status_versions');
        echo '</td>';

        echo '<td>';
        mini_publication($db->v('pub_datum'), $db->v('verfallsdatum')); 
        echo '</td>';

        echo '<td>';
        mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
        echo '</td>';

        echo '</tr>';
        // }}}
        // article revisions {{{
        $query = "SELECT nr, artikel_archiv, article_nr, auth, commentary, rubric_id, templates_id, titel, datum, verfallsdatum, pub_datum, freigabe, released_user_id, release_date, autor, last_modify, changer "
                ."FROM ".CPO_NEWS." "
                ."WHERE artikel_archiv!=0 " // exclude the actual 
                ."AND article_nr='".addslashes($article_nr)."' "
                ."ORDER BY last_modify DESC";
        $db->query($query);
        if ($db->num_rows()<=0) {
            print('</tbody></table>');
            require(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        while($db->next_record()) {
            $trclass = '';
            if (!$online && $db->v('artikel_archiv')==1) {
                $trclass = 'table_system_active';
                $online = true;
            }
            print('<tr class="'.$trclass.'">');
            echo '<td>';
            // Version date
            print($db->v('last_modify')>0 ? 
                date($cpoSystem['date_format'], strtotime($db->v('last_modify'))) : 
                date($cpoSystem['date_format'], strtotime($db->v('datum')))
            );
            print('<br />');

            if ($db->v('freigabe')==STATE_RELEASED && $db->v('release_date')!='0000-00-00 00:00:00') {
                print(date($cpoSystem['date_format'], strtotime($db->v('release_date'))));
                // FIXME display released_user_id name if ($freigabe_name!=$changer && $freigabe_name!='') {
            }
            echo '</td>';

            echo '<td>';
            printIcon(
                BASE_REL.'_admin/articles.php?action=articles_versions_restore&nr='.$_POST['nr'].'&version_nr='.$db->v('nr'),
                SKIN_URL.'pic_restore.gif',
                ___('restore article version'),
                true
            );
            if ($db->v('artikel_archiv')!=1) {
                printIcon(
                    BASE_REL.'_admin/articles.php?action=articles_versions_delete&nr='.$db->v('nr'),
                    SKIN_URL.'pic_del.gif',
                    ___('delete article version'),
                    true
                );
            }
            echo '</td>';

            echo '<td>';
            $r = $db->v('freigabe');
            if (empty($trclass)) $r = -1; // do not display the published image for versions not online
            mini_title($r, $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $_POST['nr'], $db->v('last_modify'));
            echo '</td>';

            echo '<td>';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), '_admin/articles.php?action=articles_status_versions&amp;info=1');
            echo '</td>';

            echo '<td>';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum'));
            echo '</td>';

            echo '<td>';
            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
            echo '</td>';

            echo '</tr>';
        } 
        echo '</tbody></table>';
        // }}}
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'edit_form': // {{{

        require(CPO_BASEDIR.'_include/header.php');

        if (empty($_POST['nr'])) {
            if (empty($_POST['copy'])) {
                printPageHeader(
                    ___('Create article'),
                    ___('In this view you can create an article.'),
                    'articles-createarticle.html#articles-createarticle'
                );
            } else {
                printPageHeader(
                    ___('Copy article'),
                    sprintf(___('In this view you can edit the copy of the article %s.'), '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'),
                    'articles-listarticles.html#articles-listarticles-copyarticle'
                );
            }
        } else {
            printPageHeader(
                ___('Edit article'),
                sprintf(___('In this view you can edit the article %s.'), '<em>'.$_POST['titel'].'</em>'),
                'articles-listarticles.html#articles-listarticles-workonarticle'
            );
        }
        
        if (!empty($_POST['templates_id'])) {
            $query = "SELECT ".CPO_TEMPLATES.".id, name "
                    ."FROM ".CPO_TPL_ASSIGNMENT.", ".CPO_TEMPLATES." "
                    ."WHERE templates_id=".CPO_TEMPLATES.".id "
                    ."AND ".CPO_TPL_ASSIGNMENT.".rubric_id = '".$_SESSION['SID_rubric_source_rubric_id']."' "
                    ."AND ".CPO_TEMPLATES.".id=" . (int)$_POST['templates_id'];
            $db = new DB;
            $db->query($query);
            if ($db->num_rows()==0) {
                $message[] = ___('The used article-template is not allowed in this rubric. You might want to choose a different article-template.');
            }
        }

        $query = "SELECT COUNT(*) "
                ."FROM ".CPO_TPL_ASSIGNMENT.", ".CPO_TEMPLATES." "
                ."WHERE templates_id=".CPO_TEMPLATES.".id "
                ."AND ".CPO_TPL_ASSIGNMENT.".rubric_id = '".$_SESSION['SID_rubric_source_rubric_id']."'";
        $db->query($query);
        $db->next_record();
        if ($db->v('COUNT(*)')<=0) {
            $message[] = ___('No article-templates are assigned to this rubric.').'<br />';
            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                $message[] = sprintf(___('Please do so in the %srubric settings%s.'),
                    '<a href="'.BASE_REL.'_admin/rubrics.php?action=rubrics_showsettings&id='.htmlspecialchars($_SESSION['SID_rubric_source_rubric_id'], ENT_COMPAT, 'ISO-8859-15').'">',
                    '</a>'
                );
            }
            include(CPO_BASEDIR.'_include/message.php');
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        include(CPO_BASEDIR.'_include/message.php');

        print('<form method="post" action="'.$_SERVER['PHP_SELF'].'" onsubmit="return innerToHidden();" name="article_form" enctype="multipart/form-data">');
        $antiCSRF->printInput('articles_save');
        // FIXME use print to print the complete tags... ?>
        <input type="hidden" name="rubric_id" value="<?php echo isset($_POST['rubric_id']) ? $_POST['rubric_id'] : ''; ?>">
        <input type="hidden" name="nr"        value="<?php echo isset($_POST['nr'])        ? $_POST['nr']        : ''; ?>">
        <input type="hidden" name="auth"      value="<?php echo isset($_POST['auth'])      ? $_POST['auth']      : ''; ?>">
        <input type="hidden" name="sort_id"   value="<?php echo isset($_POST['sort_id'])   ? $_POST['sort_id']   : ''; ?>">
        <input type="hidden" name="freigabe"  value="<?php echo isset($_POST['freigabe'])  ? $_POST['freigabe']  : ''; ?>">
        <input type="hidden" name="copy"      value="<?php echo isset($_POST['copy'])      ? $_POST['copy']      : ''; ?>">
        <input type="hidden" name="datum"     value="<?php echo isset($_POST['datum'])     ? $_POST['datum']     : ''; ?>">
        <input type="image" src="<?php echo BASE_REL; ?>_images/transparent.gif"  value=""  />

        <?php
        require(CPO_BASEDIR.'_include/article_form.php'); // FIXME Display the content table if no placeholders are use?

        print('</form>');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'move': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        $db = new DB;

        $query = "SELECT titel "
                ."FROM ".CPO_NEWS." "
                ."WHERE nr='".addslashes($_POST['nr'])."'";
        $db->query($query);
        $db->next_record();
        $titel = $db->v('titel');

        printPageHeader(
            ___('Move article'),
            sprintf(___('In this view you can move the article %s into another rubric. If the used article-template is not allowed in the new rubric, the standard article-template of the new rubric will be used.'),
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'articles-listarticles.html#articles-listarticles-movearticle'
        );
        ?>

        <form method="post" action="<?php echo $_SERVER['PHP_SELF'] ?>">
        <?php $antiCSRF->printInput('articles_moveto'); ?>
        <input type="hidden" name="nr" value="<?php echo htmlspecialchars($_POST['nr'], ENT_COMPAT, 'ISO-8859-15'); ?>">

        <table class="colored" style="width: 100%;"><thead>
            <tr>
                <th colspan="2"><span><?php echo ___('Article'); ?></span></th>
            </tr>
        </thead><tbody>
            <tr>
                <td class="leftrow"><?php echo ___('Article:'); ?></td>
                <td class="rightrow">
                    <?php echo htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15'); ?>
                </td>
            </tr>
            <tr>
                <td><?php echo ___('Move article into rubric:'); ?></td>
                <td>
                    <?php
                    $query = "SELECT rubric_id, name "
                            ."FROM ".CPO_RUBRIC.", ".CPO_PERMISSION." "
                            .'WHERE rubric_id='.CPO_RUBRIC.'.id '
                            ."AND rubric_id!='".addslashes($_SESSION['SID_rubric_id'])."' "
                            .'AND (stufe1=1 OR stufe2=1) '
                            .'AND user_id='.(int)$_SESSION['SID_user']['id'].' '
                            ."ORDER BY name";
                    $db->query($query);

                    print('<select name="move_target" size="1">');
                    while($db->next_record()) {
                        printf('<option value="%s">%s</option>',
                            htmlspecialchars($db->v('rubric_id'), ENT_COMPAT, 'ISO-8859-15'),
                            htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15')
                        );
                    }
                    print('</select>');
                    print(help('articles-listarticles.html#articles-listarticles-movearticle-rubric')); 
                    ?>
                </td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td>
                    <?php 
                    echo '<input type="submit" class="button" value="'.___('move article').'">&nbsp;'; 
                    echo '<input type="submit" name="cancel" class="button" value="'.___('cancel').'">';
                    ?>
                </td>
            </tr>
        </tbody></table>
        </form>
        <?php

        require(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'reject': // {{{ reject_versions, reject_release
    case 'reject_versions':
    case 'reject_release':
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Reject article'),
            sprintf(___('You are going to reject the article %s. You should probably send the author of the article (%s <%s>) a message why you rejected his content.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>',
                '<em>'.htmlspecialchars($autor, ENT_COMPAT, 'ISO-8859-15').'</em>',
                '<em>'.htmlspecialchars($email, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'articles-listarticles.html#articles-listarticles-articlerelease-rejectarticle'
        );
        include(CPO_BASEDIR.'_include/message.php');

        // do we have template candidates?
        echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" onsubmit="return innerToHidden();" name="article_form">';
        switch ($nextview) {
        case 'reject';
            $antiCSRF->printInput('articles_status');
            break;
        case 'reject_versions';
            $antiCSRF->printInput('articles_status_versions');
            break;
        case 'reject_release';
            $antiCSRF->printInput('articles_status_release');
            break;
        }
        echo '<input type="hidden" name="sendmessage" value="1">';
        echo '<input type="hidden" name="nr" value="'.htmlspecialchars($_REQUEST['nr'], ENT_COMPAT, 'ISO-8859-15').'" />';
        echo '<input type="hidden" name="status" value="'.STATE_REJECTED.'" />';
        echo '<table class="colored" style="width: 100%;"><thead>';
        echo '<tr><th colspan="2"><span>'.___('Rejection reason').'</span></th></tr>';
        echo '</thead><tbody>';
        echo '<tr><td>'.___('Subject:').'</td><td>';
        if (!empty($_POST['subject']))
            echo '<input type="text" class="text inputwidth" name="subject" value="' . htmlspecialchars($_POST['subject'], ENT_COMPAT, 'ISO-8859-15') . '" />';
        else 
            echo '<input type="text" class="text inputwidth" name="subject" value="'.___('Article rejected').'" />';
        echo help('articles-listarticles.html#articles-listarticles-articlerelease-rejectarticle-subject');
        echo '</td></tr>';
        echo '<tr><td>'.___('Message:').'</td><td>';
        echo '<textarea class="textarea" cols="80" rows="20" name="body">';
        if (!empty($_POST['subject'])) {
            echo htmlspecialchars($_POST['body'], ENT_COMPAT, 'ISO-8859-15');
        } else {
            echo sprintf(___("------------------------------------------------------------------------\nThis e-mail was automatically generated. If you have questions please\ncontact your administrator <%s>.\n------------------------------------------------------------------------\n\nHello %s,\n\none of your articles was rejected:\n\nProject:     %s\nRubric:      %s\nTitle:       %s\n\nResponsible: %s <%s>\n\nReason: \n"),
                htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15'), // admin
                htmlspecialchars($autor, ENT_COMPAT, 'ISO-8859-15'), // user
                htmlspecialchars($cpoSystem['project'], ENT_COMPAT, 'ISO-8859-15'), // project
                htmlspecialchars($rubric, ENT_COMPAT, 'ISO-8859-15'), // Rubric
                htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15'), // Title
                htmlspecialchars($_SESSION['SID_user']['name'], ENT_COMPAT, 'ISO-8859-15'), // responsible
                htmlspecialchars($_SESSION['SID_user']['email'], ENT_COMPAT, 'ISO-8859-15') // responsible
            );            
        }
        echo '</textarea>'.help('articles-listarticles.html#articles-listarticles-articlerelease-rejectarticle-body');
        echo '<br />';
        echo '<br />';
        echo '</td></tr>';
        echo '<tr><td>&nbsp;</td><td>';
        echo '<input type="submit" name="sendmessageyes" value="'.___('send message').'" />';
        echo '&nbsp;';
        echo '<input type="submit" name="sendmessageno" value="'.___('don\'t send message').'" />';
        echo '</td></tr>';
        echo '</tbody></table>';
        print('</form>');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'articles_version_reallydelete': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Delete article version'),
            sprintf(___('In this view you can delete the article version %s.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'articles-listarticles.html#articles-listarticles-deletearticle'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the article version %s?'), 
            '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('articles_versions_deletereally');
        $message .= '<input type="hidden" name="nr" value="'.htmlspecialchars($_GET['nr'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'reallydelete': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Delete article'),
            sprintf(___('In this view you can delete the article %s.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'articles-listarticles.html#articles-listarticles-deletearticle'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the article %s?'), 
            '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('articles_delete_really');
        $message .= '<input type="hidden" name="nr" value="'.htmlspecialchars($_GET['nr'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'reallyunlock': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Unlock article'),
            sprintf(___('You are going to unlock the article %s.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            '' // helpme
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('%s started editing the article %s %d minutes ago and might still be editing it.'),
            htmlspecialchars(ucfirst(formatUserName($user_id, $user, $name)), ENT_COMPAT, 'ISO-8859-15'),
            '<em>'.$titel.'</em>',
            (time()-strtotime($date))/60
        );
        $message .= '<br /><br />';
        $message .= sprintf(___('Are you sure you want to unlock the article %s?'), 
            '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('articles_unlock_really');
        $message .= '<input type="hidden" name="nr" value="'.htmlspecialchars($_GET['nr'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, unlock').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not unlock').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}

    case 'restorearticles': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            __('Restore articles'),
            __('In this view you restore deleted articles and purge deleted articles.'),
            'articles-restorearticles.html#articles-restorearticles'
        );

        $query = 'SELECT nr, article_nr, templates_id, auth, commentary, freigabe, titel, autor, changer, last_modify, pub_datum, verfallsdatum '
                .'FROM '.CPO_NEWS.' '
                .'WHERE artikel_archiv=9 '
                ."AND rubric_id='".$_SESSION['SID_rubric_id']."' "
                .'ORDER BY '.$cpoRubricSettings['sorting'];
        $db = new DB;
        $db->query($query);
    
        // exit if no articles were found
        if ($db->num_rows()<=0) {
            $message[] =  __('No articles found.');
            include(CPO_BASEDIR.'_include/message.php');
            require(CPO_BASEDIR.'_include/footer.php');
            break;
        } 

        include(CPO_BASEDIR.'_include/message.php');

        echo '<table class="ruler" style="width: 100%;">';
        echo '<thead><tr>';

        echo '<th style="width: 75%;"><span>'.__('Title/Author').help('articles-restorearticles.html#articles-restorearticles-titleauthor').'</span></th>';
        if ($_SESSION['SID_stufe2']==1) {
            echo '<th style="width: 5%;"><span>'.__('Manage').help('articles-restorearticles.html#articles-restorearticles-edit').'</span></th>';
        }

        echo '<th style="width: 20%;"><span>'.__('Status').help('articles-restorearticles.html#articles-restorearticles-status').'</span></th>';
        echo '<th style="width: 15%;"><span>'.__('Publication').help('articles-restorearticles.html#articles-restorearticles-publication').'</span></th>';
        echo '<th style="width: 5%;"><span>'.__('Info').help('articles-restorearticles.html#articles-restorearticles-info').'</span></th>';
        echo '</tr></thead><tbody>';

        while($db->next_record()) {
            echo '<tr>';

            echo '<td>';
            mini_title(-1, $db->v('pub_datum'), $db->v('verfallsdatum'), $db->v('titel'), $db->v('autor'), $db->v('changer'), $db->v('nr'), $db->v('last_modify'));
            echo '</td>';

            if ($_SESSION['SID_stufe2']==1) {
                echo '<td>';
                printIcon(
                    BASE_REL.'_admin/articles.php?action=articles_do_restore&nr='.$db->v('nr'),
                    SKIN_URL.'pic_restore_article.gif',
                    ___('restore article'),
                    true
                );

                printIcon(
                    BASE_REL.'_admin/articles.php?action=articles_purge&nr='.$db->v('nr'),
                    SKIN_URL.'pic_del.gif',
                    ___('purge article'),
                    true
                );
                echo '</td>';
            }

            echo '<td>';
            mini_status($db->v('nr'), $db->v('article_nr'), $db->v('freigabe'), '');
            echo '</td>';

            echo '<td>';
            mini_publication($db->v('pub_datum'), $db->v('verfallsdatum'));
            echo '</td>';

            echo '<td>';
            mini_info($db->v('templates_id'), $db->v('commentary'), $db->v('auth'));
            echo '</td>';

            echo '</tr>';
        } // while
        echo '</tbody></table>';

        require(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    case 'reallypurge': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Purge article'),
            sprintf(___('In this view you can purge the article %s.'), 
                '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            '' // helpme
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to purge the article %s?'), 
            '<em>'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('articles_purge_really');
        $message .= '<input type="hidden" name="nr" value="'.htmlspecialchars($_GET['nr'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, purge').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not purge').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    }
}