<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');

// define some vars
initVar($_REQUEST['pos'],'');
initVar($_REQUEST['search'],'');
initVar($_GET['order'],'');
initVar($_GET['desc'],'');
initVar($desc,'');
initVar($_SESSION['filter_log']['phrase'],'');
initVar($_SESSION['filter_log']['enabled'],'');
initVar($_REQUEST['action'],'');

$zugang = 0;

if ($_REQUEST['pos']=='' || $_REQUEST['pos']<0) $_REQUEST['pos'] = 0;

// by default the filter is off
if (!isset($_SESSION['filter_log'])) $_SESSION['filter_log']['enabled'] = false;


require(CPO_BASEDIR.'_include/check.php');

$defaultAnzahl = 50;
$anzahl = $defaultAnzahl;
if (isset($_SESSION['SID_pagers']['logsPerPage'])) $anzahl=$_SESSION['SID_pagers']['logsPerPage'];
if (!empty($_GET['anzahl'])) $anzahl = (int)$_GET['anzahl'];

$views = array('list');
$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

if ($_REQUEST['action']=='setPerPage') {
    if (!$antiCSRF->checkToken()) {
        $message[] = ___('Security check failed. Please try again.');
        logaction('logfile setPerPage', 'CSRF check failed.');
    } else {
        if ($anzahl!=$_POST['newPerPage'])
            $_SESSION['SID_pagers']['logsPerPage'] = $_POST['newPerPage'];
        $anzahl = $_POST['newPerPage'];
        if (!empty($_REQUEST['defaultAction']))
            $_REQUEST['action'] = $_REQUEST['defaultAction'];
    }
}


while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'logfile_togglefilter':
        $_SESSION['filter_log']['enabled'] = !$_SESSION['filter_log']['enabled'];

        if (!$_SESSION['filter_log']['enabled']) {
            $_SESSION['filter_log']['phrase'] = '';
        }
        break;
    case 'logfile_setfilter':
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('logfile set filter', 'CSRF check failed.');
            break;
        }
        $_SESSION['filter_log']['phrase'] = $_POST['phrase'];
        break;
    case 'setPerPage':
        if ($anzahl!=$_POST['newPerPage'])
            $_REQUEST['pos'] = 0;
        $anzahl = $_POST['newPerPage'];
        break;
    }
}
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list':
        include(CPO_BASEDIR.'_include/header.php');

        $db = new DB;
        if ($cpoSystem['logfiledays']>0) {
            $db->query('DELETE FROM '.CPO_LOG.' WHERE datum<\''.date('Y-m-d', time()-$cpoSystem['logfiledays']*24*60*60)."'"); 
        }

        $query = "SELECT COUNT(*) FROM ".CPO_LOG." ";
        if ($_SESSION['filter_log']['enabled']) 
            $query .= "WHERE user LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ".
                      "OR aktion LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ".
                      "OR bemerkung LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ";
        $db->query($query);
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        $query = "SELECT id, user, datum, aktion, bemerkung "
                ."FROM ".CPO_LOG." ";
        if ($_SESSION['filter_log']['enabled']) 
            $query .= "WHERE user LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ".
                      "OR aktion LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ".
                      "OR bemerkung LIKE '%".addslashes($_SESSION['filter_log']['phrase'])."%' ";
        $query .= "ORDER BY id DESC ";

        if ($anzahl!='all')
            $query .= "LIMIT " . (int)$_REQUEST['pos'] . ", " . $anzahl;

        $db->query($query);

        if ($db->num_rows()<=0) { 
            $message[] = ___('No records found.');
        }

        printPageHeader(
            __('Show logfile'),
            __('In this view you can see all logged activities. Please use the filter to search in the entries.'),
            'system-logfile.html#system-logfile'
        );
        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="colored" style="width: 100%"><thead><tr>');

        if (!$_SESSION['filter_log']['enabled']) {
            printf('<th><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>',
                $_SERVER['PHP_SELF'].'?action=logfile_togglefilter&amp;anzahl=' . urlencode($anzahl),
                ___('Enable filter'),
                help('system-logfile.html#system-logfile-filterenable')
            );
            print('</tr></thead></table>');
        } else {
            printf('<th colspan="2"><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>', 
                $_SERVER['PHP_SELF'].'?action=logfile_togglefilter&amp;anzahl=' . urlencode($anzahl),
                ___('Disable filter'), 
                help('system-logfile.html#system-logfile-filterenable')
            );
            print('</tr></thead><tbody><tr>');
            ?>
            <form method="post" action="<?php print($_SERVER['PHP_SELF']); ?>">
                <td class="leftrow"><?php print(__('Filter by phrase:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="phrase" size="25" value="<?php 
                        echo htmlspecialchars($_SESSION['filter_log']['phrase'], ENT_COMPAT, 'ISO-8859-15'); ?>"> 
                        <?php echo help('system-logfile.html#system-logfile-filterbykeyword'); ?>
                </td>
            </tr><tr>
                <td>&nbsp;</td>
                <td>
                    <?php $antiCSRF->printInput('logfile_setfilter'); ?>
                    <input type="hidden" name="anzahl" value="<?php echo htmlspecialchars($anzahl, ENT_COMPAT, 'ISO-8859-15'); ?>">
                    <input type="submit" class="button" name="submit" value="<?php print(___('Set filter parameters')); ?>" />
                </td>
            </tr></form></tbody></table><br />
        <?php
        }

        if ($db->num_rows()<=0) { 
            include(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='top')  {
            next_page(
                $_REQUEST['pos'],
                $max_data,
                $anzahl,
                true,
                'desc='.urlencode($desc).'&amp;search='.urlencode($_REQUEST['search']).'&amp;order='.urlencode($_GET['order']).'&amp;first=1&amp;anzahl=' . urlencode($anzahl),
                '', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
        }

        echo '<br /><table class="ruler" style="width: 100%"><thead>';
        echo '<tr>';

        $newdesc = 1;
        if ($_GET['desc']==1) $newdesc = 0;

        echo '<th><span>'.___('Date');
        print(help('system-logfile.html#system-logfile-date'));
        echo '</span></th>';

        echo '<th><span>'.___('User');
        print(help('system-logfile.html#system-logfile-user'));
        echo '</span></th>';

        echo '<th><span>'.___('Action');
        print(help('system-logfile.html#system-logfile-action'));
        echo '</span></th>';

        echo '<th><span>'.__('Detail');
        print(help('system-logfile.html#system-logfile-detail'));
        echo '</span></th>';

        echo '</tr></thead><tbody>';

        while($db->next_record()) {
            echo '<tr>';

            echo '<td style="white-space: nowrap;">';
            echo date($cpoSystem['date_format'], strtotime($db->v('datum')));
            echo '</td>';

            echo '<td stlye="white-space: nowrap;">'.htmlspecialchars($db->v('user'), ENT_COMPAT, 'ISO-8859-15').'&nbsp;</td>';

            echo '<td>'.htmlspecialchars($db->v('aktion'), ENT_COMPAT, 'ISO-8859-15').'&nbsp;</td>';

            echo '<td>'.htmlspecialchars($db->v('bemerkung'), ENT_COMPAT, 'ISO-8859-15').'&nbsp;</td>';

            echo '</tr>';
        }

        echo '</tbody></table>';

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='bottom')  {
            next_page(
                $_REQUEST['pos'],
                $max_data,
                $anzahl,
                true,
                'desc='.urlencode($desc).'&amp;search='.urlencode($_REQUEST['search']).'&amp;order='.urlencode($_GET['order']).'&amp;first=1&amp;anzahl=' . urlencode($anzahl),
                '', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
        }

        require(CPO_BASEDIR.'_include/footer.php');
        break;
    }
}