<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

$zugang = 0;
require(CPO_BASEDIR.'_include/check.php');

$views = array('list');
initVar($_SESSION['SID_navigation_select_id'],NULL);
initVar($_GET['id'],NULL);

$actions = array(); 
if (isset($_REQUEST['action'])) 
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'close': // {{{
        if (isset($_SESSION['SID_navigation_opened'][$_GET['id']])) unset($_SESSION['SID_navigation_opened'][$_GET['id']]);
        break; // }}}
    case 'open': // {{{
        $_SESSION['SID_navigation_opened'][$_GET['id']] = true;
        break; // }}}

    case 'navigation_addleft': // {{{
        $_REQUEST['caption']   = '';
        $_REQUEST['rubric_id'] = 0;
        $_REQUEST['settings']  = array();
        $_REQUEST['create'] = 'left';
        $views = array('edit');
        break; // }}}
    case 'navigation_addright': // {{{
        $_REQUEST['caption']   = '';
        $_REQUEST['rubric_id'] = 0;
        $_REQUEST['settings']  = array();
        $_REQUEST['create'] = 'right';
        $views = array('edit');
        break; // }}}
    case 'navigation_addlevel': // {{{
        $_REQUEST['caption']   = '';
        $_REQUEST['rubric_id'] = 0;
        $_REQUEST['settings']  = array();
        $_REQUEST['create'] = 'level';
        $views = array('edit');
        break; // }}}

    case 'navigation_moveleft': // {{{
        // cut marked entry and add right to the chosen ID
        $db = new DB; 
        if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');

        // how many entries to move (difference between left and right value)
        $query = 'SELECT caption, (r-l+1) AS toMove FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db->query($query);
        $db->next_record();
        $toMove = $db->v('toMove');
        $caption = $db->v('caption');

        // get target l
        $query = 'SELECT caption, l FROM '.CPO_NAVTREE." WHERE id='".addslashes($_GET['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $tlid = $db->v('l');
        $caption2 = $db->v('caption');

        // reserve space at target node
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l+'".addslashes($toMove)."' WHERE l>='".addslashes($tlid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r+'".addslashes($toMove)."' WHERE r>'".addslashes($tlid)."'");

        // get source l and r (might have been edited)
        $query = 'SELECT l, r FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $slid = $db->v('l');
        $srid = $db->v('r');

        // move source to target
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-".$slid."+".$tlid.", r=r-".$slid."+".$tlid." WHERE l BETWEEN ".$slid." AND ".$srid);

        // close the gap at the source position
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-'".addslashes($toMove)."' WHERE l>'".addslashes($srid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r-'".addslashes($toMove)."' WHERE r>'".addslashes($srid)."'");

        if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

        $views = array('list');
        $_SESSION['SID_navigation_select_id'] = 0;

        $message[] = sprintf(___('The navigation element %s was successfully moved above element %s.'), 
            '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>', '<em>'.htmlspecialchars($caption2, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('move navigation element', '');
        break; // }}}
    case 'navigation_moveright': // {{{
        // cut marked entry and add right to the chosen ID
        $db = new DB; 
        if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');

        // how many entries to move (difference between left and right value)
        $query = 'SELECT caption, (r-l+1) AS toMove FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db->query($query);
        $db->next_record();
        $toMove = $db->v('toMove');
        $caption = $db->v('caption');

        // get target r
        $query = 'SELECT caption, r FROM '.CPO_NAVTREE." WHERE id='".addslashes($_GET['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $trid = $db->v('r');
        $caption2 = $db->v('caption');

        // reserve space at target node
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l+'".addslashes($toMove)."' WHERE l>'".addslashes($trid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r+'".addslashes($toMove)."' WHERE r>'".addslashes($trid)."'");

        // get source l and r (might have been edited)
        $query = 'SELECT l, r FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $slid = $db->v('l');
        $srid = $db->v('r');

        // move source to target
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-".$slid."+1+".$trid.", r=r-".$slid."+1+".$trid." WHERE l BETWEEN ".$slid." AND ".$srid);

        // close the gap at the source position
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-'".addslashes($toMove)."' WHERE l>'".addslashes($srid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r-'".addslashes($toMove)."' WHERE r>'".addslashes($srid)."'");

        if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

        $views = array('list');
        $_SESSION['SID_navigation_select_id'] = 0;

        $message[] = sprintf(___('The navigation element %s was successfully moved below element %s.'), 
            '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>', '<em>'.htmlspecialchars($caption2, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('move navigation element', '');
        break; // }}}
    case 'navigation_movelevel': // {{{
        // cut marked entry and add below the chosen ID
        $db = new DB; 
        if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');

        // how many entries to move (difference between left and right value)
        $query = 'SELECT caption, (r-l+1) AS toMove FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        $db->query($query);
        $db->next_record();
        $toMove = $db->v('toMove');
        $caption = $db->v('caption');

        // get target l and r
        $query = 'SELECT caption, l FROM '.CPO_NAVTREE." WHERE id='".addslashes($_GET['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $tlid = $db->v('l');
        $caption2 = $db->v('caption');

        // reserve space at target node
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l+'".addslashes($toMove)."' WHERE l>'".addslashes($tlid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r+'".addslashes($toMove)."' WHERE r>'".addslashes($tlid)."'");

        // get source l and r (might have been edited)
        $query = 'SELECT l, r FROM '.CPO_NAVTREE." WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $slid = $db->v('l');
        $srid = $db->v('r');

        // move source to target
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-".$slid."+1+".$tlid.", r=r-".$slid."+1+".$tlid." WHERE l BETWEEN ".$slid." AND ".$srid);

        // close the gap at the source position
        $db->query("UPDATE ".CPO_NAVTREE." SET l=l-'".addslashes($toMove)."' WHERE l>'".addslashes($srid)."'");
        $db->query("UPDATE ".CPO_NAVTREE." SET r=r-'".addslashes($toMove)."' WHERE r>'".addslashes($srid)."'");

        if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

        $views = array('list');
        $_SESSION['SID_navigation_select_id'] = 0;
        
        $message[] = sprintf(___('The navigation element %s was successfully moved to a new sublevel below element %s.'), 
            '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>', '<em>'.htmlspecialchars($caption2, ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('move navigation element', '');
        break; // }}}
    case 'navigation_delete': // {{{
        $query = 'SELECT caption '
                .'FROM '.CPO_NAVTREE.' '
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $caption = $db->v('caption');
        $views = array('reallydelete');
        break; // }}}
    case 'navigation_deletereally': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete navigation element', 'CSRF check failed.');
            break;
        }
        if (isset($_POST['no'])) {
            $query = 'SELECT caption '
                    .'FROM '.CPO_NAVTREE.' '
                    ."WHERE id='".addslashes($_REQUEST['id'])."'";
            $db = new DB; 
            $db->query($query);
            $db->next_record();
            $caption = $db->v('caption');

            $message[] = sprintf(___('The element %s was not deleted.'), 
                '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
            break;
        }

        // which entry to delete
        $query = 'SELECT caption, l, r '
                .'FROM '.CPO_NAVTREE.' '
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $lid = $db->v('l');
        $rid = $db->v('r');
        $caption = $db->v('caption');

        // delete entry and all entries below
        $move = floor(($rid-$lid)/2);
        $move = 2*(1+$move);
        if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
        $db->query("DELETE FROM ".CPO_NAVTREE." WHERE l BETWEEN '".addslashes($lid)."' AND '".addslashes($rid)."'");
        $db->query('UPDATE '.CPO_NAVTREE." SET l = l-".$move." WHERE l>'".addslashes($rid)."' ");
        $db->query("UPDATE ".CPO_NAVTREE." SET r = r-".$move." WHERE r>'".addslashes($rid)."' ");
        if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

        if ($_SESSION['SID_navigation_select_id']==$_GET['id']) $_SESSION['SID_navigation_select_id'] = 0;
        $views = array('list');

        $message[] = sprintf(___('The element %s was successfully deleted.'),
            '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );
        logaction('delete navigation element', '');
        break; // }}}
    case 'navigation_select': // {{{
        $_SESSION['SID_navigation_select_id'] = $_GET['id'];

        break; // }}}
    case 'navigation_edit': // {{{
        // load data from database
        $query = 'SELECT caption, rubric_id, settings '
                .'FROM '.CPO_NAVTREE.' '
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $db->next_record();
        $_REQUEST['caption'] = $db->v('caption');
        $_REQUEST['rubric_id'] = $db->v('rubric_id');
        $_REQUEST['settings'] = unserialize($db->v('settings'));
        if (!is_array($_REQUEST['settings'])) $_REQUEST['settings'] = array();

        $_REQUEST['create'] = '';
        $views = array('edit');

        break; // }}}
    case 'navigation_edit_save': // {{{
        // check data and possibly save it
        $views = array('edit');
        if ($_REQUEST['rubric_id']==0 && trim($_REQUEST['caption'])=='') {
            $message[] = __('Please specify a caption for this element if you do not assign a rubric.');
            break; 
        }
        if ($_REQUEST['rubric_id']>0 && trim($_REQUEST['settings']['externalURL'])!='') {
            $message[] = __('Please note that you can not assign a rubric and an external URL.');
            break; 
        }

        switch ($_REQUEST['create']) {
        case 'left': // {{{
            $query = 'SELECT l '
                    .'FROM '.CPO_NAVTREE.' '
                    ."WHERE id='".addslashes($_REQUEST['id'])."'";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db = new DB; 
            $db->query($query);
            $db->next_record();
            $lid = $db->v('l');

            // add entry
            if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
            $db->query('UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>='".addslashes($lid)."' ");
            $db->query("UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($lid)."' ");
            $db->query("INSERT INTO ".CPO_NAVTREE." (l, r) VALUES ('".addslashes($lid)."', '".addslashes($lid+1)."')");
            if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

            // prepare to edit new entry
            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $_REQUEST['id'] = $db->v('last_insert_id()');
            break; // }}}
        case 'right': // {{{
            $query = 'SELECT r '
                    .'FROM '.CPO_NAVTREE.' '
                    ."WHERE id='".addslashes($_REQUEST['id'])."'";
            DEBUG(1, $query, __FILE__, __LINE__);
            $db = new DB; 
            $db->query($query);
            $db->next_record();
            $rid = $db->v('r');

            // add entry
            if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
            $db->query('UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ");
            $db->query("UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>'".addslashes($rid)."' ");
            $db->query("INSERT INTO ".CPO_NAVTREE." (l, r) VALUES ('".addslashes($rid+1)."', '".addslashes($rid+2)."')");
            if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

            // prepare to edit new entry
            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $_REQUEST['id'] = $db->v('last_insert_id()');
            break; // }}}
        case 'level': // {{{
            $query = 'SELECT r FROM '.CPO_NAVTREE." WHERE id='".addslashes($_REQUEST['id'])."'";
            $_SESSION['SID_navigation_opened'][$_REQUEST['id']] = true;
            $db = new DB; 
            $db->query($query); $db->next_record();
            $rid = $db->v('r');

            // add entry
            if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_NAVTREE.' WRITE');
            $db->query('UPDATE '.CPO_NAVTREE." SET l = l+2 WHERE l>'".addslashes($rid)."' ");
            $db->query("UPDATE ".CPO_NAVTREE." SET r = r+2 WHERE r>='".addslashes($rid)."' ");
            $db->query("INSERT INTO ".CPO_NAVTREE." (l, r) VALUES ('".addslashes($rid)."', '".addslashes($rid+1)."')");
            if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

            $db->query('SELECT last_insert_id()');
            $db->next_record();
            $_REQUEST['id'] = $db->v('last_insert_id()');
            break; // }}}
        }

        $query = 'UPDATE '.CPO_NAVTREE.' '
                ."SET caption = '".addslashes($_REQUEST['caption'])."', " 
                ."rubric_id = '".addslashes($_REQUEST['rubric_id'])."', "
                ."settings = '".addslashes(serialize($_REQUEST['settings']))."' "
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db = new DB; 
        $db->query($query);
        $views = array('list');

        $message[] = sprintf(___('The navigation element %s was successfully saved.'), 
            '<em>'.htmlspecialchars($_REQUEST['caption'], ENT_COMPAT, 'ISO-8859-15').'</em>');
        logaction('edit navigation element', $_REQUEST['caption']);
        break; // }}}
    }
}

include(CPO_BASEDIR.'_include/header.php');

if ($cpoSystem['nolocktables']) $message[] = ___('Please note that a workaround for "LOCK TABLES" is active. You should avoid editing the navigation simultanously with another user.');

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'edit':  // {{{
        require(CPO_BASEDIR.'_views/navigation_edit.inc.php');
        break; // }}}
    case 'list':  // {{{
        require(CPO_BASEDIR.'_views/navigation_list.inc.php');
        break; // }}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Delete navigation element'),
            sprintf(___('In this view you can delete the navigation element %s.'),
                '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            '' // helpme
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the navigation element %s?'),
            '<em>'.htmlspecialchars($caption, ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('navigation_deletereally');
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_GET['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        break; // }}}
    }
}

include(CPO_BASEDIR.'_include/footer.php');