<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true); 
require_once('../_include/checkaccess.inc.php');

// define some vars
initVar($_REQUEST['action'],'');
initVar($_SESSION['filter_users']['enabled'],NULL);
initVar($_SESSION['filter_users']['role'],NULL);
initVar($_SESSION['filter_users']['username'],NULL);
initVar($_SESSION['filter_users']['name'],NULL);
initVar($_SESSION['filter_users']['email'],NULL);
initVar($_SESSION['filter_users']['group'],NULL);
initVar($selfedit,NULL);
initVar($_POST['usergroups_id'],NULL);

$defaultAnzahl = 10;
$anzahl = $defaultAnzahl; // FIXME system settings?
if (isset($_SESSION['SID_pagers']['usersPerPage'])) $anzahl=$_SESSION['SID_pagers']['usersPerPage'];
if (!empty($_GET['anzahl'])) $anzahl = (int)$_GET['anzahl'];

if ($_REQUEST['action']=='setPerPage') {
    if (!$antiCSRF->checkToken()) {
        $message[] = ___('Security check failed. Please try again.');
        logaction('users setPerPage', 'CSRF check failed.');
    } else {
        if ($anzahl!=$_POST['newPerPage'])
            $_SESSION['SID_pagers']['usersPerPage'] = $_POST['newPerPage'];
        $anzahl = $_POST['newPerPage'];
        if (!empty($_REQUEST['defaultAction']))
            $_REQUEST['action'] = $_REQUEST['defaultAction'];
    }
}
if (!empty($_REQUEST['defaultAction'])) 
    $_REQUEST['action'] = $_REQUEST['defaultAction'];

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) 
        ? $actions = $_REQUEST['action'] 
        : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'users_togglefilter':
        $_SESSION['filter_users']['enabled'] = !$_SESSION['filter_users']['enabled'];

        if (!$_SESSION['filter_users']['enabled']) {
            $_SESSION['filter_users']['username'] = '';
            $_SESSION['filter_users']['name'] = '';
            $_SESSION['filter_users']['email'] = '';
            $_SESSION['filter_users']['role'] = -1;
            $_SESSION['filter_users']['group'] = -1;
            $_SESSION['SID_pagers']['users'] = 0;
            $_SESSION['SID_pagers']['users_deleted'] = 0;
        }
        if (isset($_REQUEST['view'])) $views = array($_REQUEST['view']);
        break;
    case 'users_setfilter':
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('users setfilter', 'CSRF check failed.');
            break;
        }
        
        $_SESSION['filter_users']['username'] = $_POST['username'];
        $_SESSION['filter_users']['name'] = $_POST['name'];
        $_SESSION['filter_users']['email'] = $_POST['email'];
        $_SESSION['filter_users']['role'] = $_POST['role'];
        $_SESSION['filter_users']['group'] = $_POST['group'];
        $_SESSION['SID_pagers']['users'] = 0;
        $_SESSION['SID_pagers']['users_deleted'] = 0;
        if (isset($_REQUEST['view'])) $views = array($_REQUEST['view']);
        break;
    case 'users_create': // set default values for a new user {{{
        $_REQUEST['id'] = 0;
        $_POST['user'] = '';
        $_POST['name'] = '';
        $_POST['usergroups_id'] = 0;
        $_POST['admin'] = 0;
        $_POST['user_language'] = '';
        $_POST['edit_initial'] = '';
        $_POST['edit_email'] = '';
        $_POST['passwdold'] = '';
        $_POST['passwd'] = '';
        $_POST['passwd2'] = '';
        $views = array('edit_form');
        break;
        // }}}
    case 'users_self_modify': // users_modify; load values for existing user from database {{{
        $selfedit = true;
    case 'users_modify':
        if (!isset($selfedit)) $selfedit = false;
        $_POST['user'] = '';
        $_POST['name'] = '';
        $_POST['usergroups_id'] = 0;
        $_POST['admin'] = 0;
        $_POST['user_language'] = '';
        $_POST['edit_initial'] = '';
        $_POST['edit_email'] = '';
        $_POST['passwdold'] = '';
        $_POST['passwd'] = '';
        $_POST['passwd2'] = '';

        $db = new db;
        $db->query('SELECT user, name, email, initial, admin, usergroups_id, passwd, language '
                  .'FROM '.CPO_USER.' '
                  ."WHERE id='".addslashes($_REQUEST['id'])."' "
                  .'ORDER BY user');
        while ($db->next_record()) { 
            $_POST['user']          = $db->v('user');
            $_POST['name']          = $db->v('name');
            $_POST['usergroups_id'] = $db->v('usergroups_id');
            $_POST['admin']         = $db->v('admin');
            $_POST['user_language']          = $db->v('language');
            $_POST['edit_initial']  = $db->v('initial');
            $_POST['edit_email']    = $db->v('email');
            $_POST['passwdold']     = substr($db->v('passwd'), 6);
            $_POST['passwd']        = substr($db->v('passwd'), 6);
            $_POST['passwd2']       = substr($db->v('passwd'), 6);
        }            
        $views = array('edit_form');
        break;
        // }}}
    case 'users_self_save': // store user data in database {{{
    case 'users_save': 
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            if (!empty($_REQUEST['id'])) {
                logaction('edit user', 'CSRF check failed.');
            } else {
                logaction('create user', 'CSRF check failed.');            
            }
            $views = array('edit_form');
            break;
        }

        $error = false;

        // on creation check if user already exists
        if ($_REQUEST['id']==0) {
            $db = new db;
            $db->query('SELECT id '
                      .'FROM '.CPO_USER.' '
                      ."WHERE user='".addslashes($_POST['user'])."'");
            if ($db->next_record()) {
                $message['exists'] = __('A user with this username already does exist. Please choose a different username.');
                if ($db->v('id')<0) 
                    $message['exists'] = __('A deactivated user with this username already does exist. Please choose a different username.');
                $views = array('edit_form');
                break;
            }
        }

        // was a username specified?
        if (!$error && trim($_POST['user'])=='') {
            $message[] = __('Please specify a login for the user.');
            $error = true;
        }

        // was a name specified?
        if (trim($_POST['name'])=='') {
            $message[] = __('Please enter a name for this user.');
            $error = true;
        }

        // are the passwords correct?
        if (trim($_POST['passwd'])=='' || $_POST['passwd']!=$_POST['passwd2'] ) {
            $message[] = __('Please enter a password and make sure that both passwords match.');
            $error = true;
        }

        // error found, display form again
        if ($error) {
            $views = array('edit_form');
            break;
        }

        // create user 
        $db = new DB;
        $query = '';
        if (!empty($_REQUEST['id'])) {
            // edit user
            $query = 'UPDATE '.CPO_USER.' SET '
                    ."user = '".addslashes($_POST['user'])."', "
                    ."name = '".addslashes($_POST['name'])."', "
                    ."initial = '".addslashes($_POST['edit_initial'])."', "
                    ."email = '".addslashes($_POST['edit_email'])."', "
                    ."language = '".addslashes($_POST['user_language'])."', "
                    ."admin = '".addslashes($_POST['admin'])."', "
                    ."usergroups_id = '".addslashes($_POST['usergroups_id'])."' ";

            // add new password if it was edited
            if ($_POST['passwdold']!=$_POST['passwd']) {
                $query .= ", passwd = '".md5($_POST['passwd'])."'";
            }

            $query .= " WHERE id='".addslashes($_REQUEST['id'])."'";

            $db->query($query);

            $message[] = sprintf(__('The user %s was successfully modified.'),
                            '<em>'.htmlspecialchars(formatUserName($_REQUEST['id'], $_POST['user'], $_POST['name']), ENT_COMPAT, 'ISO-8859-15').'</em>');
            logaction('edit user', $_POST['user']);

        } else {
            // create user
            if (!$cpoSystem['nolocktables']) $db->query('LOCK TABLES '.CPO_USER.' WRITE');

            // find maximum id manually as it foobars with auto_increment and negative values
            $db->query('SELECT MAX(ABS(id))+1 as newid FROM '.CPO_USER.' ');
            $db->next_record();
            $newid = $db->v('newid');

            $query = "INSERT INTO ".CPO_USER." "
                    ."(id, user, name, initial, email, language, admin, usergroups_id, passwd) VALUES (" //, c_time, changer) VALUES ("
                    .(int)$newid.', '
                    ."'".addslashes($_POST['user'])."', "
                    ."'".addslashes($_POST['name'])."', "
                    ."'".addslashes($_POST['edit_initial'])."', "
                    ."'".addslashes($_POST['edit_email'])."', "
                    ."'".addslashes($_POST['user_language'])."', "
                    ."'".addslashes($_POST['admin'])."', "
                    ."'".addslashes($_POST['usergroups_id'])."', "
                    ."'".md5($_POST['passwd'])."') ";
            $db->query($query);
            if (!$cpoSystem['nolocktables']) $db->query('UNLOCK TABLES');

            $message[] = sprintf(__('The user %s was successfully created.'),
                            '<em>'.htmlspecialchars(formatUserName(1, $_POST['user'], $_POST['name']), ENT_COMPAT, 'ISO-8859-15').'</em>');

            logaction('create user', $_POST['user']);
        }

        $views = array('list');
        if ($nextaction=='users_self_save') $views = array('edit_form');
        
        break;
        // }}}
    case 'users_delete': // {{{
        $db = new DB;
        $db->query("SELECT user, name, email "
                  ."FROM ".CPO_USER." "
                  ."WHERE id='".addslashes($_GET['id'])."'");
        $db->next_record();
        $user = $db->v('user');
        $name = $db->v('name');
        $email = $db->v('email');
        $views = array('reallydelete');
        break; // }}}
    case 'users_delete_really': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('deactivate user', 'CSRF check failed.');
            break;
        }

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The user %s was not deactivated.'), 
                '<em>'.htmlspecialchars(formatUsername($_POST['id'], $_POST['user'], $_POST['name'], $_POST['email']), ENT_COMPAT, 'ISO-8859-15').'</em>'
            );
            break;
        }

        $querys = array();
        $querys[] = 'UPDATE '.CPO_USER.' SET id=-id WHERE id='.(int)$_POST['id'];
        $querys[] = 'DELETE FROM '.CPO_PERMISSION.' WHERE user_id='.(int)$_POST['id'];
        $querys[] = 'UPDATE '.CPO_NEWS.' SET released_user_id=-released_user_id WHERE released_user_id='.(int)$_POST['id'];
        $querys[] = 'UPDATE '.CPO_SNIPPET      .' SET user_id=-user_id WHERE user_id='.(int)$_POST['id'];
        $querys[] = 'UPDATE '.CPO_LOG_LOGIN    .' SET user_id=-user_id WHERE user_id='.(int)$_POST['id']; // FIXME what happens if a logged in user gets deleted?
        $querys[] = 'UPDATE '.CPO_DATA         .' SET user_id=-user_id WHERE user_id='.(int)$_POST['id'];
        $querys[] = 'UPDATE '.CPO_PAGETEMPLATES.' SET user_id=-user_id WHERE user_id='.(int)$_POST['id'];

        $db = new DB;
        foreach ($querys as $v) $db->query($v);

        $message[] = sprintf(___('The user %s was successfully deactivated.'),
            '<em>'.htmlspecialchars(formatUsername($_POST['id'], $_POST['user'], $_POST['name'], $_POST['email']), ENT_COMPAT, 'ISO-8859-15').'</em>'
        );
        logaction('deactivate user', $_POST['user']);
        break; // }}}
    case 'users_reactivate': // {{{
        $querys = array();
        $querys[] = 'UPDATE '.CPO_USER.' SET id=-id WHERE id='.(int)$_GET['id'];
        $querys[] = 'UPDATE '.CPO_SNIPPET.' SET user_id=-user_id WHERE user_id='.(int)$_GET['id'];
        //$querys[] = 'DELETE FROM '.CPO_PERMISSION.' WHERE user_id='.(int)$_GET['id'];
        $querys[] = 'UPDATE '.CPO_NEWS.' SET released_user_id=-released_user_id WHERE released_user_id='.(int)$_GET['id'];
        $querys[] = 'UPDATE '.CPO_LOG_LOGIN.' SET user_id=-user_id WHERE user_id='.(int)$_GET['id']; // FIXME what happens if a logged in user gets deleted?
        $querys[] = 'UPDATE '.CPO_DATA.' SET user_id=-user_id WHERE user_id='.(int)$_GET['id'];
        $querys[] = 'SELECT user, name, email FROM '.CPO_USER.' WHERE id='.(int)(-$_GET['id']);

        $db = new DB;
        foreach ($querys as $v) $db->query($v);
        $db->next_record();

        $message[] = sprintf(___('The user %s was successfully reactivated. Please note that you have to %sset the rights%s for this user again.'),
            '<em>'.htmlspecialchars(formatUsername($_GET['id'], $db->v('user'), $db->v('name'), $db->v('email')), ENT_COMPAT, 'ISO-8859-15').'</em>',
            '<a href="'.BASE_REL.'_admin/user_rights.php?user_id='.(int)(-$_GET['id']).'">',
            '</a>'
        );
        logaction('reactivate user', $db->v('user'));
        break; // }}}
    case 'users_list_deactivated': // {{{
        $views = array('list_deactivated');
        break; // }}}
    }
}

include_once(CPO_BASEDIR.'_include/header.php');

if (!isset($views)) $views = array('list');
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        // get maximum count of users
        $db->query('SELECT COUNT(*) '
                  .'FROM '.CPO_USER.' '
                  .'WHERE id>=0 ' .
                   (!empty($_SESSION['filter_users']['username']) ? "AND user LIKE '%" . addslashes($_SESSION['filter_users']['username']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['name'])     ? "AND name LIKE '%" . addslashes($_SESSION['filter_users']['name']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['email'])     ? "AND email LIKE '%" . addslashes($_SESSION['filter_users']['email']) . "%' " : '') .
                   (isset($_SESSION['filter_users']['role']) && $_SESSION['filter_users']['role']!=-1 ? "AND admin =     " . (int)$_SESSION['filter_users']['role'] . " " : '') .
                   (isset($_SESSION['filter_users']['group']) && $_SESSION['filter_users']['group']!=-1 ? "AND usergroups_id=" . (int)$_SESSION['filter_users']['group'] . " " : '')
        ); 
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        if (isset($_GET['pos'])) {
            $_SESSION['SID_pagers']['users'] = $_GET['pos'];
        }
        // make sure we are not behind the last entry
        if ($max_data<=$_SESSION['SID_pagers']['users']) {
            $_SESSION['SID_pagers']['users'] = $max_data-1;
        }
        if ($_SESSION['SID_pagers']['users']<0) {
            $_SESSION['SID_pagers']['users'] = 0;
        }

        $db = new db;
        $db->query('SELECT id, usergroup '
                  .'FROM '.CPO_USERGROUPS);
        while ($db->next_record()) {
            $usergroups[$db->v('id')] = $db->v('usergroup');
        }
        $db->query('SELECT id, user, admin, name, email, usergroups_id ' .
                   'FROM '.CPO_USER.' ' .
                   'WHERE id>=0 ' .
                   (!empty($_SESSION['filter_users']['username']) ? "AND user LIKE '%" . addslashes($_SESSION['filter_users']['username']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['name'])     ? "AND name LIKE '%" . addslashes($_SESSION['filter_users']['name']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['email'])     ? "AND email LIKE '%" . addslashes($_SESSION['filter_users']['email']) . "%' " : '') .
                   (isset($_SESSION['filter_users']['role']) && $_SESSION['filter_users']['role']!=-1   ? "AND admin = "       . (int)$_SESSION['filter_users']['role'] . " " : '') .
                   (isset($_SESSION['filter_users']['group']) && $_SESSION['filter_users']['group']!=-1 ? "AND usergroups_id=" . (int)$_SESSION['filter_users']['group'] . " " : '') .
                   'ORDER BY user ' .
                   ($anzahl!='all' ? 'LIMIT '.$_SESSION['SID_pagers']['users'].', '.$anzahl : ''));
        if ($db->num_rows()<=0) {
            $message[] = __('No users found.');
        } 

        printPageHeader(
            __('Work on users'),
            __('In this view you can choose a user for editing or delete it.'),
            'users-workonusers.html#users-workonusers'
        );
        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="colored" style="width: 100%"><thead><tr>');
        if (!$_SESSION['filter_users']['enabled']) {
            printf('<th><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>',
                $_SERVER['PHP_SELF'].'?action=users_togglefilter&amp;anzahl=' . urlencode($anzahl),
                ___('Enable filter'),
                help('') // helpme
            );
            print('</tr></thead></table>');
        } else {
            printf('<th colspan="2"><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>', 
                $_SERVER['PHP_SELF'].'?action=users_togglefilter&amp;anzahl=' . urlencode($anzahl),
                ___('Disable filter'), 
                help('') // helpme
            );
            print('</tr></thead><tbody><tr>');
            ?>
            <form method="post" action="<?php print($_SERVER['PHP_SELF']); ?>">
                <td class="leftrow"><?php print(__('Filter by username:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="username" size="25" value="<?php 
                        echo htmlspecialchars($_SESSION['filter_users']['username'], ENT_COMPAT, 'ISO-8859-15'); ?>"> 
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by name:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="name" size="25" value="<?php
                        echo htmlspecialchars($_SESSION['filter_users']['name'], ENT_COMPAT, 'ISO-8859-15'); ?>">
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by email:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="email" size="25" value="<?php
                        echo htmlspecialchars($_SESSION['filter_users']['email'], ENT_COMPAT, 'ISO-8859-15'); ?>">
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by role:')); ?></td>
                <td class="rightrow">
                    <select name="role">
                    <?php
                    $roles = array(
                        '-1'             => 'All',
                        ROLE_MEMBER      => 'Member',
                        ROLE_EDITOR      => 'Editor',
                        ROLE_CHIEFEDITOR => 'Chief editor',
                        ROLE_SUPERUSER   => 'Superuser',
                        ROLE_ADMIN       => 'Admin');
                    foreach ($roles as $k=>$v) {
                        echo '<option value="' . $k . '" ' . ($_SESSION['filter_users']['role']===(string)$k ? ' selected' : '') .
                             '>' . ___($v) . '</option>';
                    }
                    ?></select>
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by group:')); ?></td>
                <td class="rightrow">
                    <select name="group">
                    <?php
                    echo '<option value="-1"' . ($_SESSION['filter_users']['group']==-1 ? ' selected' : '') .'>' . ___('All') . '</option>';
                    echo '<option value="0"' . ($_SESSION['filter_users']['group']==0 ? ' selected' : '') .'>' . ___('None') . '</option>';
                    $dbug = new DB;
                    $dbug->query('SELECT id, usergroup FROM ' . CPO_USERGROUPS . ' ORDER BY usergroup');
                    while ($dbug->next_record()) {
                        echo '<option value="' . $dbug->v('id') . '" ' . ($_SESSION['filter_users']['group']==$dbug->v('id') ? ' selected' : '') .
                             '>' . htmlspecialchars($dbug->v('usergroup'), ENT_COMPAT, 'ISO-8859-15') . '</option>';
                    }
                    ?></select>
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td>&nbsp;</td>
                <td>
                    <?php $antiCSRF->printInput('users_setfilter'); ?>
                    <input type="hidden" name="anzahl" value="<?php echo htmlspecialchars($anzahl, ENT_COMPAT, 'ISO-8859-15'); ?>">
                    <input type="submit" class="button" name="submit" value="<?php print(___('Set filter parameters')); ?>" />
                </td>
            </tr></form></tbody></table><br />
        <?php
        }

        if ($db->num_rows()<=0) break; 

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='top')  {
            next_page(
                $_SESSION['SID_pagers']['users'],
                $max_data,
                $anzahl,
                true,
                'anzahl=' . urlencode($anzahl),
                BASE_REL . '_admin/users.php', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
            echo '<br />';
        }

        echo '<table class="ruler" style="width: 100%"><thead><tr>';
        echo '<th style="width: 20%;"><span>'.___('Username')
            .help('users-workonusers.html#users-workonusers-username').'</span></th>';
        echo '<th style="width:  5%;"><span>'.___('Manage')
            .help('users-workonusers.html#users-workonusers-manage').'</span></th>';
        echo '<th style="width: 41%;"><span>'.___('Name')
            .help('users-workonusers.html#users-workonusers-name').'</span></th>';
        echo '<th style="width: 17%;"><span>'.___('Role')
            .help('users-workonusers.html#users-workonusers-role').'</span></th>';
        echo '<th style="width: 17%;"><span>'.___('Group')
            .help('users-workonusers.html#users-workonusers-group').'</span></th>';
        echo '</tr></thead><tbody>';

        while ($db->next_record()) {
            echo '<tr>';

            // FIXME it's possible to edit if the uid is used everywhere
            echo '<td>'.htmlspecialchars($db->v('user'), ENT_COMPAT, 'ISO-8859-15').'</td>';

            echo '<td>';
            // everyone above ROLE_SUPERUSER can edit users
            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                if ($_SESSION['SID_user']['admin']>=$db->v('admin')) {
                    printIcon(BASE_REL.'_admin/users.php'
                        .'?action=users_modify&id='.$db->v('id'), 
                        SKIN_URL.'pic_edit.gif', 
                        __('edit user'),
                        true
                    );
                } else {
                    printIcon(BASE_REL.'_admin/users.php'
                        .'?action=users_modify&id='.$db->v('id'), 
                        SKIN_URL.'pic_edit.gif', 
                        __('You are not allowed to edit users of a higher role.'),
                        false
                    );
                }
                if ($db->v('admin')>ROLE_MEMBER) {
                    if ($_SESSION['SID_user']['admin']>=$db->v('admin')) {
                        printIcon(BASE_REL.'_admin/user_rights.php'
                            .'?user_id='.$db->v('id'), 
                            SKIN_URL.'pic_rights.gif', 
                            __('edit user rights'),
                            true
                        );
                    } else {
                        printIcon(BASE_REL.'_admin/user_rights.php'
                            .'?user_id='.$db->v('id'), 
                            SKIN_URL.'pic_rights.gif', 
                            __('You are not allowed to edit users of a higher role.'),
                            false
                        );
                    }
                } else {
                    printIcon(BASE_REL.'_admin/user_rights.php'
                        .'?user_id='.$db->v('id'), 
                        SKIN_URL.'pic_rights.gif', 
                        __('Members do not have rubric rights.'),
                        false
                    );
                }
                if ($_SESSION['SID_user']['id']!=$db->v('id') 
                    && $_SESSION['SID_user']['admin']>=$db->v('admin')) {
                    printIcon(BASE_REL.'_admin/users.php?action=users_delete&id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15'),
                        SKIN_URL.'pic_del.gif', 
                        __('deactivate user'),
                        true
                    );
                }  else {
                    $note = '';
                    if ($_SESSION['SID_user']['id']==$db->v('id'))
                        $note .= __('You are not allowed to deactivate yourself.').' ';
                    if ($_SESSION['SID_user']['admin']<$db->v('admin'))
                        $note .= __('You are not allowed to deactivate users of a higher role.').' ';

                    printIcon('',
                        SKIN_URL.'pic_del.gif', 
                        $note,
                        false
                    );
                }
            }

            echo '</td>';
            $_t = '';
            if ($db->v('email')!='') {
                $_t = '<a href="mailto:'.$db->v('email').'">'

                     .'<img src="'.SKIN_URL.'mail.gif" width="15" height="7" '
                     .'alt="'  .htmlspecialchars($db->v('email'), ENT_COMPAT, 'ISO-8859-15').'" '
                     .'title="'.htmlspecialchars($db->v('email'), ENT_COMPAT, 'ISO-8859-15').'">'

                     .'</a>';
            } 
            echo '<td>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').' '.$_t.'</td>';
            switch ($db->v('admin')) { 
            case ROLE_MEMBER:
                echo '<td>'.___('Member').'</td>';
                break; 
            case ROLE_EDITOR: 
                echo '<td>'.___('Editor').'</td>';
                break;  
            case ROLE_CHIEFEDITOR:
                echo '<td>'.___('Chief editor').'</td>';
                break;
            case ROLE_SUPERUSER:
                echo '<td>'.___('Superuser').'</td>';
                break;
            case ROLE_ADMIN:
                echo '<td>'.___('Admin').'</td>';
                break;  
            }
            $_t = '-'; 
            if ($db->v('usergroups_id')!=0) { 
                $_t = $usergroups[$db->v('usergroups_id')]; 
            }
            echo '<td>'.htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15').'</td>';
        }

        echo '</tbody></tr></table>';

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='bottom')  {
            next_page(
                $_SESSION['SID_pagers']['users'],
                $max_data,
                $anzahl,
                true,
                'anzahl=' . urlencode($anzahl),
                BASE_REL . '_admin/users.php', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
        }

        break; // }}}
    case 'list_deactivated': // {{{
        // get maximum count of users
        $db->query('SELECT COUNT(*) '
                  .'FROM '.CPO_USER.' '
                  .'WHERE id<0 ' .
                   (!empty($_SESSION['filter_users']['username']) ? "AND user LIKE '%" . addslashes($_SESSION['filter_users']['username']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['name'])     ? "AND name LIKE '%" . addslashes($_SESSION['filter_users']['name']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['email'])     ? "AND email LIKE '%" . addslashes($_SESSION['filter_users']['email']) . "%' " : '') .
                   (isset($_SESSION['filter_users']['role']) && $_SESSION['filter_users']['role']!=-1   ? "AND admin = "       . (int)$_SESSION['filter_users']['role'] . " " : '') .
                   (isset($_SESSION['filter_users']['group']) && $_SESSION['filter_users']['group']!=-1 ? "AND usergroups_id=" . (int)$_SESSION['filter_users']['group'] . " " : '')
        );
        $db->next_record();
        $max_data = $db->v('COUNT(*)');

        if (isset($_GET['pos'])) {
            $_SESSION['SID_pagers']['users_deleted'] = $_GET['pos'];
        }

        if (!isset($_SESSION['SID_pagers']['users_deleted']) 
            || $_SESSION['SID_pagers']['users_deleted']<0) {
            $_SESSION['SID_pagers']['users_deleted'] = 0;
        }

        // make sure we are not behind the last entry
        if ($max_data<=$_SESSION['SID_pagers']['users_deleted']) {
            $_SESSION['SID_pagers']['users_deleted'] = $max_data>0 ? $max_data-1 : 0;
        }

        $db = new db;
        $db->query('SELECT id, usergroup '
                  .'FROM '.CPO_USERGROUPS);
        while ($db->next_record()) {
            $usergroups[$db->v('id')] = $db->v('usergroup');
        }

        $db->query('SELECT id, user, admin, name, email, usergroups_id ' .
                   'FROM ' . CPO_USER . ' ' .
                   'WHERE id<0 ' .
                   (!empty($_SESSION['filter_users']['username']) ? "AND user LIKE '%" . addslashes($_SESSION['filter_users']['username']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['name'])     ? "AND name LIKE '%" . addslashes($_SESSION['filter_users']['name']) . "%' " : '') .
                   (!empty($_SESSION['filter_users']['email'])     ? "AND email LIKE '%" . addslashes($_SESSION['filter_users']['email']) . "%' " : '') .
                   (isset($_SESSION['filter_users']['role']) && $_SESSION['filter_users']['role']!=-1   ? "AND admin = "       . (int)$_SESSION['filter_users']['role'] . " " : '') .
                   (isset($_SESSION['filter_users']['group']) && $_SESSION['filter_users']['group']!=-1 ? "AND usergroups_id=" . (int)$_SESSION['filter_users']['group'] . " " : '') .
                   'ORDER BY user ' .
                   ($anzahl!='all' ? 'LIMIT '.$_SESSION['SID_pagers']['users_deleted'].', '.$anzahl : ''));
        if ($db->num_rows()<=0) {
            $message[] = __('No users found.');
        } 

        printPageHeader(
            __('Reactivate users'),
            __('In this view you can reactivate users.'),
            'users-reactivateusers.html#users-reactivateusers'
        );
        include(CPO_BASEDIR.'_include/message.php');

        print('<table class="colored" style="width: 100%"><thead><tr>');
        if (!$_SESSION['filter_users']['enabled']) {
            printf('<th><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>',
                $_SERVER['PHP_SELF'].'?action=users_togglefilter&amp;view=list_deactivated&amp;anzahl=' . urlencode($anzahl),
                ___('Enable filter'),
                help('') // helpme
            );
            print('</tr></thead></table>');
        } else {
            printf('<th colspan="2"><span><a href="%1$s">'
                  .'<img src="'.SKIN_URL.'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
                  .'&nbsp;<a href="%1$s">%2$s</a>%3$s<span></th>', 
                $_SERVER['PHP_SELF'].'?action=users_togglefilter&amp;view=list_deactivated&amp;anzahl=' . urlencode($anzahl),
                ___('Disable filter'), 
                help('') // helpme
            );
            print('</tr></thead><tbody><tr>');
            ?>
            <form method="post" action="<?php print($_SERVER['PHP_SELF']); ?>">
                <td class="leftrow"><?php print(__('Filter by username:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="username" size="25" value="<?php 
                        echo htmlspecialchars($_SESSION['filter_users']['username'], ENT_COMPAT, 'ISO-8859-15'); ?>"> 
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by name:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="name" size="25" value="<?php
                        echo htmlspecialchars($_SESSION['filter_users']['name'], ENT_COMPAT, 'ISO-8859-15'); ?>">
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by email:')); ?></td>
                <td class="rightrow">
                    <input type="text" name="email" size="25" value="<?php
                        echo htmlspecialchars($_SESSION['filter_users']['email'], ENT_COMPAT, 'ISO-8859-15'); ?>">
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by role:')); ?></td>
                <td class="rightrow">
                    <select name="role">
                    <?php
                    $roles = array(
                        '-1'             => 'All',
                        ROLE_MEMBER      => 'Member',
                        ROLE_EDITOR      => 'Editor',
                        ROLE_CHIEFEDITOR => 'Chief editor',
                        ROLE_SUPERUSER   => 'Superuser',
                        ROLE_ADMIN       => 'Admin');
                    foreach ($roles as $k=>$v) {
                        echo '<option value="' . $k . '" ' . ($_SESSION['filter_users']['role']===(string)$k ? ' selected' : '') .
                             '>' . ___($v) . '</option>';
                    }
                    ?></select>
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td class="leftrow"><?php print(__('Filter by group:')); ?></td>
                <td class="rightrow">
                    <select name="group">
                    <?php
                    echo '<option value="-1"' . ($_SESSION['filter_users']['group']==-1 ? ' selected' : '') .'>' . ___('All') . '</option>';
                    echo '<option value="0"' . ($_SESSION['filter_users']['group']==0 ? ' selected' : '') .'>' . ___('None') . '</option>';
                    $dbug = new DB;
                    $dbug->query('SELECT id, usergroup FROM ' . CPO_USERGROUPS . ' ORDER BY usergroup');
                    while ($dbug->next_record()) {
                        echo '<option value="' . $dbug->v('id') . '" ' . ($_SESSION['filter_users']['group']==$dbug->v('id') ? ' selected' : '') .
                             '>' . htmlspecialchars($dbug->v('usergroup'), ENT_COMPAT, 'ISO-8859-15') . '</option>';
                    }
                    ?></select>
                        <?php echo help(''); //helpme ?>
                </td>
            </tr><tr>
                <td>&nbsp;</td>
                <td>
                    <?php $antiCSRF->printInput('users_setfilter'); ?>
                    <input type="hidden" name="view" value="list_deactivated" />
                    <input type="hidden" name="anzahl" value="<?php echo htmlspecialchars($anzahl, ENT_COMPAT, 'ISO-8859-15'); ?>" />
                    <input type="submit" class="button" name="submit" value="<?php print(___('Set filter parameters')); ?>" />
                </td>
            </tr></form></tbody></table>
        <?php
        }
        
        if ($db->num_rows()<=0) break;

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='top')  {
            next_page(
                $_SESSION['SID_pagers']['users_deleted'],
                $max_data,
                $anzahl,
                true,
                'defaultAction=users_list_deactivated&amp;anzahl=' . urlencode($anzahl),
                BASE_REL . '_admin/users.php', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
            echo '<br />';
        }

        echo '<table class="ruler" style="width: 100%"><thead><tr>';
        echo '<th style="width: 20%;"><span>'.___('Username')
            .help('users-workonusers.html#users-workonusers-username').'</span></th>';
        echo '<th style="width:  5%;"><span>'.___('Manage')
            .help('users-workonusers.html#users-workonusers-manage').'</span></th>';
        echo '<th style="width: 41%;"><span>'.___('Name')
            .help('users-workonusers.html#users-workonusers-name').'</span></th>';
        echo '<th style="width: 17%;"><span>'.___('Role')
            .help('users-workonusers.html#users-workonusers-role').'</span></th>';
        echo '<th style="width: 17%;"><span>'.___('Group')
            .help('users-workonusers.html#users-workonusers-group').'</span></th>';
        echo '</tr></thead><tbody>';

        while ($db->next_record()) {
            echo '<tr>';

            // Username
            // FIXME it's possible to edit if the uid is used everywhere
            echo '<td>'.htmlspecialchars($db->v('user'), ENT_COMPAT, 'ISO-8859-15').'</td>';

            echo '<td>';
            // everyone above ROLE_SUPERUSER can edit users
            if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
                if ($_SESSION['SID_user']['admin']>=$db->v('admin')) {
                    printIcon(BASE_REL.'_admin/users.php'
                        .'?action=users_reactivate&id='.$db->v('id'), 
                        SKIN_URL.'pic_restore.gif', 
                        __('reactivate user'),
                        true
                    );
                } else {
                    printIcon(BASE_REL.'_admin/users.php'
                        .'?action=users_reactivate&id='.$db->v('id'), 
                        SKIN_URL.'pic_restore.gif', 
                        __('reactivate user'),
                        false
                    );
                }
            }

            echo ' </td>';

            $_t = '';
            if ($db->v('email')!='') {
                $_t = '<a href="mailto:'.$db->v('email').'">'

                     .'<img src="'.SKIN_URL.'mail.gif" width="15" height="7" '
                     .'alt="'  .htmlspecialchars($db->v('email'), ENT_COMPAT, 'ISO-8859-15').'" '
                     .'title="'.htmlspecialchars($db->v('email'), ENT_COMPAT, 'ISO-8859-15').'">'

                     .'</a>';
            } 
            echo '<td>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').' '.$_t.'</td>';

            switch ($db->v('admin')) { 
            case ROLE_MEMBER:
                echo '<td>'.___('Member').'</td>';
                break; 
            case ROLE_EDITOR: 
                echo '<td>'.___('Editor').'</td>';
                break;  
            case ROLE_CHIEFEDITOR:
                echo '<td>'.___('Chief editor').'</td>';
                break;
            case ROLE_SUPERUSER:
                echo '<td>'.___('Superuser').'</td>';
                break;
            case ROLE_ADMIN:
                echo '<td>'.___('Admin').'</td>';
                break;  
            }

            $_t = '-'; 
            if ($db->v('usergroups_id')!=0) { 
                $_t = $usergroups[$db->v('usergroups_id')]; 
            }
            echo '<td>'.htmlspecialchars($_t, ENT_COMPAT, 'ISO-8859-15').'</td>';
        }

        echo '</tbody></tr></table>';

        if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='bottom')  {
            next_page(
                $_SESSION['SID_pagers']['users_deleted'],
                $max_data,
                $anzahl,
                true,
                'defaultAction=users_list_deactivated&amp;anzahl=' . urlencode($anzahl),
                BASE_REL . '_admin/users.php', // $targetURL
                array(), // $tl
                $defaultAnzahl // $defaultperPage
            );
        }

        break; // }}}
    case 'edit_form': // {{{
        switch (true) {
        case ($_REQUEST['id']==0):
            printPageHeader(
                __('Create user'),
                __('In this view you can create a new user.'),
                'users-createuser.html#users-createuser'
            );
            break;
        case ($_REQUEST['id']==$_SESSION['SID_user']['id']):
            printPageHeader(
                __('Edit personal settings'),
                __('In this view you can edit your personal settings.'),
                'users-editpersonalsettings.html#users-editpersonalsettings'
            );
            break;
        default:
            printPageHeader(
                __('Edit user'),
                sprintf(__('In this view you can edit the settings for the user %s.'), 
                    '<em>'.htmlspecialchars(formatUserName($_REQUEST['id'], $_POST['user'], $_POST['name']), ENT_COMPAT, 'ISO-8859-15').'</em>'),
                'users-workonusers.html#users-workonusers-editusersettings'
            );
        }
        include(CPO_BASEDIR.'_include/message.php');

        echo '<form method="post" action="'.htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15').'" name="newsentry">';
        if ($selfedit) $antiCSRF->printInput('users_self_save');
        else           $antiCSRF->printInput('users_save');
        echo '<input type="hidden" name="id" value="'.htmlspecialchars($_REQUEST['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        echo '<table class="colored" style="width: 100%;"><thead><tr>';
        echo '<th colspan="2"><span>'.___('User').'</span></th>';
        echo '</tr></thead></tbody>';

        echo '<tr><td class="leftrow">'.___('Login:').'</td>';
        echo '<td class="rightrow">';
        if ($_REQUEST['id']<=0) {
            echo '<input type="text" name="user" value="'.htmlspecialchars($_POST['user'], ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255" />';
            echo help('users-workonusers.html#users-workonusers-editusersettings-login'); 
        } else { 
            echo '<input type="hidden" name="user" value="'.htmlspecialchars($_POST['user'], ENT_COMPAT, 'ISO-8859-15').'" />'
                .htmlspecialchars($_POST['user'], ENT_COMPAT, 'ISO-8859-15');
        }
        echo '</td></tr>';
        echo '<tr><td class="leftrow">'.___('Name:').'</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" name="name" value="'.htmlspecialchars($_POST['name'], ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255">';
        echo help('users-workonusers.html#users-workonusers-editusersettings-name'); 
        echo '</td></tr>';
        $db = new DB;
        $db->query('SELECT id, usergroup FROM '.CPO_USERGROUPS);
    
        if ($db->num_rows()>0) { 
            if ($_SESSION['SID_user']['admin']<ROLE_SUPERUSER) {
                echo '<input type="hidden" name="usergroups_id" value="'.htmlspecialchars($_POST['usergroups_id'], ENT_COMPAT, 'ISO-8859-15').'" />';
            } else {
                echo '<tr><td class="leftrow">'.___('Group:').'</td>';
                echo '<td class="rightrow">';
                echo '<select name="usergroups_id" size="1">';
                echo '<option value=""'
                    .($_POST['usergroups_id']=='' ? ' selected' : '').'>'
                    .___('no group').'</option>';
                echo '<option value="">------------------------</option>';
                while($db->next_record()) {
                    echo '<option value="'.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15').'"'
                        .($_POST['usergroups_id']==$db->v('id') ? ' selected' : '').'>'
                        .htmlspecialchars($db->v('usergroup'), ENT_COMPAT, 'ISO-8859-15').'</option>';
                }
                echo '</select>';
                echo help('users-workonusers.html#users-workonusers-editusersettings-group'); 
                echo '</td></tr>';
            }
        } 
        if ($_SESSION['SID_user']['admin']<ROLE_SUPERUSER) {
            echo '<input type="hidden" name="admin" value="'.htmlspecialchars($_POST['admin'], ENT_COMPAT, 'ISO-8859-15').'" />';
        } else {
            echo '<tr><td class="leftrow">'.___('Role:').'</td>';
            echo '<td class="rightrow">';
            echo '<select name="admin" size="1">';
            echo '<option value="'.ROLE_MEMBER.'" '
                .($_POST['admin']==ROLE_MEMBER ? 'selected' : '').'>'
                .___('Member').'</option>';
            echo '<option value="'.ROLE_EDITOR.'" '
                .($_POST['admin']==ROLE_EDITOR ? 'selected' : '').'>'
                .___('Editor').'</option>';
            echo '<option value="'.ROLE_CHIEFEDITOR.'" '
                .($_POST['admin']==ROLE_CHIEFEDITOR ? 'selected' : '').'>'
                .___('Chief editor').'</option>';
            echo '<option value="'.ROLE_SUPERUSER.'" '
                .($_POST['admin']==ROLE_SUPERUSER ? 'selected' : '').'>'
                .___('Superuser').'</option>';

            if ($_SESSION['SID_user']['admin']>=ROLE_ADMIN) { 
                echo '<option value="'.ROLE_ADMIN.'" '
                    .($_POST['admin']==ROLE_ADMIN ? 'selected' : '').'>'
                    .___('Admin').'</option>';
            } 
            echo '</select>';
            echo help('users-workonusers.html#users-workonusers-editusersettings-role'); 
            echo '</td></tr>';
        }
        echo '<tr><td class="leftrow">'.___('Language:').'</td>';
        echo '<td class="rightrow">';
        echo '<select name="user_language" size="1">';
        $d = $translator->findTranslations();

        foreach ($d as $v) {
            echo '<option value="'.$v.'"';
            if ($_POST['user_language']==$v) echo " selected";
            echo ">".htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15')."</option>\n";
        }
        echo '</select>';
        echo help('users-workonusers.html#users-workonusers-editusersettings-language');
        echo '</td></tr>';
        echo '<tr><td class="leftrow">'.___('Initials:').'</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" name="edit_initial" value="'.htmlspecialchars($_POST['edit_initial'], ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255" />';
        echo help('users-workonusers.html#users-workonusers-editusersettings-initials');
        echo '</td></tr>';
        echo '<tr><td class="leftrow">'.___('E-mail:').'</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" name="edit_email" value="'.htmlspecialchars($_POST['edit_email'], ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255" />';
        echo help('users-workonusers.html#users-workonusers-editusersettings-email');
        echo '</td></tr>';
        echo '<tr><td class="leftrow">'.___('Password:').'</td>';
        echo '<td class="rightrow">';
        echo '<input type="hidden" name="passwdold" value="'.htmlspecialchars(substr($_POST['passwdold'], 0, 16), ENT_COMPAT, 'ISO-8859-15').'" />';
        echo '<input type="password" name="passwd" value="'.htmlspecialchars(substr($_POST['passwd'], 0, 16), ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255" />';
        echo '</td></tr>';

        echo '<tr><td class="leftrow">'.___('Password confirmation:').'</td>';
        echo '<td>';
        echo '<input type="password" name="passwd2" value="'.htmlspecialchars(substr($_POST['passwd2'], 0, 16), ENT_COMPAT, 'ISO-8859-15').'" class="inputwidth" maxlength="255" />';
        echo help('users-workonusers.html#users-workonusers-editusersettings-password');
        echo '</td></tr>';

        echo '<tr><td class="leftrow">&nbsp;</td>';
        echo '<td class="rightrow">';
        echo '<input type="submit" class="button" value="'.___('save').'" />';
        echo '</td></tr>';

        echo '</tbody></table>';
        echo '</form>';
        break; // }}}
    case 'rights': // {{{
        break; //}}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Deactivate User'),
            sprintf(___('In this view you can deactivate the user %s.'),
                '<em>'.htmlspecialchars(formatUsername($_GET['id'], $user, $name, $email), ENT_COMPAT, 'ISO-8859-15').'</em>'
            ),
            'users-workonusers.html#users-workonusers-deleteuser'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to deactivate the user %s?'),
            '<em>'.htmlspecialchars(formatUsername($_GET['id'], $user, $name, $email), ENT_COMPAT, 'ISO-8859-15').'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('users_delete_really');
        $message .= '<input type="hidden" name="id" value="'.htmlspecialchars($_GET['id'], ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="email" value="'.htmlspecialchars($email, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="user" value="'.htmlspecialchars($user, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="hidden" name="name" value="'.htmlspecialchars($name, ENT_COMPAT, 'ISO-8859-15').'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, deactivate').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not deactivate').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    }
}

include_once(CPO_BASEDIR.'_include/footer.php');