<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// set some PHP defaults that break CPOs behaviour
@ini_set('error_reporting', 
        E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | 
        E_CORE_WARNING | E_COMPILE_ERROR | E_COMPILE_WARNING | 
        E_USER_ERROR | E_USER_WARNING | E_USER_NOTICE);
// 2012-11-15, Balu: removed because it got deprecated in PHP 5.4
// @ini_set('magic_quotes_runtime', false);
// @ini_set('magic_quotes_sybase', false);

define('CPO_BASEDIR', realpath(dirname(__FILE__).'/../').'/');

// make sure that $directory can not be set externally
$directory = basename(dirname($_SERVER['PHP_SELF']));

// ctracker worm protection 
if (file_exists(CPO_BASEDIR.'_include/ctracker.php')) require_once(CPO_BASEDIR.'_include/ctracker.php'); 

// load common functions
require_once(CPO_BASEDIR.'_include/constants.inc.php');
require_once(CPO_BASEDIR.'_include/function.php');
require_once(CPO_BASEDIR.'_include/printnavigation.inc.php');

// load local configuration file
if (file_exists(CPO_BASEDIR.'_cfg/common-local.inc.php') && 
    is_readable(CPO_BASEDIR.'_cfg/common-local.inc.php'))
    require_once(CPO_BASEDIR.'_cfg/common-local.inc.php');

// FIXME This should be done as a workaround only until the transition to superglobals got finished
// Note: this only imports GET, POST and COOKIE variables, not SERVER, FILES, ENV, or SESSION!
// 2012-11-15, Balu: import_request_variables() got removed in PHP 5.4
//                   extract() is a possible replacement, but since it is just 
//                   as insecure, it is disabled
// @import_request_variables('cgp'); // CGP to avoid problems with cookies from other pages
// @extract($_COOKIE); @extract($_GET); @extract($_POST); 

/* // This bekame obsolete with PHP 5.4 where PHP no longer adds slashes to request parameters 

// strip magic quotes from Superglobals...
//if ((bool) get_magic_quotes_GPC()) { // by "php Pest"
    // Really EGPCSR - Environment $_ENV, GET $_GET , POST $_POST, Cookie $_COOKIE, Server $_SERVER
    // and their HTTP_*_VARS cousins (separate arrays, not references) and $_REQUEST
    $fnStripMagicQuotes = function($mData, $fnSelf) { 
        if (is_array($mData)) { 
            foreach ($mData as $mKey=>$mValue) $fnSelf($mData[$mKey], $fnSelf); return; 
        }
        $mData = stripslashes($mData);
    };
    $fnStripMagicQuotes($_POST, $fnStripMagicQuotes); // do each set of EGPCSR as you find necessary
    $fnStripMagicQuotes($_GET, $fnStripMagicQuotes); 
    $fnStripMagicQuotes($_REQUEST, $fnStripMagicQuotes); 
//} 
*/
//print_r($_POST);

// some variables 
initVar($CPO, array(
    'skin' => 'conpresso', 
    'version' => '4.1.6+4.0c "Wild Horses" Beta 1',
)); 

// initialize debugging variables
initVar($CPOVARS, array());
initVar($CPODEBUG, 0);
initVar($CPODEBUGLOG, array());
initVar($CPODEBUGQUERYCOUNT, 0);
list($usec, $sec) = explode(' ', microtime());
initVar($CPODEBUGRUNNINGSTART, (float)$usec + (float)$sec);

// prevent resetting debug and other values
$keepGlobalVars = array(
    'CPOVARS',
    'CPODEBUG',
    'CPODEBUGLOG',
    'CPODEBUGQUERYCOUNT',
    'CPODEBUGRUNNINGSTART'
);


// old mechanism
initVar($varDEBUG, 0); // 0 = kein DEBUG, 1 = std. DEBUG , 4 = alle DEBUG

initVar($tagsPreg, '/<!--\s*(file|html|image|text|url|value)\s*:\s*([^;]*?)\s*(;\s*(.*?)\s*)?-->/si'); // FIXME replace this with the stuff in $hdl_parser_*
initVar($typeNames, array('', 'file', 'html', 'image', 'text', 'url', 'value', 'divider', 'submitbutton'));

initVar($NextSpan, 2);       // show $NextSpan neighbour pages 
initVar($NextSpan10, true);    // show every 10th page
initVar($NextSpanSpace, ' ... '); // placeholder for not shown pages

initVar($notimeout, false);

initVar($pagetype, 'index');

initVar($navigationIndentFactor, 1.5);

// standard-handler
initVar($hdlr_navigation, array('include: '.urlencode('_include/basic_navigation.inc.php')));

initVar($hdlr_parser_content, array(
    'file'  => array('include: '.urlencode('_include/parser_c_file.inc.php')),
    'html'  => array('include: '.urlencode('_include/parser_c_html.inc.php')),
    'image' => array('include: '.urlencode('_include/parser_c_image.inc.php')),
    'text'  => array('include: '.urlencode('_include/parser_c_text.inc.php')),
    'url'   => array('include: '.urlencode('_include/parser_c_url.inc.php')),
    'value' => array('include: '.urlencode('_include/parser_c_value.inc.php')),
));

initVar($hdlr_parser_replacement, array(
    'file'  => array('include: '.urlencode('_include/parser_r_file.inc.php')),
    'html'  => array('include: '.urlencode('_include/parser_r_html.inc.php')),
    'image' => array('include: '.urlencode('_include/parser_r_image.inc.php')),
    'text'  => array('include: '.urlencode('_include/parser_r_text.inc.php')),
    'url'   => array('include: '.urlencode('_include/parser_r_url.inc.php')),
    'value' => array('include: '.urlencode('_include/parser_r_value.inc.php')),
));

initVar($cpoRubricDefaults, array(
    'directory' => '_rubric',
    'name'      => '',
    'seclevel' => SECLEVEL_PUBLIC,
));

// don't initialize database settings, etc during setup
if (!defined('SETUP')) {
    require_once(CPO_BASEDIR.'_include/db_mysql.inc.php');
    if (!is_readable(CPO_BASEDIR.'_cfg/db.inc.php'))
        die('<html><head><meta http-equiv="refresh" content="0; URL=../_setup/index.php" /></head><body><p>ConPresso is not configured yet! Please run the setup or make sure '.CPO_BASEDIR.'_cfg/db.inc.php is readable.</p></body></html>');
    require_once(CPO_BASEDIR.'_cfg/db.inc.php');

    define('CPO_BLOCK',             $dbPrefix.'_block'); 
    define('CPO_CONTENT_FILES',     $dbPrefix.'_content_files'); 
    define('CPO_CONTENT_HTML',      $dbPrefix.'_content_html'); 
    define('CPO_CONTENT_IMAGES',    $dbPrefix.'_content_images'); 
    define('CPO_CONTENT_TEXT',      $dbPrefix.'_content_text'); 
    define('CPO_CONTENT_URLS',      $dbPrefix.'_content_urls'); 
    define('CPO_DATA',              $dbPrefix.'_data'); 
    define('CPO_LOG',               $dbPrefix.'_log'); 
    define('CPO_LOG_LOGIN',         $dbPrefix.'_log_login'); 
    define('CPO_MODULES',           $dbPrefix.'_modules'); 
    define('CPO_NAVTREE',           $dbPrefix.'_navtree'); 
    define('CPO_NEWS',              $dbPrefix.'_news'); 
    define('CPO_OPTION',            $dbPrefix.'_option'); 
    define('CPO_PAGETEMPLATES',     $dbPrefix.'_pagetemplates'); 
    define('CPO_PERMISSION',        $dbPrefix.'_permission'); 
    define('CPO_PLACEHOLDERS',      $dbPrefix.'_placeholders'); 
    define('CPO_RUBRIC',            $dbPrefix.'_rubric'); 
    define('CPO_RUBRIC_PERMISSION', $dbPrefix.'_rubric_permission'); 
    define('CPO_SESSIONS',          $dbPrefix.'_sessions'); 
    define('CPO_SNIPPET',           $dbPrefix.'_snippet'); 
    define('CPO_STATISTICS',        $dbPrefix.'_statistics'); 
    define('CPO_TEMPLATES',         $dbPrefix.'_templates'); 
    define('CPO_TPL_ASSIGNMENT',    $dbPrefix.'_tpl_assignment'); 
    define('CPO_USER',              $dbPrefix.'_user'); 
    define('CPO_USERGROUPS',        $dbPrefix.'_usergroups'); 

    // overwrite default settings with the ones from the database
    $db = new DB;
    $db->query('SELECT options FROM '.CPO_OPTION.' '
              ."WHERE type='system'");
    while ($db->next_record()) {
        $options = $db->v('options');
        $t_cpoSystem = unserialize($options);
        if (!is_array($t_cpoSystem)) break;

        initVar($cpoSystem, $t_cpoSystem);
    }
    // start session (use database handler?)
    CPOsession_start();    
    
    // yes, we do this globally :-s
    require_once(CPO_BASEDIR . '_include/anti_csrf.inc.php');
    $antiCSRF = new antiCSRF();
}

// set user-defined error_reporting
if (isset($cpoSystem['error_reporting']))  {
   @ini_set('error_reporting', (int)$cpoSystem['error_reporting'] );
}

$cpoSystemDefaults = array(
    'owner'           => '', 
    'lkey'            => '', 
    'project'         => 'ConPresso 4', 
    'release'         => false, 
    'system_email'    => '',  // FIXME I don't like these defaults
    'admin_email'     => '', 
    'timeout'         => 3*60*60, 
    'max_image'       => 2*1024*1024,
    'max_file'        => 2*1024*1024, 
    'language'        => 'deutsch', 
    'skin'            => 'conpresso',
    'base_url'        => '',
    'targets'         => '_self _blank _top',
    'send_pw'         => false,
    'help'            => true,
    'pagination'      => 'both',
    'noOfFiles'       => 5,
    'noOfArticles'    => 10,
    'noOfUploadFiles' => 5,
    'homepage'        => '_admin/index.php',
    'statistics'      => false,
    'sessionsInDB'    => true,
    'ipcheck'         => false,
    'startnews'       => true,
    'date_format'     => 'd.m.Y H:i', 
    'pagetemplate_index'       => 1,
    'pagetemplate_detail'       => 1,
    'standard_template'       => 1,
    'sorting'       => 'pub_datum DESC',
    'editorCSS'       => '',
    'CSSURL'          => '',
    'bodyId'          => '',
    'installed'       => time(), // actual date as default installation time
    'PATH_INFO'       => false,
    'logfiledays'     => 365,
    'nolocktables'    => false,
    'error_reporting'    => 2039,
    'classSelectorOnTop'    => false,
    'missingTranslations'    => 'no',
    'showFontSelectors'    => false,
    'relativeLinks'    => false,
    'showFullToolbar'    => false,
    'roleToolbar'    => 99,
);

initVar($cpoSystem, $cpoSystemDefaults);

// always use sensible defaults
if ($cpoSystem['timeout']<5*60)      $cpoSystem['timeout']         = 5*60; 
if ($cpoSystem['noOfFiles']<1)       $cpoSystem['noOfFiles']       = 1; 
if ($cpoSystem['noOfArticles']<1)    $cpoSystem['noOfArticles']    = 1; 
if ($cpoSystem['noOfUploadFiles']<1) $cpoSystem['noOfUploadFiles'] = 1; 
if ($cpoSystem['language']=='')      $cpoSystem['language']        = 'deutsch'; 

// language files
require_once(CPO_BASEDIR.'_include/translation.inc.php');

initVar($cpoRubricSettingsDefaults, array( // FIXME switch all to $cpoRubric?
    'title' => '',
    'sorting' => $cpoSystem['sorting'],
    //'newSorting' => array('sort_id DESC'),
    'newSorting' => array($cpoSystem['sorting']),
    'edit_index'    => false,
    'showArchive' => false,
    'showArchiveText' => __('Archive'),
    'disableRubric' => false,
    'disableRubricText' => '',
    'edit_author'   => false,
    'edit_email'    => false,
    'edit_initial'  => false,
    'standard_template' => $cpoSystem['standard_template'],
    'pagetemplate_index'       => $cpoSystem['pagetemplate_index'],
    'pagetemplate_detail'       => $cpoSystem['pagetemplate_detail'],
    'date_format' => $cpoSystem['date_format'],
    'articleSeparator' => '', 
    'noArticlesFound' => __('No articles found.'),
    'noOfArticles' => 10, 
    'language' => $cpoSystem['language'],
    'pager_showresults' => false,
    'pager_found' => '',
    'pager_results' => '',
    'pager_previous' => '',
    'pager_next' => '',
    'metaKeywords' => '',
    'metaDescription' => '',
));

// here's the place for early sanitation of GET, POST, REQUEST
// ***********************************************************
// 
// rubric -> allow all existing rubricnames and ids
// nr -> numeric integer
// pos -> numeric integer
// 
// 
// fetch all rubrics (needed in the parser to link to other rubrics, etc.)
if (!defined('SETUP')) { // not during setup!
    initVar($allowedRubrics, array());
    $query = 'SELECT id, name FROM '.CPO_RUBRIC.' ';
    $db->query($query);
    while ($db->next_record()) {
        $allowedRubrics[] = $db->v('id');
        $allowedRubrics[] = $db->v('name');
    }
    if (isset($_GET['rubric'])     && !in_array($_GET['rubric'],     $allowedRubrics)) unset ($_GET['rubric']) ;
    if (isset($_POST['rubric'])    && !in_array($_POST['rubric'],    $allowedRubrics)) unset ($_POST['rubric']) ;
    if (isset($_REQUEST['rubric']) && !in_array($_REQUEST['rubric'], $allowedRubrics)) unset ($_REQUEST['rubric']) ;
    // check for numerics
    $numerics = array('nr', 'pos');
    foreach ($numerics AS $numeric)  {
        if (isset($_GET[$numeric]))     $_GET[$numeric]     = (int)$_GET[$numeric];
        if (isset($_POST[$numeric]))    $_POST[$numeric]    = (int)$_POST[$numeric];
        if (isset($_REQUEST[$numeric])) $_REQUEST[$numeric] = (int)$_REQUEST[$numeric];
    }
}

if (!defined('SETUP')) {
    // load activated modules
    $GLOBALS['modules'] = array();
    $db->query('SELECT name, options FROM '.CPO_MODULES.' '
              .'WHERE status='.MODULE_ACTIVE.' ORDER BY id');
    $activeModules = array();
    while ($db->next_record()) {
        $options = unserialize($db->v('options'));
        if (!is_array($options)) continue;

        $activeModules[$db->v('name')] = $options;

        $moduleDirectory = $activeModules[$db->v('name')]['directory'];
        if (@is_readable(CPO_BASEDIR.$activeModules[$db->v('name')]['directory'].'/common-module.inc.php')) {
            include_once(CPO_BASEDIR.$activeModules[$db->v('name')]['directory'].'/common-module.inc.php');
            continue;
        }

        $message[] = sprintf(
            ___('Unable to load module %s. The module could be missing!'), 
            '<em>'.htmlspecialchars($db->v('name'), ENT_COMPAT, 'ISO-8859-15').'</em>'
        );
    }
}

// figure out and set base_url
$auto_base_url = 'http://';
if(isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS'])=='on') {
    $auto_base_url='https://';
}

/* deprecated, creates problems with IE when using protected directories
if(isset($_SERVER['PHP_AUTH_USER'])) {
    $auto_base_url .= $_SERVER['PHP_AUTH_USER'];
    if(isset($_SERVER['PHP_AUTH_PW'])) {
        $auto_base_url .= ':'.$_SERVER['PHP_AUTH_PW'];
    }
    $auto_base_url .= '@';
}
*/

$auto_base_url .= $_SERVER['HTTP_HOST'];

// 2012-11-15, Balu: Disabled since server port seems to be included in HTTP_HOST
//if($_SERVER['SERVER_PORT']!=80 && $_SERVER['SERVER_PORT']!=443) {
//    $auto_base_url .= ':'.$_SERVER['SERVER_PORT'];
//}

$DOCROOT = $_SERVER['DOCUMENT_ROOT'];
if (empty($DOCROOT)) {
    $DOCROOT = substr(
        str_replace(array('\\', '//'), '/', $_SERVER['PATH_TRANSLATED']), 
        0, 
        -(strlen($_SERVER['SCRIPT_NAME']))
    );
}

$auto_base_url .= substr(str_replace('\\', '/', __FILE__),  
                      strlen(str_replace('\\', '/', realpath($DOCROOT))), 
                      -strlen('_include/2common.inc.php'));

initVar($base_url, $cpoSystem['base_url']);
if (preg_match('=auto/?=i', $base_url) || empty($base_url)) {
    $base_url = $auto_base_url;
}

// load skin configuration file
if (isset($cpoSystem['skin'])) $CPO['skin'] = $cpoSystem['skin'];
if (substr($CPO['skin'], -1)!='/') $CPO['skin'] .= '/';
if (@file_exists(CPO_BASEDIR.'_skin/'.$CPO['skin'].'common-skin.php') && 
     is_readable(CPO_BASEDIR.'_skin/'.$CPO['skin'].'common-skin.php'))
    include_once(CPO_BASEDIR.'_skin/'.$CPO['skin'].'common-skin.php');

if (substr($base_url, -1)!='/') $base_url .= '/';
preg_match('=^.*://[^/]*/(.*)$=', $base_url, $matches);
define('BASE_REL', '/'.$matches[1]); // relative base url
define('BASE_ABS', $base_url);       // absulute base url
define('BASE_URL', $base_url);       // FIXME deprecate this

if (!defined('SETUP')) define('SKIN_URL', BASE_REL.'_skin/'.$CPO['skin']);
else define('SKIN_URL', '../_skin/'.$CPO['skin']); // if the auto detection for BASE_ does not work...

// force ISO
if (strtolower(ini_get('default_charset')) != 'iso-8859-1')
    header('Content-type: text/html; charset=ISO-8859-1'); 

// check if the setup was already done...
if (defined('SETUP') && file_exists(CPO_BASEDIR.'_cfg/db.inc.php') && !isset($showHelpInSpiteOfSetup)) {
    echo ___('Looks like the setup was finished already. '
           .'If you want to do the setup again, please delete the file _cfg/db.inc.php '
           .'(and remove the tables in the database).');
}

if (isset($_GET['nr'])) { // find some useful article data powered by Ahmet Kazdag ********
	$queryarticle = "SELECT html, nr FROM ".CPO_NEWS.", ".CPO_CONTENT_HTML." WHERE " 
		.CPO_NEWS.".nr=".CPO_CONTENT_HTML.".article_id " 
		."AND fieldname='Artikel-Text' " 
		."AND article_id=".(int)$_GET['nr']; 

	DEBUG(1, $queryarticle, __FILE__, __LINE__); 
	$dbarticle = new DB; 
	$dbarticle->query($queryarticle); 
	$dbarticle->next_record(); 
	$article_nummer = $dbarticle->v('nr');
	$article_data   = $dbarticle->v('html');
	$teaser         = strip_tags($article_data);
	$teaser         = substr($teaser, 0, 150);

	$querypic = "SELECT ".CPO_DATA.".id, image_id, article_id, datei, fieldname FROM ".CPO_DATA.", ".CPO_CONTENT_IMAGES." WHERE " 
		.CPO_DATA.".id=".CPO_CONTENT_IMAGES.".image_id "
		.'AND fieldname="Bild" ' 
		."AND article_id=".(int)$_GET['nr'];

	DEBUG(1, $querypic, __FILE__, __LINE__); 
	$dbpic = new DB; 
	$dbpic->query($querypic); 
	$dbpic->next_record(); 
	$article_nummer = $dbpic->v('article_id');
	$article_data   = $dbpic->v('datei');
	$article_pic    = $article_data;
}   // end useful article data powered by Ahmet Kazdag ************************************