<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

header('Content-Type: application/octet-stream');
header(sprintf('Content-Disposition: attachment; filename="%s"', $_POST['filename']));

$dbQ = new DB;
$dbT = new DB;

echo '<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>'."\r\n";
print ('<!-- ===================================================================='."\r\n");
print ('   ConPresso XML-export'."\r\n");
print ('========================================================================='."\r\n");
printf('   exported by %s on %s'."\r\n", htmlspecialchars(utf8_encode($_SESSION['SID_user']['name']), ENT_COMPAT, 'ISO-8859-15'), date('Y-m-d H:i:s'));
print ("\r\n");
printf('   Database: %s'."\r\n", htmlspecialchars(utf8_encode($dbQ->Database), ENT_COMPAT, 'ISO-8859-15'));
printf('       Host: %s'."\r\n", htmlspecialchars(utf8_encode($dbQ->Host), ENT_COMPAT, 'ISO-8859-15'));
printf('       User: %s'."\r\n", htmlspecialchars(utf8_encode($dbQ->User), ENT_COMPAT, 'ISO-8859-15'));

// set maximum execution time to allow the export of big databases
if (!(bool)ini_get('safe_mode')) {
    ini_set('max_execution_time', '0');
} else {
    print ("\r\n");
    print ('   NOTE: PHPs safe_mode is active, so I can not change the '."\r\n");
    print ('         max_execution_time. The script might not export all data'."\r\n");
    printf('         because the PHP interpreter breaks after %d seconds.'."\r\n", ini_get('max_execution_time'));
    print ('         (see http://php.net/set_time_limit for more info)'."\r\n");
    print ("\r\n");
}
print ('===================================================================== -->'."\r\n\r\n");

print ('<conpresso>'."\r\n");
printf('<version>%s</version>'."\r\n", utf8_encode($CPO['version']));
printf('<exporttimestamp>%s</exporttimestamp>'."\r\n", time());
printf('<prefix>%s</prefix>'."\r\n", htmlspecialchars(utf8_encode($dbPrefix), ENT_COMPAT, 'ISO-8859-15'));
print ('<data>'."\r\n");

$dbT->query('SHOW TABLES');
while ($dbT->next_record()) {
    $table = $dbT->record();
    $table = $table[0];

    // only export tables with actual prefix
    if (substr($table, 0, strlen($dbPrefix))!=$dbPrefix) continue;

    $skipTable = false;
    switch (substr($table, strlen($dbPrefix))) {
    case '_block':     $skipTable = true; break;
    case '_log':       $skipTable = true; break;
    case '_log_login': $skipTable = true; break;
    case '_sessions':  $skipTable = true; break;
    }
    if ($skipTable) continue;

    printf('<table name="%s">'."\r\n", htmlspecialchars(utf8_encode(substr($table, strlen($dbPrefix))), ENT_COMPAT, 'ISO-8859-15'));

    $dbQ->query('SHOW COLUMNS FROM '.$table);

    echo '<colgroup>'."\r\n";
    while ($dbQ->next_record_assoc()) {
        $record = $dbQ->record();
        printf('<col type="%s">%s</col>'."\r\n", utf8_encode($record['Type']), utf8_encode($record['Field']));
    }
    echo '</colgroup>'."\r\n";

    $query = "SELECT * FROM ".$table;
    $dbQ->query($query);
    while ($dbQ->next_record_assoc()) {
        $record = $dbQ->record();
        echo '<tr>'."\r\n";
        foreach($record as $key=>$value) {
            if (strstr($value, "\n")!==false || strstr($value, "\r")!==false) {
                // contains newlines
                echo '<td encoding="base64">'."\r\n";
                echo htmlspecialchars(chunk_split(base64_encode(utf8_encode($value))), ENT_COMPAT, 'ISO-8859-15');
                echo '</td>'."\r\n";
            } else {
                printf('<td>%s</td>'."\r\n", htmlspecialchars(utf8_encode($value), ENT_COMPAT, 'ISO-8859-15'));
            }
        }
        echo '</tr>'."\r\n";
    }
    echo '</table>'."\r\n";
}
print('</data>'."\r\n");
print('</conpresso>'."\r\n");
?>
