<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
// if $freigabe==-1 the "published image" will not get displayed

if (function_exists('mini_title')) return;
function mini_title($freigabe='', $pub_datum='', $verfallsdatum='', $titel='', $autor='', $changer='', $nr='', $last_modify='')
{
    global $cpoSystem;
    $query = "SELECT COUNT(*) FROM ".CPO_NEWS." "
            ."WHERE article_nr='".addslashes($nr)."' "
            ."AND artikel_archiv='1'";
    DEBUG(1, 'Is there an older released version?<br /><br />'.$query, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query);
    $db_2->next_record();
    $released = ($freigabe==STATE_RELEASED && (time()>=strtotime($pub_datum) && time()<strtotime($verfallsdatum))); 

    if ($db_2->v('COUNT(*)')>0) $released = true;

    $shortTitle = substr($titel, 0, 65);
    if (strlen($titel)>65) $shortTitle .= '...';

    print('<span style="vertical-align: top">');

    if ($released) {
        printf('<img src="%1$s" alt="%2$s" title="%2$s" style="width: 13px; height: 13px; vertical-align: text-bottom;">&nbsp;', 
            SKIN_URL.'sym_published.gif',
            ___('article published'));
    } else {
        if ($freigabe!=-1) {
            printf('<img src="%1$s" alt="%2$s" title="%2$s" style="width: 13px; height: 13px; vertical-align: text-bottom;">&nbsp;', 
                SKIN_URL.'sym_not-published.gif',
                ___('article not published'));
        }
    }

    if(file_exists(CPO_BASEDIR.'_admin/show_article.php'))  {
        // show_article ****************************************************************
        printf('<!-- %d --><strong><a href="%s" target="showarticle">%s</a></strong>', 
            $nr, 
            BASE_REL.'_admin/show_article.php?rubric='.$_SESSION['SID_rubric_id'].'&nr='.$nr, 
            empty($titel) ? '<em>'.__('no title').'</em>' : '<span title="'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'">'.$shortTitle.'</span>' 
        );
        // show_article ****************************************************************
    } else {
        printf('<!-- %d --><strong>%s</strong>',
            $nr,
            empty($titel) ? '<em>'.__('no title').'</em>' : '<span title="'.htmlspecialchars($titel, ENT_COMPAT, 'ISO-8859-15').'">'.$shortTitle.'</span>'
        );
    }
    print('</span>');
    print('<img src="'.BASE_REL.'_images/transparent.gif" style="width: 1px; height: 21px;" alt="">');

    if (!empty($autor)) {
        echo '<div>'.__('Author:').' '.$autor.'</div>';
    }

    echo '<div style="clear: both;" title="'.date($cpoSystem['date_format'], strtotime($last_modify)).'">'.__('Last modified by:').' ';

    if (empty($last_modify)) echo '- ';
    else {
        $query = "SELECT name FROM ".CPO_USER." "
                ."WHERE user='".addslashes($changer)."'";
        DEBUG(2, 'Who did the last modification.<br /><br />'.$query, __FILE__, __LINE__);
        $db2 = new db;
        $db2->query($query);
        if ($db2->num_rows()<=0) echo '- '.$changer;
        else {
            $db2->next_record();
            $db2->p('name');
            echo ' ['.$changer.']';
        }
    }
    echo '</div>';
}
?>
