<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

function sessionDB_open($save_path, $session_name) 
{ 
    // Workaround for Debian systems with disabled GC 
    if (ini_get('session.gc_probability')==0 && rand(1, ini_get('session.gc_divisor'))<=1) 
        sessionDB_gc(ini_get('session.gc_maxlifetime')); 
    return true; 
}

function sessionDB_close()
{
    return true;
}

function sessionDB_read($id)
{
    $query = sprintf("SELECT data FROM %s_sessions WHERE sessid='%s'", 
        $GLOBALS['dbPrefix'], 
        $id
    );
    $db = new DB;
    $db->query($query);

    if($db->num_rows()==1) {
        $db->next_record();
        return $db->v('data');
    } 

    return ""; // Must return "" here.
}

function sessionDB_write($id, $data)
{
    $query = sprintf("REPLACE INTO %s_sessions SET sessid='%s', data='%s', lastupdated=NOW()", 
        $GLOBALS['dbPrefix'], 
        addslashes($id),
        addslashes($data)
    );
    $db = new DB;
    $db->query($query);
        
    return true;
}

function sessionDB_destroy($id)
{
    $query = sprintf("DELETE FROM %s_sessions WHERE sessid='%s'", $GLOBALS['dbPrefix'], addslashes($id));
    $db = new DB;
    $db->query($query);

    return true;
}

function sessionDB_gc($maxtime)
{
    if (2*$GLOBALS['cpoSystem']['timeout'] > $maxtime) 
        $maxtime = 2*$GLOBALS['cpoSystem']['timeout'];

    $query = sprintf("DELETE FROM %s_sessions WHERE UNIX_TIMESTAMP(NOW())-UNIX_TIMESTAMP(lastupdated) > %s",
        $GLOBALS['dbPrefix'],
        addslashes($maxtime)
    );
    $db = new DB;
    $db->query($query);
    //logaction('session garbage collection', $db->affected_rows());
    return true;
}
