<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

$q_format= "format='1'";
$pager = 'files';
if ($show_only_images) {
    $q_format = "format='2'";
    $pager = 'images';
}

if (empty($_SESSION['SID_pagers'][$pager])) $_SESSION['SID_pagers'][$pager] = 0;
if (isset($_GET['pos'])) $_SESSION['SID_pagers'][$pager] = $_GET['pos'];

if (empty($_SESSION['SID_pagers']['filesPerPage'])) {
    $_SESSION['SID_pagers']['filesPerPage'] = $cpoSystem['noOfFiles'];
}

// by default the filter is off
if (!isset($_SESSION['filter_files'])) $_SESSION['filter_files']['enabled'] = false;

switch ($_REQUEST['action']) {
case 'togglefilter':
    $_SESSION['filter_files']['enabled'] = !$_SESSION['filter_files']['enabled'];
    break;
case 'setfilter':
    if (!$antiCSRF->checkToken()) {
        // no message, because it's not displayed anyway.
        // $message[] = ___('Security check failed. Please try again.');
        logaction('tab_files setfilter', 'CSRF check failed.');
        // no blocking either as user is not informed and security implications are low
        // break
    }
    $_SESSION['SID_pagers'][$pager] = 0;

    if (isset($_POST['templates'])) $_SESSION['filter_files']['templates'] = true;
    else $_SESSION['filter_files']['templates'] = false;

    if (isset($_POST['all'])) $_SESSION['filter_files']['all'] = true;
    else $_SESSION['filter_files']['all'] = false;

    if (isset($_POST['active'])) $_SESSION['filter_files']['active'] = true;
    else $_SESSION['filter_files']['active'] = false;

    $_SESSION['filter_files']['phrase'] = $_POST['phrase'];
    break;
case 'setPerPage':
    if (!$antiCSRF->checkToken()) {
        $message[] = ___('Security check failed. Please try again.');
        logaction('articles setPerPage', 'CSRF check failed.');
        break;
    }
    
    if ($_SESSION['SID_pagers']['filesPerPage']!=$_REQUEST['newPerPage'])
        $_SESSION['SID_pagers']['files'] = 0;
    $_SESSION['SID_pagers']['filesPerPage'] = $_REQUEST['newPerPage'];
    break;
}

if (!$_SESSION['filter_files']['enabled']) {
    $_SESSION['filter_files']['templates'] = false;
    $_SESSION['filter_files']['all'] = false;
    $_SESSION['filter_files']['active'] = false;
    $_SESSION['filter_files']['phrase'] = '';
}

$q_rubric = '0 ';
if ($_SESSION['filter_files']['templates'])
    $q_rubric .= " OR rubric_id='-2'";
if ($_SESSION['filter_files']['all'])
    $q_rubric .= " OR rubric_id='-1'";
if ($_SESSION['filter_files']['active'])
    $q_rubric .= " OR rubric_id='".$_SESSION['SID_rubric_id']."'";
if (strlen($q_rubric)==2) $q_rubric = '1'; // only if still "0 "

// if the user has no rights to upload files into this rubric, only display general files 
if (!$_SESSION['SID_stufe3']) $q_rubric = '('.$q_rubric.') AND rubric_id<0';
if ($_SESSION['SID_user']['admin']<=ROLE_SUPERUSER) $q_rubric = '('.$q_rubric.') AND rubric_id>-2';

/* see on top of file
$q_format= "format='1'";
$pager = 'files';
if ($show_only_images) {
    $q_format = "format='2'";
    $pager = 'images';
}
*/

$q_phrase = '';
if ($_SESSION['filter_files']['phrase'])
    $q_phrase .= "AND (beschreibung LIKE '%".addslashes($_SESSION['filter_files']['phrase'])."%' "
                ."OR alttext LIKE '%".addslashes($_SESSION['filter_files']['phrase'])."%' "
                ."OR datei LIKE '%".addslashes($_SESSION['filter_files']['phrase'])."%')";

$q = "WHERE ".CPO_USER.".id=user_id "
    ."AND (".$q_rubric.") "
    ."AND (".$q_format.") "
    .$q_phrase;

$filesPerPage = $_SESSION['SID_pagers']['filesPerPage'];

$query  = "SELECT COUNT(*) FROM ".CPO_USER.", ".CPO_DATA." ".$q;
DEBUG(1, $query, __FILE__, __LINE__);
$db = new DB;
$db->query($query);
$db->next_record();
$max_data = $db->v('COUNT(*)');

if ($max_data<=$_SESSION['SID_pagers'][$pager]) $_SESSION['SID_pagers'][$pager] = $max_data-1;
if ($_SESSION['SID_pagers'][$pager]<0) $_SESSION['SID_pagers'][$pager] = 0;

$query = "SELECT ".CPO_DATA.".id, name, user, datei, datum, rubric_id, beschreibung, alttext, TYPE, format "
        ."FROM ".CPO_USER.", ".CPO_DATA." ".$q
        ."ORDER BY datei ";
if ($filesPerPage!='all') 
        $query .= "LIMIT ".$_SESSION['SID_pagers'][$pager].", ".$filesPerPage;

DEBUG(1, $query, __FILE__, __LINE__);
$db->query($query);

if (!$_SESSION['filter_files']['enabled']) {
    print('<table style="width: 100%;" class="colored filter"><thead>');
    print('<tr>');
    printf('<th><span><a href="%1$s">'
          .'<img src="'.SKIN_URL.'sym_filteron.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
          .'&nbsp;<a href="%1$s">%2$s</a>%3$s</span></th>', 
        $_SERVER['PHP_SELF'].'?action=togglefilter',
        ___('Enable filter'), 
        ($show_only_images 
            ? help('files-workonimage.html#files-workonimage-filter') 
            : help('files-workonfiles.html#files-workonfiles-filter'))
    );
    print('</tr></table>');
} else {
    print('<table style="width: 100%;" class="colored"><thead>');
    print('<tr>');
    printf('<th colspan="3"><span><a href="%1$s">'
          .'<img src="'.SKIN_URL.'sym_filteroff.gif" width="13" height="13" style="vertical-align: text-bottom;" alt="%2$s" title="%2$s" ></a>'
          .'&nbsp;<a href="%1$s">%2$s</a>%3$s</span></th>',
        $_SERVER['PHP_SELF'].'?action=togglefilter',
        ___('Disable filter'), 
        ($show_only_images 
            ? help('files-workonimage.html#files-workonimage-filter') 
            : help('files-workonfiles.html#files-workonfiles-filter'))
        );
    print('</tr></thead><tbody><tr>');

    print('<form method="post" action="'.$_SERVER["PHP_SELF"].' " name="newsentry">');
    print('<td class="leftrow">');
        print(__('Filter by availabilty:').'</td><td class="rightrow">');
        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            printf('<input class="checkbox" type="checkbox" name="%s" id="templates" value="1" %s><label for="templates"> %s</label>',
                'templates',
                ($_SESSION['filter_files']['templates'] ? 'checked' : ''),
                ___('useable for article-templates'));
        }
        printf('<br /><input class="checkbox" type="checkbox" name="%s" id="all" value="1" %s><label for="all"> %s</label>',
            'all',
            ($_SESSION['filter_files']['all'] ? 'checked' : ''),
            ___('useable in all rubrics'));
        if (!empty($_SESSION['SID_rubric_id']) && $_SESSION['SID_stufe3']) {
            printf('<br /><input class="checkbox" type="checkbox" name="%s" id="active" value="1" %s><label for="active"> %s</label>',
                'active',
                ($_SESSION['filter_files']['active'] ? 'checked' : ''),
                htmlspecialchars(sprintf(__('useable in rubric %s'), $_SESSION['SID_rubric_name']), ENT_COMPAT, 'ISO-8859-15')
            );
        }
        print(($show_only_images 
            ? help('files-workonimage.html#files-workonimage-filterbyusein') 
            : help('files-workonfiles.html#files-workonfiles-filterbyusein')));
    print('</td></tr><tr><td>');
        print(__('Filter by phrase:').'</td><td>');
        printf('<input type="text" name="%s" value="%s" class="inputwidth">%s', 
            'phrase',
            htmlspecialchars($_SESSION['filter_files']['phrase'], ENT_COMPAT, 'ISO-8859-15'), 
            ($show_only_images 
                ? help('files-workonimage.html#files-workonimage-filterbykeyword') 
                : help('files-workonfiles.html#files-workonfiles-filterbykeyword'))
        );
    print('</td></tr><td>&nbsp;</td><td>');
        $antiCSRF->printInput('setfilter');
        print('<input type="submit" class="button" value="'.___('Set filter parameters').'">');
    print('</td>');
    print('</form>');
    print('</tr></tbody></table>');
}

if ($db->num_rows()<=0){ 
    if ($show_only_images) {
        $message[] = __('No pictures found!');
    } else {
        $message[] = __('No files found!');
    }
    require(CPO_BASEDIR.'_include/message.php');
    return;
} 


if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='top')  {
    next_page($_SESSION['SID_pagers'][$pager], 
              $max_data, 
              $filesPerPage, 
              true, 
              '',
              '',
              array(),
              $cpoSystem['noOfFiles']);
    echo '<br />';
}

// start part 1 of 3 enhanced delete by m.roesel *********************************************** 
if(array_key_exists('EnhancedDelete', $activeModules) && isset($inc_tab_files[1])) include($inc_tab_files[1]);
// end part 1 of 3 enhanced delete by m.roesel ***********************************************


echo '<table class="ruler" style="width: 100%;"><thead>';
echo '<tr>';

printf('<th style="width: 40%%;"><span>%s</span></th>', 
    __('Filename/Description').($show_only_images 
        ? help('files-workonimage.html#files-workonimage-filename') 
        : help('files-workonfiles.html#files-workonfiles-filename'))
);
printf('<th style="width: 5%%;"><span>%s</span></th>', 
    __('Manage').($show_only_images 
        ? help('files-workonimage.html#files-workonimage-edit') 
        : help('files-workonfiles.html#files-workonfiles-edit'))
);
printf('<th style="width: 20%%;"><span>%s</span></th>', 
    __('Preview').($show_only_images 
        ? help('files-workonimage.html#files-workonimage-preview') 
        : help('files-workonfiles.html#files-workonfiles-preview'))
);
printf('<th style="width: 35%%;"><span>%s</span></th>', 
    __('Info').($show_only_images 
        ? help('files-workonimage.html#files-workonimage-info') 
        : help('files-workonfiles.html#files-workonfiles-info'))
);
echo '</tr></thead><tbody>';

while($db->next_record()) {
    echo '<tr>';

    $noSuchFile = false;
    if (!@is_readable(CPO_BASEDIR.'_data/'.$db->v('datei'))) {
        $noSuchFile = true;
    }

    // get image size
    $size = array(0, 0, 0, '');
    if (!$noSuchFile && $db->v('format')=='2') { // images
        $size=getimagesize(CPO_BASEDIR.'_data/'.$db->v('datei'));
    }

    // FIXME ADD CHECK IF IMAGE/FILE IS IN USE!

    print('<td>'.$db->v('datei').'<br />');

    $besch = strlen($db->v('beschreibung'))>300 ? substr($db->v('beschreibung'), 0, 300).'[...]' : $db->v('beschreibung');
    printf('<span title="%s">%s</span><br />',
        htmlspecialchars($db->v('beschreibung'), ENT_COMPAT, 'ISO-8859-15'),
        htmlspecialchars($besch, ENT_COMPAT, 'ISO-8859-15')
    );
    echo '</td>';

    // manage
    echo '<td>';
    printf('<a href="change_image.php?'
          .'id='.$db->v('id').'&amp;'
          .'">'
          .'<img src="'.SKIN_URL.'pic_edit.gif" class="pic" alt="%1$s" title="%1$s" />'
          .'</a>',
        $show_only_images ? ___('edit image') : ___('edit file')
    ); 
    // start part 2 of 3 enhanced delete by m.roesel *********************************************** 
    if(array_key_exists('EnhancedDelete', $activeModules) && isset($inc_tab_files[2])) {
        include($inc_tab_files[2]);
    } else {
        $q = addslashes(htmlspecialchars(sprintf(__('Do you really want to delete %s?'), $db->v('datei')), ENT_COMPAT, 'ISO-8859-15'));
        print('<a href="'.$_SERVER['PHP_SELF'].'?'
             .'action=del&'
             .'id='.htmlspecialchars($db->v('id'), ENT_COMPAT, 'ISO-8859-15').'&'
             .'file='.htmlspecialchars($db->v('datei'), ENT_COMPAT, 'ISO-8859-15')
             .'" onClick="return confirm(\''.$q.'\')">'
             .'<img src="'.SKIN_URL.'pic_del.gif" class="pic" '
                .'alt="'.  ($show_only_images ? ___('delete image') : ___('delete file')).'" '
                .'title="'.($show_only_images ? ___('delete image') : ___('delete file')).'" />'
             .'</a>');  
    }
    // end part 2 of 3 enhanced delete by m.roesel ***********************************************

    echo '</td>';

    // preview
    echo '<td>';
    switch ($db->v('format')) {
    case 1: // file
        if ($noSuchFile) print(__('The file does not exist!').'<br />');
        else 
            printf('<a href="../_data/%1$s" target="_blank">'.___('Preview file in new window').'.</a><br />',
                htmlspecialchars($db->v('datei'), ENT_COMPAT, 'ISO-8859-15')
            );
        break;
    case 2: // image
        if ($noSuchFile) {
            print(__('The file does not exist!').'<br />');
            break;
        }
        $img_width   = $size[0];
        $img_height  = $size[1];

        // calculate preview height/width
        $percent = (100/$img_width*150);
        if ((100/$img_height*100) < $percent)
            $percent = (100/$img_height*100);
        if (($img_width < 150) && ($img_height < 100))
            $percent = 100;
        $img_width  = $img_width*$percent/100;
        $img_height = $img_height*$percent/100;

        $img_width  = number_format($img_width,  0, ',' ,'.');
        $img_height = number_format($img_height, 0, ',' ,'.');
        
        printf('<a href="../_data/%1$s" target="_blank">'
//              .'<img  src="../_data/%1$s" width="%2$d" height="%3$d" alt="%4$s" title="%5$s"><br /></a>',
              .'<img  src="../_include/thumb.php?size=150&imagefile=../_data/%1$s" width="%2$d" height="%3$d" alt="%4$s" title="%5$s"><br /></a>',
            htmlspecialchars($db->v('datei'), ENT_COMPAT, 'ISO-8859-15'),
            $img_width,
            $img_height,
            htmlspecialchars($db->v('alttext'), ENT_COMPAT, 'ISO-8859-15'),
            htmlspecialchars($db->v('alttext'), ENT_COMPAT, 'ISO-8859-15')
        );

        break;
    }
    echo '</td>';

    // 
    print('<td>');
    printf('%s %s<br />',
        ___('uploaded:'),
        htmlspecialchars(date($cpoSystem['date_format'], strtotime($db->v('datum'))), ENT_COMPAT, 'ISO-8859-15')
    );
    printf('%s %s<br />',
        ___('by:'),
        htmlspecialchars($db->v('name').' ['.$db->v('user').']', ENT_COMPAT, 'ISO-8859-15')
    );
    if ($db->v('format')=='2') { // images
        printf('%s %s<br />',
            ___('dimensions:'),
            htmlspecialchars($size[0].'x'.$size[1].'px', ENT_COMPAT, 'ISO-8859-15')
        );
    }
    printf('%s %s<br />',
        ___('file type:'),
        htmlspecialchars($db->v('TYPE'), ENT_COMPAT, 'ISO-8859-15')
    );
    $_s = @filesize(CPO_BASEDIR.'_data/'.$db->v('datei'));
    if ($_s) {
        printf('%s %s<br />',
            ___('size:'),
            htmlspecialchars(printHumanReadable($_s), ENT_COMPAT, 'ISO-8859-15')
        );
    }

    if ($db->v('rubric_id')>=0) {
        $query = "SELECT name "
                ."FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($db->v('rubric_id'))."' ";
        DEBUG(1, $query, __FILE__, __LINE__);
        $db2 = new DB;
        $db2->query($query);
        $db2->next_record();

        printf('%s %s<br />',
            ___('available in:'),
            htmlspecialchars(sprintf(__('rubric %s'), $db2->v('name')), ENT_COMPAT, 'ISO-8859-15')
        );
    }
    if ($db->v('rubric_id')==-1) {
        printf('%s %s<br />',
            ___('available in:'),
            ___('all rubrics')
        );
    }
    if ($db->v('rubric_id')==-2) {
        printf('%s %s<br />',
            ___('available in:'),
            ___('article-templates')
        );
    }
    print('</td>');

    print('</tr>');
}
// start part 3 of 3 enhanced delete by m.roesel *********************************************** 
    if(array_key_exists('EnhancedDelete', $activeModules) && isset($inc_tab_files[3])) {
        include($inc_tab_files[3]);
    } else {
        echo '</tbody></table>';
    }
// end part 3 of 3 enhanced delete by m.roesel *********************************************** 


if($cpoSystem['pagination']=='both' || $cpoSystem['pagination']=='bottom')  {
    echo '<br />';
    next_page($_SESSION['SID_pagers'][$pager], 
              $max_data, 
              $filesPerPage, 
              true, 
              '',
              '',
              array(),
              $cpoSystem['noOfFiles']);
    echo '<br />';
}
