<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// getting article by title when nr is missing
if (!isset($_REQUEST['nr']) && isset($_REQUEST['title'])) { 
	initVar($cpoRubricId, 1);
	$query = "SELECT article_nr " 
		 ."FROM ".CPO_NEWS." " 
		 ."WHERE titel='".addslashes($_REQUEST['title'])."' " 
		 ."AND rubric_id=".$cpoRubricId." AND artikel_archiv=0"; 
	DEBUG(2, $query, __FILE__, __LINE__);    
	$dbget = new DB; 
	$dbget->query($query); 
	$dbget->next_record();
	//  set nr for further processing
	$_REQUEST['nr'] = $dbget->v('article_nr'); 
	$_GET['nr']     = $dbget->v('article_nr'); 
} 

if ($cpoRubricSettings['disableRubric']) {
    echo $cpoRubricSettings['disableRubricText'];
    return;
}

// make sure an article got chosen
if (!isset($_REQUEST['nr'])) {
    print('Sorry, no article specified.');
    return;
}

$auth_string = 1;
if ($cpoRubric['seclevel']>SECLEVEL_PUBLIC) {
    $auth_string = "auth=''";
    if ($_SESSION['SID_user']['usergroups_id']>0) {
        $auth_string .= " OR auth LIKE '%#".(int)$_SESSION['SID_user']['usergroups_id']."#%'";  
    }
}

if ($cpoSystem['statistics']) {
    $datum = date('Y-m-d H:i:s');
    $query  = 'UPDATE '.CPO_STATISTICS.' SET '
             .'detail_site = detail_site+1, '
             ."last_hit = '".$datum."', "
             ."c_time = '".$datum."' "
             .'WHERE rubric_id='.(int)$cpoRubric['id'];
    $db = new DB;
    $db->query($query);

    // if there was no entry updated, add an entry with a starting value of 1
    if ($db->affected_rows()==0) { 
        $query  = 'INSERT INTO '.CPO_STATISTICS.' (rubric_id, index_site, detail_site, archive_site, last_hit, c_time) '
                 .'VALUES ('
                 .(int)$cpoRubric['id'].', '
                 .'0, '
                 .'1, '
                 .'0, '
                 ."'".$datum."', "
                 ."'".$datum."')";
        $db->query($query);
    }
} // statistics end

$query = 'SELECT rubric_id, commentary, verfallsdatum, templates_id, nr, idx, email, autor, pub_datum, titel, initial, freigabe, changer, last_modify '
        .'FROM '.CPO_NEWS.' '
        .'WHERE nr='.(int)$_REQUEST['nr'].' '
        .'AND ('.$auth_string.') '
        .'AND rubric_id='.(int)$cpoRubric['id'].' '
        .'AND '.($articlestates = $cpoSystem['release']
            ? 'artikel_archiv<2 AND freigabe='.STATE_RELEASED.' '
            : 'artikel_archiv<1 AND freigabe!='.STATE_BLOCKED.' '
        );
$now = time();


$db = new DB;
$db->query($query);

// no article with that number found.
if ($db->num_rows()<=0) {
    echo $cpoRubricSettings['noArticlesFound'];
    return;
}

$GLOBALS['lastUpdated'] = 0;
$db->next_record();
$db_template      = $db->v('templates_id');
$db_nr            = $db->v('nr');
$db_idx           = $db->v('idx');
$db_email         = $db->v('email');
$db_autor         = $db->v('autor');
$db_changer       = $db->v('changer');
$db_pub_datum     = $db->v('pub_datum');
$db_verfallsdatum = $db->v('verfallsdatum');
$db_commentary    = $db->v('commentary');
$db_titel         = $db->v('titel');
$db_initial       = $db->v('initial');
$db_freigabe      = $db->v('freigabe');
$db_rubric_id     = $db->v('rubric_id');
$db_last_modify   = $db->v('last_modify');
if ($GLOBALS['lastUpdated']<strtotime($db_last_modify)) {
    $GLOBALS['lastUpdated'] = strtotime($db_last_modify);
}

require(CPO_BASEDIR.'_include/select_template.php');
