<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
define('SETUP', true);

if (!isset($_POST['language'])) $_POST['language'] = 'deutsch';

require_once('../_include/common.inc.php');


include(CPO_BASEDIR.'_include/header.php');
?>
<script type="text/javascript">
    parent.cpo_navigation.location.href = "../_admin/frame_navigation.php?s=0&l=<?php echo urlencode($_POST['language']); ?>";
</script>
<?php
printPageHeader(
    ___('Welcome'),
    sprintf(___('Welcome to the %s installation. This setup routine will guide you in three easy steps through the installation of the content management system %s.'),
        htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'),
        htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')
    ),
    'setup-setupcall.html#setup-welcome',
    false, '', $_POST['language']
);

// needs a translation... //FIXME
$message[] = 'Dies ist das Setup der <b>ConPresso<i>Plus</i> Community Edition '.$CPO['version'].'</b>. Dies ist keine offizielle ConPresso-Installation. Fr ConPresso<i>Plus</i> gibt es keinen offiziellen Support. Stattdessen enthlt diese Version inoffizielle Ergnzungen, Verbesserungen, Anpassungen und Workarounds, deren Einsatz sich im praktischen Einsatz als sinnvoll erwiesen haben. Dafr ist diese Version nicht unbedingt kompatibel zu Modulen, Codes und Forums-Posts, die sich auf die aktuelle und ltere Original ConPresso Installationen beziehen.';
$message[] = 'Wer das jetzt nicht versteht oder meint sich spter darber beschweren zu drfen hrt jetzt bitte auf und installiert eine Original-Version.';
include(CPO_BASEDIR.'_include/message.php');

$plusfile = '../_docs/CPOplus_english.txt';
if (file_exists('../_docs/CPOplus_'.$_POST['language'].'.txt')) $plusfile = '../_docs/CPOplus_'.$_POST['language'].'.txt';
echo '<iframe style="width: 90%; height: 200px;" src="'.htmlspecialchars($plusfile, ENT_COMPAT, 'ISO-8859-15').'"></iframe><br /><br />';


echo '<form method="post" action="step0.php">';
echo '<input type="hidden" name="s" value="0">';
$selectbox = '<select name="language" size="1">';
$tls = $translator->findTranslations();
$selectbox .= '<option value="english"'.($_POST['language']=='english' ? ' selected' : '').'>english</option>';
foreach ($tls as $v) {
    if ($v=='english') continue;
    $selectbox .= '<option value="'.htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15').'" '.($_POST['language']==$v ? ' selected' : '').'>';
    $selectbox .= htmlspecialchars($v, ENT_COMPAT, 'ISO-8859-15');
    $selectbox .= '</option>';
}
$selectbox .= '</select>';

echo ___('Please choose the system language that is also used during the installation routine:');
echo ' '.$selectbox.'&nbsp;';
echo '<input type="submit" class="button" value="'.___('choose').'">';
echo help('setup-setupcall.html#setup-welcome-language', false, '', $_POST['language']);
echo '</form>';

if (@file_exists(CPO_BASEDIR.'_cfg/db.inc.php')) {
    $message[] = sprintf(___('Setup was already run for this project. To start over delete the file %s and remove all related tables from the database.'), '<em>_cfg/db.inc.php</em>');
    include(CPO_BASEDIR.'_include/message.php');
    exit;
}

echo '<p>'.___('The following three steps will perform the needed tasks:').'</p>';
echo '<strong>'.___('Step 1: Check requirements').'</strong><br />';
echo ___('This check will test your server environment to make sure that all requirements are met. It will also test the transferred files and tell you about possible problems.').'<br /><br />';
echo '<strong>'.___('Step 2: Enter settings').'</strong><br />';
echo sprintf(___('In this step you will have to enter settings that %s needs to be installed. Those settings include information such as database login data and the basic system settings.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'<br /><br />';
echo '<strong>'.___('Step 3: Finish').'</strong><br />';
echo sprintf(___('This step will create all the necessary database tables and fill them with their initial values. After this the setup is ready and you can log in into your new installed %s.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'<br /><br /><br />';

$licensefile = '../_docs/LICENSE_english.txt';
if (file_exists('../_docs/LICENSE_'.$_POST['language'].'.txt')) $licensefile = '../_docs/LICENSE_'.$_POST['language'].'.txt';
echo '<iframe style="width: 90%; height: 200px;" src="'.htmlspecialchars($licensefile, ENT_COMPAT, 'ISO-8859-15').'"></iframe><br /><br />';

echo sprintf(__('The %s-license model differs between commercial and non-commercial use.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'));
echo ' ';
echo sprintf(__('To use the system in commercial environments you need to purchase a "license for commercial use" in the moment of project release. This license can be ordered on the %s Website%s.'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
echo ' ';
echo sprintf(___('If you are using %s non-commercially, you can register for free at this point in time on the %s Website%s.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');

echo '<br /><br />';
echo '<form method="post" action="step1.php">';
echo '<input type="hidden" name="s" value="1">';
echo '<input type="hidden" name="language" value="'.htmlspecialchars($_POST['language'], ENT_COMPAT, 'ISO-8859-15').'">';
echo ___('Accept license and ').' <input type="submit" class="button" value="'.___('start setup').'">';
echo '</form>';


echo '<br /><br />';
include(CPO_BASEDIR.'_include/footer.php'); 
?>
