<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

require(CPO_BASEDIR.'_include/header.php');

$title = ___('Rubrics');
if (isset($_GET['first'])) {
    $h = date('H', time()); 
    switch (true) {
    case 0<=$h && $h<=11: 
        $title = sprintf(___('Good morning, %s'), $_SESSION['SID_user']['name']);
        break;
    case 12<=$h && $h<=17: 
        $title = sprintf(___('Good afternoon, %s'), $_SESSION['SID_user']['name']);
        break;
    case 17<=$h && $h<=23: 
        $title = sprintf(___('Good evening, %s'), $_SESSION['SID_user']['name']);
        break;
    }

    if (!license($cpoSystem['lkey']) && $cpoSystem['installed']<(time()-90*24*60*60)) {
        $message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'),
            htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
        $message['license'] .= sprintf(___('This is a fully functional, but not registered version of %1$s. Please contact your %2$sadministrator%3$s.'),
            htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'),
            '<a href="mailto:'.htmlspecialchars($cpoSystem['admin_email'], ENT_COMPAT, 'ISO-8859-15').'">',
            '</a>'
        );

        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            $message['license'] = '<strong>'.sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')).'</strong> ';
            $message['license'] .= sprintf(__('The %s-license model differs between commercial and non-commercial use.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'));
            $message['license'] .= ' ';
            $message['license'] .= sprintf(__('To use the system in commercial environments you need to purchase a "license for commercial use" in the moment of project release. This license can be ordered on the %s Website%s.'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
            $message['license'] .= ' ';
            $message['license'] .= sprintf(___('If you are using %s non-commercially, you can register for free at this point in time on the %s Website%s.'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '<a href="'.$CPO['productlink'].'" target="_blank">'.htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15'), '</a>');
        }
    }
    
    if (isset($message['license'])) {
        printPageHeader(
            $title,
            '', // sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')),
            ''
        );
        $page = str_replace('<strong>' . sprintf(___('Your 90 days %s evaluation period has expired!'), htmlspecialchars($CPO['product'], ENT_COMPAT, 'ISO-8859-15')) . '</strong><br />', '', $message['license']);
        unset($message['license']);
        // include(CPO_BASEDIR.'_include/message.php');
        echo '<fieldset class="message" style="border-color: red;">';
        echo '<legend style="color: red;">' . ___('Message') . '</legend>';
        echo $page;
        echo '<br /><br />';
        echo '<a href="' . BASE_REL . '_admin/rubrics.php">' . ucfirst(___('list rubrics')) . ' &raquo;</a>';
        echo '</fieldset>';
        return;
    }
}

$sub = ___('In this view you can choose a rubric.');
if ($_SESSION['SID_user']['admin']==ROLE_ADMIN) {
    $sub .= ' '.___('As administrator you get rubrics listed even if you don\'t have the right to access them. This allows you to change their settings if necessary.');
}
printPageHeader(
    $title,
    $sub, 
    'rubrics-listrubrics.html#rubrics-listrubrics'
);
include(CPO_BASEDIR.'_include/message.php');

// fetch all rubrics this user has access to
$query = 'SELECT rubric_id ' 
        .'FROM '.CPO_PERMISSION.' '
        ."WHERE user_id='".addslashes($_SESSION['SID_user']['id'])."' ";
$db = new DB;
$db->query($query);
$rubricAccess = array();
while ($db->next_record()) $rubricAccess[$db->v('rubric_id')] = true;

// fetch all rubrics to show the ones not in navigation
$query = 'SELECT id, name, seclevel ' 
        .'FROM '.CPO_RUBRIC.' '
        .'ORDER BY name';
$db->query($query);
$notInNavigation = array();
while ($db->next_record()) {
    $notInNavigation[$db->v('id')] = array(
        'id'=>0,
        'l'=>0,
        'r'=>0,
        'level'=>1,
        'childs'=>0,
        'caption'=>'',
        'navigation'=>array(),
        'rubric'=>array('id'=>$db->v('id'), 'name'=>$db->v('name'), 'seclevel'=>$db->v('seclevel'), )
    );
}

$navigation = getNavigation();

$displayedNavigation = false;
if (count($navigation)>0) {
    $displayedNavigation = true;

    // show navigation
    print('<table class="ruler" style="width: 100%;">');
    print('<thead><tr>');
    print('<th style="width: 35%;"><span>'.___('Navigation').help('rubrics-listrubrics.html#rubrics-listrubrics-navigation').'</span></th>');
    print('<th style="width: 35%;"><span>'.___('Rubric/URL').help('rubrics-listrubrics.html#rubrics-listrubrics-rubricurl').'</span></th>');
    print('<th style="width: 10%;"><span>'.___('Manage').help('rubrics-listrubrics.html#rubrics-listrubrics-edit').'</span></th>');
    print('<th style="width: 10%;"><span>'.___('Published').help('rubrics-listrubrics.html#rubrics-listrubrics-published').'</span></th>');
    print('<th style="width: 10%;"><span>'.___('Total').help('rubrics-listrubrics.html#rubrics-listrubrics-total').'</span></th>');
    print('<th style="width: 10%;"><span>'.___('Info').help('rubrics-listrubrics.html#rubrics-listrubrics-info').'</span></th>');
    print('</tr></thead><tbody>');

    $skip = 1;
    foreach ($navigation as $k=>$v) {
        initVar($v['rubric']['id'], NULL); // in case of deleted rubric
        initVar($v['rubric']['seclevel'], NULL); // in case of deleted rubric
        if (array_key_exists($v['rubric']['id'], $notInNavigation)) unset($notInNavigation[$v['rubric']['id']]);

        if ($v['level']>$skip) continue;
        if (!array_key_exists($v['id'], $_SESSION['SID_navigation_opened'])) {
            $skip = $v['level'];
        } else $skip++;

        print('<tr>');

        // Navigation
        print('<td>');
        $m = ($v['level']-1)*$GLOBALS['navigationIndentFactor'];
        if ($v['childs']<=0) {
            printf('<img src="'.SKIN_URL.'nav_empty.gif" style="margin-left: %sem;">%s', $m, htmlspecialchars($v['caption'], ENT_COMPAT, 'ISO-8859-15'));
        } else if (array_key_exists($v['id'], $_SESSION['SID_navigation_opened'])) {
            printf('<a href="%s?action[]=close&amp;id=%d"><img src="%s" style="margin-left: %sem;">%s</a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars($v['id'], ENT_COMPAT, 'ISO-8859-15'), 
                SKIN_URL.'nav_close.gif',
                $m,
                htmlspecialchars($v['caption'], ENT_COMPAT, 'ISO-8859-15')
            );
        } else {
            printf('<a href="%s?action[]=open&amp;id=%d"><img src="%s" style="margin-left: %sem;">%s</a>', 
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15'),
                htmlspecialchars($v['id'], ENT_COMPAT, 'ISO-8859-15'), 
                SKIN_URL.'nav_open.gif',
                $m,
                htmlspecialchars($v['caption'], ENT_COMPAT, 'ISO-8859-15')
            );
        }
        echo '</td>';

        // Rubric
        $_t = '&nbsp;';
        if ($v['rubric']['id']>0) $_t = htmlspecialchars($v['rubric']['name'], ENT_COMPAT, 'ISO-8859-15');
        if (!empty($v['navigation']['externalURL'])) 
            $_t = sprintf('<span title="%s">[%s]</span>', 
                htmlspecialchars($v['navigation']['externalURL'], ENT_COMPAT, 'ISO-8859-15'),
                ___('URL')
            );

        if ($v['rubric']['id']<=0 || !array_key_exists($v['rubric']['id'], $rubricAccess)) {
            printf('<td>%s</td>', $_t);
        } else {
            printf('<td><a href="'.BASE_REL.'_admin/index.php?navigation=%d:%d" target="_top">%s</a></td>',
                $v['id'],
                $v['rubric']['id'],
                $_t
            );
        }

        echo '<td>';
        if ($v['rubric']['id']<=0) {
            echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
                .'style="background: url('.SKIN_URL.'pic_edit.gif);" '
                .'alt="'  .___('This is not a rubric.').'" '
                .'title="'.___('This is not a rubric.').'" />';

        } else if (!array_key_exists($v['rubric']['id'], $rubricAccess)) {
            echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
                .'style="background: url('.SKIN_URL.'pic_edit.gif);" '
                .'alt="'  .___('You have no rights to work on articles in this rubric.').'" '
                .'title="'.___('You have no rights to work on articles in this rubric.').'" />';
        } else {
            printf('<a href="'.BASE_REL.'_admin/index.php?navigation=%d:%d" target="_top">%s</a>',
                $v['id'],
                $v['rubric']['id'],
                '<img src="'.SKIN_URL.'pic_edit.gif" class="pic" '
                .'alt="'  .___('work on articles').'" '
                .'title="'.___('work on articles').'" />'
            );
        }


        // Manage
        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            if ($v['rubric']['id']<=0) {
                echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
                    .'style="background: url('.SKIN_URL.'pic_settings.gif);" '
                    .'alt="'  .___('This is not a rubric.').'" '
                    .'title="'.___('This is not a rubric.').'" />';
                echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
                    .'style="background: url('.SKIN_URL.'pic_rights.gif);" '
                    .'alt="'  .___('This is not a rubric.').'" '
                    .'title="'.___('This is not a rubric.').'" />';
                echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
                    .'style="background: url('.SKIN_URL.'pic_del.gif);" '
                    .'alt="'  .___('This is not a rubric.').'" '
                    .'title="'.___('This is not a rubric.').'" />';
            } else {
                printf('<a href="%s">'
                      .'<img src="'.SKIN_URL.'%s" alt="%s" title="%s" width="18" height="21">'
                      .'</a>',
                    htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15').'?action=rubrics_showsettings&amp;id='.htmlspecialchars($v['rubric']['id'], ENT_COMPAT, 'ISO-8859-15'),
                    'pic_settings.gif',
                    ___('edit rubric settings'),
                    ___('edit rubric settings')
                );
                printf('<a href="'.BASE_REL.'%s">'
                      .'<img src="'.SKIN_URL.'%s" alt="%s" title="%s" width="18" height="21">'
                      .'</a>',
                    '_admin/rubric_rights.php?rubric_id='.htmlspecialchars($v['rubric']['id'], ENT_COMPAT, 'ISO-8859-15'),
                    'pic_rights.gif',
                    ___('edit rubric rights'),
                    ___('edit rubric rights')
                );

                $query1 = "SELECT COUNT(*) FROM ".CPO_RUBRIC." "
                         ."WHERE source_rubric_id='".addslashes($v['rubric']['id'])."' ";
                DEBUG(2, $query1, __FILE__, __LINE__);
                $db_2 = new DB;
                $db_2->query($query1);
                $db_2->next_record();
                $tcount = $db_2->v('COUNT(*)');
                if ($db_2->v('COUNT(*)')>0) {
                    printIcon($_SERVER['PHP_SELF'].'?action[]=rubrics_delete&id='.$v['rubric']['id'], 
                        SKIN_URL.'pic_del.gif', 
                        ___('Other rubrics are using this as source for their settings, so this rubric can not be deleted.'), 
                        false
                    );
                } else {
                    printIcon($_SERVER['PHP_SELF'].'?action[]=rubrics_delete&id='.$v['rubric']['id'], 
                        SKIN_URL.'pic_del.gif', 
                        ___('delete rubric'), 
                        true
                    );
                } 
            } 
        }
        print('</td>');

        // Published
        $jetzt = date('Y-m-d H:i:s', time());
        $where = $cpoSystem['release'] ? "artikel_archiv<'1' AND freigabe!='2' " : "artikel_archiv<'2' AND freigabe='0' ";
        $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." "
                 ."WHERE ".$where." "
                 ."AND pub_datum<='".$jetzt."' "
                 ."AND verfallsdatum>='".$jetzt."' "
                 ."AND rubric_id='".addslashes($v['rubric']['id'])."' ";
        DEBUG(2, $query1, __FILE__, __LINE__);
        $db_2 = new DB;
        $db_2->query($query1);
        $db_2->next_record();

        $tcount = $db_2->v('COUNT(*)');
        if ($v['rubric']['id']<=0) $tcount = '-';
        
        print('<td style="text-align: center;">'.$tcount.'</td>');

        // Total
        $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." "
                 //."WHERE artikel_archiv<=1 "
                 ."WHERE nr=article_nr "
                 ."AND artikel_archiv!=9 "
                 ."AND rubric_id='".addslashes($v['rubric']['id'])."' ";
        DEBUG(2, $query1, __FILE__, __LINE__);
        $db_2 = new DB;
        $db_2->query($query1);
        $db_2->next_record();

        $tcount = $db_2->v('COUNT(*)');
        if ($v['rubric']['id']<=0) $tcount = '-';

        print('<td style="text-align: center;">'.$tcount.'</td>');

        // Info
        print('<td>');
        switch ($v['rubric']['seclevel']) {
        case SECLEVEL_PERSONALIZED:
            print('<img src="'.SKIN_URL.'lock2.gif" alt="'.___('personalized').'" title="'.___('personalized').'" width="13" height="13">');
            break;
        case SECLEVEL_CLOSED:
            print('<img src="'.SKIN_URL.'lock1.gif" alt="'.___('closed').'" title="'.___('closed').'" width="13" height="13">');
            break;
        }
        print('</td>');

        print('</tr>');
    }
    echo '</tbody></table>';

    if (count($notInNavigation)<=0) {
        require(CPO_BASEDIR.'_include/footer.php'); 
        return;
    }
}

// show rubrics not in navigation

// remove all rubrics not in navigation the user does not have access to 
if ($_SESSION['SID_user']['admin']<ROLE_ADMIN) {
    foreach ($notInNavigation as $k=>$v) {
        if (!array_key_exists($k, $rubricAccess)) unset($notInNavigation[$k]);
    }
}

// return if no rubrics are to be displayed
if (count($notInNavigation)<=0) {
    if (!$displayedNavigation) {
        if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
            $message[] = ___('Sorry no rubrics found to display to you.').' '.
                sprintf(___('You can %screate a new rubric%s.'),
                    '<a href="'.BASE_REL.'_admin/rubrics.php?action=rubrics_create">',
                    '</a>'
                );
        } else {
            $message[] = ___('Sorry no rubrics found to display to you.');
        }
    }
    include(CPO_BASEDIR.'_include/message.php');
    require(CPO_BASEDIR.'_include/footer.php'); 
    return;
}

print('<table class="ruler" style="margin-top: 1em; width: 100%;">');
print('<thead><tr>');
print('<th style="width: 70%;"><span>'.___('Rubrics without navigation assignment').help('rubrics-listrubrics.html#rubrics-listrubrics-notinnavigation').'</span></th>');
print('<th style="width: 10%;"><span>'.___('Manage').help('rubrics-listrubrics.html#rubrics-listrubrics-edit').'</span></th>');
print('<th style="width: 10%;"><span>'.___('Published').help('rubrics-listrubrics.html#rubrics-listrubrics-published').'</span></th>');
print('<th style="width: 10%;"><span>'.___('Total').help('rubrics-listrubrics.html#rubrics-listrubrics-total').'</span></th>');
print('<th style="width: 10%;"><span>'.___('Info').help('rubrics-listrubrics.html#rubrics-listrubrics-info').'</span></th>');

print('</tr></thead><tbody>');

foreach ($notInNavigation as $k=>$v) {
    print('<tr>');

    // Rubric
    print('<td>');
    if ($v['rubric']['id']>0 && array_key_exists($v['rubric']['id'], $rubricAccess)) {
        printf('<a href="'.BASE_REL.'_admin/index.php?navigation=0:%d" target="_top">%s</a> ',
            $v['rubric']['id'],
            htmlspecialchars($v['rubric']['name'], ENT_COMPAT, 'ISO-8859-15')
        );
    } else {
        printf('%s %s', 
            htmlspecialchars($v['caption'], ENT_COMPAT, 'ISO-8859-15'), 
            htmlspecialchars($v['rubric']['name'], ENT_COMPAT, 'ISO-8859-15')
        );
    }
    echo '</td>';

    print('<td>');
    if (!array_key_exists($v['rubric']['id'], $rubricAccess)) {
        echo '<img src="'.SKIN_URL.'pic_shade.gif" class="pic" '
            .'style="background: url('.SKIN_URL.'pic_edit.gif);" '
            .'alt="'  .___('You have no rights to work on articles in this rubric.').'" '
            .'title="'.___('You have no rights to work on articles in this rubric.').'" />';
    } else {
        printf('<a href="'.BASE_REL.'_admin/index.php?navigation=%d:%d" target="_top">%s</a>',
            $v['id'],
            $v['rubric']['id'],
            '<img src="'.SKIN_URL.'pic_edit.gif" class="pic" '
            .'alt="'  .___('work on articles').'" '
            .'title="'.___('work on articles').'" />'
        );
    }


    // Manage
    if ($_SESSION['SID_user']['admin']>=ROLE_SUPERUSER) {
        if ($v['rubric']['id']<=0) {
            print('<img src="'.SKIN_URL.'pic_empty.gif" class="pic" alt="" >');
        } else {
            printf('<a href="%s">'
                  .'<img src="'.SKIN_URL.'%s" alt="%s" title="%s" class="pic" border="0">'
                  .'</a>',
                htmlspecialchars($_SERVER['PHP_SELF'], ENT_COMPAT, 'ISO-8859-15').'?action=rubrics_showsettings&amp;id='.htmlspecialchars($v['rubric']['id'], ENT_COMPAT, 'ISO-8859-15'),
                'pic_settings.gif',
                ___('edit rubric settings'),
                ___('edit rubric settings')
            );
            printf('<a href="'.BASE_REL.'%s">'
                  .'<img src="'.SKIN_URL.'%s" alt="%s" title="%s" class="pic" >'
                  .'</a>',
                '_admin/rubric_rights.php?rubric_id='.htmlspecialchars($v['rubric']['id'], ENT_COMPAT, 'ISO-8859-15'),
                'pic_rights.gif',
                ___('edit rubric rights'),
                ___('edit rubric rights')
            );

            $query1 = "SELECT COUNT(*) FROM ".CPO_RUBRIC." "
                     ."WHERE source_rubric_id='".addslashes($v['rubric']['id'])."' ";
            DEBUG(2, $query1, __FILE__, __LINE__);
            $db_2 = new DB;
            $db_2->query($query1);
            $db_2->next_record();
            $tcount = $db_2->v('COUNT(*)');
            if ($db_2->v('COUNT(*)')>0) {
                printf('<img src="'.SKIN_URL.'pic_shade.gif" style="background: url('.SKIN_URL.'%s);" alt="%s" title="%s" class="pic">',
                    'pic_del.gif',
                    ___('Other rubrics are using this as source for their settings, so this rubric can not be deleted.'),
                    ___('Other rubrics are using this as source for their settings, so this rubric can not be deleted.')
                );
            } else {
                printf('<a href="%s">'
                      .'<img src="'.SKIN_URL.'%s" alt="%s" title="%s" class="pic" >'
                      .'</a>',
                    $_SERVER['PHP_SELF'].'?action[]=rubrics_delete&amp;id='.htmlspecialchars($v['rubric']['id'], ENT_COMPAT, 'ISO-8859-15'),
                    'pic_del.gif',
                    ___('delete rubric'),
                    ___('delete rubric')
                );
            } 
        } 
    }
    print('</td>');

    // Published
    $jetzt = date('Y-m-d H:i:s', time());
    $where = $cpoSystem['release'] ? "artikel_archiv<'1' AND freigabe!='2' " : "artikel_archiv<'2' AND freigabe='0' ";
    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." "
             ."WHERE ".$where." "
             ."AND pub_datum<='".$jetzt."' "
             ."AND verfallsdatum>='".$jetzt."' "
             ."AND rubric_id='".addslashes($v['rubric']['id'])."' ";
    DEBUG(2, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();

    $tcount = $db_2->v('COUNT(*)');
    if ($v['rubric']['id']<=0) $tcount = '-';
    
    print('<td style="text-align: center;">'.$tcount.'</td>');

    // Total
    $query1 = "SELECT COUNT(*) FROM ".CPO_NEWS." "
             //."WHERE artikel_archiv<=1 "
             ."WHERE nr=article_nr "
             ."AND artikel_archiv!=9 "
             ."AND rubric_id='".addslashes($v['rubric']['id'])."' ";
    DEBUG(2, $query1, __FILE__, __LINE__);
    $db_2 = new DB;
    $db_2->query($query1);
    $db_2->next_record();

    $tcount = $db_2->v('COUNT(*)');
    if ($v['rubric']['id']<=0) $tcount = '-';

    print('<td style="text-align: center;">'.$tcount.'</td>');

    // Info
    print('<td>');
    switch ($v['rubric']['seclevel']) {
    case SECLEVEL_PERSONALIZED:
        print ('<img src="'.SKIN_URL.'lock2.gif" alt="'.___('personalized').'" title="'.___('personalized').'" width="13" height="13" >');
        break;
    case SECLEVEL_CLOSED:
        print ('<img src="'.SKIN_URL.'lock1.gif" alt="'.___('closed').'" title="'.___('closed').'" width="13" height="13" >');
        break;
    }
    print('</td>');

    print('</tr>');
}
echo '</tbody></table>';

require(CPO_BASEDIR.'_include/footer.php'); 
?>
